unit oDBController;

interface

uses
  Classes, SysUtils, ODBConnection;

type
  TDBController = class(TObject)
  private
    FDBConnection: TDBConnection;
  public
    constructor Create(ADBConnection: TDBConnection);
    destructor Destroy; override;
    property DBConnection: TDBConnection read FDBConnection;
  end;

const
  XML_DATE         = 'YYYY-MM-DD';
  XML_DATETIME     = 'YYYY-MM-DD hh:mm:ss';
  XML_VERSION      = '<?xml version="1.0"?>';
  XML_STATUS_OK    = '<RESULT><STATUS>OK</STATUS></RESULT>';
  XML_STATUS_ERROR = '<RESULT><STATUS>ERROR</STATUS><DB_ENGINE_ERROR_MESSAGE>%s</DB_ENGINE_ERROR_MESSAGE></RESULT>';

implementation

{ TDBController }

constructor TDBController.Create(ADBConnection: TDBConnection);
begin
  inherited Create;
  FDBConnection := ADBConnection;
end;

destructor TDBController.Destroy;
begin
  FreeAndNil(FDBConnection);
  inherited;
end;

end.
