unit fMDK_AddOptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, StdCtrls, Buttons, CheckLst, ExtCtrls, FMDK_Options, System.Actions;

type
  TfrmAddOptions = class(TForm)
    Panel2: TPanel;
    ActionList1: TActionList;
    AcAssign: TAction;
    PnlAssign: TPanel;
    BbGet: TBitBtn;
    AcGetUserPreferences: TAction;
    Panel3: TPanel;
    AcClearAll: TAction;
    AcSelectAll: TAction;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BbAssign: TBitBtn;
    GroupBox1: TGroupBox;
    ClbOptions: TCheckListBox;
    PnlTopComment: TPanel;
    Memo1: TMemo;
    MmComments: TMemo;
    BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;
    Bevel1: TBevel;
    procedure AcAssignExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AcGetUserPreferencesExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure AcClearAllExecute(Sender: TObject);
    procedure AcSelectAllExecute(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure ClbOptionsClick(Sender: TObject);
    procedure PnlAssignDblClick(Sender: TObject);
  private
    { Private declarations }
    procedure SetValueList(AStringList: TStringList);
    procedure SaveOptions(AUserDUZ, AUserName: string);
  public
    { Public declarations }
  end;

var
  FrmAddOptions: TfrmAddOptions;

procedure AddOptions(AnAssign: Boolean = False; AnOptionView: TfrmMDK_Options = nil);

implementation

uses
  UMDK_Options, FMDK_SelectProvider, UMDK_Engine, UROR_CommonUtils, System.UITypes, UMDK_Common;

{$R *.dfm}

procedure AddOptions(AnAssign: Boolean = False; AnOptionView: TfrmMDK_Options = nil);
begin
  if not Assigned(FrmAddOptions) then Application.CreateForm(TfrmAddOptions, FrmAddOptions);
  with FrmAddOptions do begin
    BbGet.Visible := AnAssign;
    BbAssign.Visible := AnAssign;
    PnlAssign.Visible := AnAssign;
    SetValueList(UserOptions.ValueList);
    ClbOptionsClick(nil);
    ShowModal;
  end;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmAddOptions.FormCreate(Sender: TObject);
begin
{$IFDEF AANTEST}
  BbAssign.Visible := True;
{$ELSE}
  BbAssign.Visible := False;
{$ENDIF}
end;

procedure TfrmAddOptions.SetValueList(AStringList: TStringList);
var
  I: Integer;
  S: string;
  Uo: TUserOptions;
begin
  Uo := TUserOptions.Create;
  Uo.Values.Text := SysOptions.Values.Text;
  Uo.Update(UserOptions.Values.Text);
  ClbOptions.Items.Assign(Uo.ValueList);
  Uo.Free;
  I := 0;
  while I < ClbOptions.Items.Count do
  // for i := 0 to clbOptions.Items.Count - 1 do
  begin
    S := ClbOptions.Items.Names[I];
    if Trim(S) = '' then begin
      ClbOptions.Items.Delete(I);
    end else begin
      if (AStringList <> nil) and (AStringList.IndexOfName(S) >= 0) then ClbOptions.Checked[I] := True
      else ClbOptions.Checked[I] := False;
      Inc(I);
    end;
  end;
  if ClbOptions.Items.Count > 0 then ClbOptions.ItemIndex := 0;
end;

procedure TfrmAddOptions.AcAssignExecute(Sender: TObject);
var
  S: string;
begin
  S := SelectProvider('', Engine.FRenalController, 3);
  if S <> '' then SaveOptions(Piece(S, '^', 2), Piece(S, '^', 1));
end;

procedure TfrmAddOptions.SaveOptions(AUserDUZ, AUserName: string);
var
  S: string;
  I: Integer;
begin
  if AUserDUZ <> Engine.UserDUZ then begin
    if Dialogs.MessageDLG('You are about to update the preference list' + #13#10 + 'of the user <' + AUserName + '>' +
      #13#10#13#10 + 'Do you want to continue?', MtConfirmation, [MbYes, MbNo], 0) <> MrYes then Exit;
  end;
  S := '';
  for I := 0 to ClbOptions.Items.Count - 1 do begin
    if ClbOptions.Checked[I] then S := S + ClbOptions.Items[I] + #13#10;
  end;
  if Engine.FRenalController.SetUserOptionByDUZ(OnUserOptions, AUserDUZ, S) and (AUserDUZ = Engine.UserDUZ) then
      UserOptions.ValueList.Text := S;
end;

procedure TfrmAddOptions.AcGetUserPreferencesExecute(Sender: TObject);
var
  _UserDUZ, _UserName, S: string;
  Sl: TStringList;
begin
  S := SelectProvider('', Engine.FRenalController, 3);
  if S <> '' then begin
    _UserName := Piece(S, '^', 1);
    _UserDUZ := Piece(S, '^', 2);
    Engine.FRenalController.GetUserOptionByDUZ(OnUserOptions, _UserDUZ, S);
    if S <> '' then begin
      if Pos('-', S) = 1 then ShowMessage(Piece(S, '^', 2))
      else begin
        ClbOptions.Items.Clear;
        Sl := TStringList.Create;
        Sl.Text := S;
        if (Trim(S) = '') or (Pos('=', Sl[0]) = 0) then Sl.Delete(0);
        SetValueList(Sl);
        Sl.Free;
      end;
    end
    else SetValueList(nil);
  end;
end;

procedure TfrmAddOptions.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = Char(VK_ESCAPE) then ModalResult := MrCancel;
end;

procedure TfrmAddOptions.AcClearAllExecute(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to ClbOptions.Items.Count - 1 do ClbOptions.Checked[I] := False;
end;

procedure TfrmAddOptions.AcSelectAllExecute(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to ClbOptions.Items.Count - 1 do ClbOptions.Checked[I] := True;
end;

procedure TfrmAddOptions.BitBtn8Click(Sender: TObject);
begin
  SaveOptions(Engine.UserDUZ, Engine.CurrentOperatorID);
end;

procedure TfrmAddOptions.ClbOptionsClick(Sender: TObject);
var
  S, SOutput, SName, SValue: string;
  I: Integer;
begin
  I := ClbOptions.ItemIndex;
  SName := Piece(ClbOptions.Items[I], '=', 1);
  SValue := PreferenceComments.StringValue(SName);
  SOutput := '';
  for I := 1 to Length(SValue) do begin
    S := Copy(SValue, I, 1);
    if S = '^' then SOutput := SOutput + #13#10
    else SOutput := SOutput + S;
  end;
  MmComments.Lines.Text := SOutput;
  if MmComments.Lines.Count < 3 then MmComments.Lines.Text := #13#10 + MmComments.Lines.Text;
end;

procedure TfrmAddOptions.PnlAssignDblClick(Sender: TObject);
begin
  PnlTopComment.Visible := not PnlTopComment.Visible;
  MmComments.Visible := not MmComments.Visible;
end;

end.
