unit fMDK_Comments;
{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 2/22/08 3:41p $
  *       Site Name:    Hines OIFO
  *       Date Created: 12/15/06
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     Comments form
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI with Comments Update/APP-HEMODIALYSIS/Forms/fMDK_Comments.pas $
  *
  *       $ History: fMDK_Comments.pas $
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TfrmComment = class(TForm)
    Panel2: TPanel;
    Pnl: TPanel;
    BtnOK: TBitBtn;
    BitBtn3: TBitBtn;
    Panel3: TPanel;
    PnlTiuText: TPanel;
    GrbComments: TGroupBox;
    Panel4: TPanel;
    PnlSignature: TPanel;
    Label1: TLabel;
    EdtSignature: TEdit;
    Panel1: TPanel;
    MmNote: TMemo;
    PnlDetails: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Label5: TLabel;
    Edit2: TEdit;
    Label7: TLabel;
    Edit3: TEdit;
    Label8: TLabel;
    Edit4: TEdit;
    Label9: TLabel;
    Edit5: TEdit;
    Label10: TLabel;
    Edit6: TEdit;
    Label11: TLabel;
    Edit7: TEdit;
    Label12: TLabel;
    Edit8: TEdit;
    PnlCommentBy: TPanel;
    Label13: TLabel;
    Label14: TLabel;
    EdtAuthor: TEdit;
    EdtCommentOn: TEdit;
    BitBtn1: TBitBtn;
    CkbWW: TCheckBox;
    Lbl: TLabel;
    LblSize: TLabel;
    PnlTIUTemplate: TPanel;
    GrbTemplates: TGroupBox;
    LbTemplates: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure BtnOKClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure MmNoteChange(Sender: TObject);
    procedure CkbWWClick(Sender: TObject);
    procedure LbTemplatesClick(Sender: TObject);
  private
    { Private declarations }
    ICount: Integer;
  public
    { Public declarations }
  end;

var
  FrmComment: TfrmComment;

function AddComment(var AText: string): TModalResult;
function EditComment(var AText: string; Add: Boolean = False): TModalResult;
function Submit(AText: string; var ESig: string): TModalResult;
function ConfirmComment(var AText, AnAuthor, ADate: string; AReadOnly: Boolean = False): TModalResult;

implementation

uses
  UMDK_Engine, UMDK_Common, UMDK_Options, FMDK_SelectProvider, System.UITypes,
  UMDK_Notes, UMDK_ReportEngine, UMDK_Utils;

{$R *.dfm}

function EditComment(var AText: string; Add: Boolean = False): TModalResult;
var
  Dlg: TfrmComment;
begin
  dlg := TfrmComment.Create(nil);
  try
    with Dlg do begin
      EdtCommentOn.Text := FormatDateTime('mm/dd/yyyy hh:nn:ss', Now);
      EdtAuthor.Text := Engine.CurrentOperatorID;
      PnlSignature.Visible := Preferences.BValue(OnRequestSignatureForComments);
      try
        Dlg.ActiveControl := Dlg.MmNote;
      except
      end;
      if Add then MmNote.Text := ''
      else MmNote.Text := AText;
      MmNote.ReadOnly := False;
    end;
    Dlg.CkbWWClick(nil);
    Dlg.PnlTIUTemplate.Visible := Preferences.BValue(OnShowTIUNoteTemplates);
    Result := Dlg.ShowModal;
    if Result <> MrCancel then AText := Dlg.MmNote.Text;
  finally
    dlg.Free;
  end;
end;

function AddComment(var AText: string): TModalResult;
begin
  Result := EditComment(AText, True);
end;

function ConfirmComment(var AText, AnAuthor, ADate: string; AReadOnly: Boolean = False): TModalResult;
var
  Dlg: TfrmComment;
begin
  Application.CreateForm(TfrmComment, Dlg);
  with Dlg do begin
    MmNote.Text := AText;
    EdtCommentOn.Text := FormatDateTime('mm/dd/yyyy hh:nn:ss', Now);
    EdtCommentOn.ReadOnly := False;
    EdtAuthor.Text := Engine.CurrentOperatorID;
    // edtAuthor.ReadOnly := False;
    EdtAuthor.ReadOnly := True;
    PnlSignature.Visible := Preferences.BValue(OnRequestSignatureForComments);
    MmNote.ReadOnly := AReadOnly;
    ActiveControl := MmNote;
    Dlg.CkbWWClick(nil);
    Result := Dlg.ShowModal;
    AnAuthor := EdtAuthor.Text;
    ADate := EdtCommentOn.Text;
    AText := MmNote.Text;
  end;
  FreeAndNil(Dlg);
end;

function Submit(AText: string; var ESig: string): TModalResult;
var
  Dlg: TfrmComment;
begin
  Application.CreateForm(TfrmComment, Dlg);
  with Dlg do begin
    ICount := 0;
    BorderStyle := BsSizeable;
    Width := 640;
    BorderIcons := [BiSystemMenu, BiMaximize];
    PnlCommentBy.Visible := False;
    PnlDetails.Visible := False;
    Caption := 'Study Report Submitted by ' + Engine.CurrentOperatorID;
    PnlSignature.Visible := True;
    MmNote.Text := AText;
    MmNote.ReadOnly := True;
    MmNote.Color := EdtSignature.Color;
    ActiveControl := EdtSignature;
    BtnOK.Caption := 'Submit';
    GrbComments.Caption := 'Study Summary Report';
    PnlTIUTemplate.Visible := False;
    CkbWWClick(nil);
  end;
  Result := Dlg.ShowModal;
  ESig := Dlg.EdtSignature.Text;
  FreeAndNil(Dlg);
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmComment.FormCreate(Sender: TObject);
var
  Sl: TSTringList;
  I: Integer;
begin
  PnlTIUTemplate.Visible := Preferences.BValue(OnShowTIUNoteTemplates);
  if PnlTIUTemplate.Visible then begin
    Sl := TSTringList.Create;
    Sl.Text := Engine.GetSystemOptionByName(OnNoteTemplates);
    for I := 0 to Sl.Count - 1 do Sl[I] := Sl.Names[I];
    LbTemplates.Items.Text := Sl.Text;
    Sl.Free;
  end;
  MmNote.Text := '';
  EdtSignature.Text := '';
end;

procedure TfrmComment.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_Escape then ModalResult := MrCancel;
end;

procedure TfrmComment.BtnOKClick(Sender: TObject);
var
  ICount: Integer;
  CanClose: Boolean;
  SMSG: string;
begin
  SMSG := '';
  ICount := Engine.InvalidESigCount;
  if PnlSignature.Visible then begin
    CanClose := Engine.ValidateSignature(EdtSignature.Text);
    if not CanClose then begin
      SMSG := SMSG + 'Invalid signature.' + #13#10;
      Inc(ICount);
      if ICount > 2 then begin
        SMSG := 'Third attempt to provide value failed' + #13#10;
        MessageDlg('Input data contains errors:' + #13#10#13#10 + SMSG + 'Try again later...', MtWarning, [MbOK], 0);
        ModalResult := MrCancel;
        Engine.InvalidESigCount := ICount;
        Exit;
      end;
    end;
    ActiveControl := EdtSignature;
  end
  else CanClose := True;
  if BtnOK.Caption <> 'Submit' then begin
    if not IsValidDateString(EdtCommentOn.Text) then begin
      SMSG := SMSG + 'Invalid data value <' + EdtCommentOn.Text + '>' + #13#10;
      CanClose := False;
    end;
    if EdtAuthor.Text = '' then begin
      CanClose := False;
      SMSG := SMSG + 'Author name is not entered' + #13#10;
    end;
  end;
  if not CanClose then
      MessageDlg('Input data contains errors:' + #13#10#13#10 + SMSG + 'Provide valid value(s) and try again...',
      MtWarning, [MbOK], 0)
  else ModalResult := MrOK;
  Engine.InvalidESigCount := ICount;
end;

procedure TfrmComment.BitBtn1Click(Sender: TObject);
begin
  EdtAuthor.Text := SelectProvider('', Engine.FRenalController);
end;

procedure TfrmComment.MmNoteChange(Sender: TObject);
begin
  LblSize.Caption := IntToStr(Length(MmNote.Text));
  if (Length(MmNote.Text) > MAX_NOTE_SIZE) and (BtnOK.Caption <> 'Submit') then LblSize.Font.Color := ClRed
  else LblSize.Font.Color := ClWindowText;
end;

procedure TfrmComment.CkbWWClick(Sender: TObject);
begin
  MmNote.WordWrap := CkbWW.Checked;
  if MmNote.WordWrap then MmNote.ScrollBars := SsVertical
  else MmNote.ScrollBars := SsBoth;
end;

procedure TfrmComment.LbTemplatesClick(Sender: TObject);
var
  STemplateName: string;
begin
  if Sender = LbTemplates then
    try
      if LbTemplates.ItemIndex < 0 then MmNote.Text := ''
      else begin
        STemplateName := Engine.GetSystemOptionByName(LbTemplates.Items[LbTemplates.ItemIndex]);
        MmNote.Text := GetReportValue(STemplateName);
        ActiveControl := MmNote;
      end;
    except
      MmNote.Text := '';
    end;
end;

end.
