unit fMDK_DateRangeSelector;

{
  ================================================================================
  *
  *       Application:  Vitals
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
  *       Developer:    dddddddddomain.user@domain.ext
  *       Site:         Hines OIFO
  *
  *       Description:  Selects two date ranges.
  *
  *       Notes:        based on fGMV_DateRange.pas
  *
  ================================================================================
  *       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_DateRangeSelector.pas $
  *
  * $History: fMDK_DateRangeSelector.pas $
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/13/09    Time: 1:15p
  * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
  * Patch 19 source code
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/24/08    Time: 4:23p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/02/08    Time: 9:24a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 3  *****************
  * User: Zzzzzzandria Date: 6/20/07    Time: 3:23p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 6/04/07    Time: 9:08a
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 5/22/07    Time: 9:16a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 3/27/07    Time: 1:31p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:38p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:27p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP_HEMODIALYSIS/CP MODERNIZATION/APP-HemoDialysis/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/25/07    Time: 9:39a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/22/07    Time: 1:36p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/APP-HEMODIALYSIS/Forms
  * GUI 1.0.6.308 RC January 2007
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/22/07    Time: 1:28p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/CP MODERNIZATION/APP-HemoDialysis/Forms
  * GUI 1.0.6.308 RC January 2007
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/28/06    Time: 5:15p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
  *
  *
  ================================================================================
}

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  ExtCtrls;

type
  TfrmGMV_DateRange = class(TForm)
    Panel1: TPanel;
    Panel5: TPanel;
    GroupBox1: TGroupBox;
    LblFrom: TLabel;
    LblTo: TLabel;
    DtpFrom: TDateTimePicker;
    DtpTo: TDateTimePicker;
    Panel2: TPanel;
    BtnOK: TButton;
    BtnCancel: TButton;
    procedure BtnOKClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DtpFromEnter(Sender: TObject);
    procedure DtpFromExit(Sender: TObject);
    procedure DtpToExit(Sender: TObject);
    procedure DtpToEnter(Sender: TObject);
  private
  public
    { Public declarations }
  end;

implementation

uses
  System.UITypes;

const
  ClTabIn  = ClWindow;
  ClTabOut = ClInfoBk;

{$R *.DFM}

function GetDateRange(var FromDate, ToDate: TDateTime; AllowFutureDate: Boolean = True;
  AllowPastDate: Boolean = True): Boolean;
begin
  with TfrmGMV_DateRange.Create(Application) do
    try
      DtpFrom.DateTime := FromDate;
      DtpTo.DateTime := ToDate;
      DtpFrom.MaxDate := TRunc(Now);
      DtpTo.MaxDate := DtpFrom.MaxDate;
      ActiveControl := DtpFrom;
      ShowModal;
      if ModalResult = MrOK then begin
        FromDate := DtpFrom.Date;
        ToDate := DtpTo.Date;
        Result := True;
      end
      else Result := False;
    finally
      Free;
    end;
end;

procedure TfrmGMV_DateRange.BtnOKClick(Sender: TObject);
begin
  if TRunc(DtpFrom.DateTime) <= TRunc(DtpTo.DateTime) then ModalResult := MrOK
  else MessageDlg('The ''Start with Date'' must be less' + #13 + 'than the ''Go to Date'' value.', MtInformation,
      [Mbok], 0);
end;

procedure TfrmGMV_DateRange.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then ModalResult := MrCancel;
end;

procedure TfrmGMV_DateRange.DtpFromEnter(Sender: TObject);
begin
  DtpFrom.Color := ClTabIn;
end;

procedure TfrmGMV_DateRange.DtpFromExit(Sender: TObject);
begin
  DtpFrom.Color := ClTabOut;
end;

procedure TfrmGMV_DateRange.DtpToExit(Sender: TObject);
begin
  DtpTo.Color := ClTabOut;
end;

procedure TfrmGMV_DateRange.DtpToEnter(Sender: TObject);
begin
  DtpTo.Color := ClTabIn;
end;

end.
