unit fMDK_DateTimeSelector;

interface

uses
  Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, ActnList, Mask, System.Actions;

type
  TdlgDateTime = class(TForm)
    Panel1: TPanel;
    CancelBtn: TBitBtn;
    OKbtn: TBitBtn;
    Panel2: TPanel;
    McDate: TMonthCalendar;
    BitBtn1: TBitBtn;
    ActionList1: TActionList;
    AcNow: TAction;
    Label2: TLabel;
    MeDate: TMaskEdit;
    PnlTime: TPanel;
    Label1: TLabel;
    MeTime: TMaskEdit;
    PnlDate: TPanel;
    AcOK: TAction;
    procedure AcNowExecute(Sender: TObject);
    procedure McDateClick(Sender: TObject);
    procedure MeDateChange(Sender: TObject);
  private
    FIgnore: Boolean;
  public
    { Public declarations }
  end;

var
  DlgDateTime: TdlgDateTime;

function GetDateTime(ATitle, AFormat: string; var AValue: string): Integer;

implementation

uses
  UMDK_Engine, System.UITypes, Dialogs, UMDK_Utils;

{$R *.dfm}

function GetDateTime(ATitle, AFormat: string; var AValue: string): Integer;
var
  Dt: TDateTime;
begin
  Result := MrCancel;
  if not Assigned(DlgDateTime) then Application.CreateForm(TdlgDateTime, DlgDateTime);
  if not Assigned(DlgDateTime) then Exit;
  DlgDateTime.Height := 240;
  DlgDateTime.Caption := ATitle;
  try
    Dt := StrToDate(AValue);
    DlgDateTime.McDate.MaxDate := Trunc(Engine.GetCurrentServerDateTime);
    DlgDateTime.MeTime.Text := FormatDateTime('hh:nn', Dt);
    DlgDateTime.MeDate.Text := FormatDateTime('mm/dd/yyyy', Dt);
  except
    Dt := Engine.GetCurrentServerDateTime;
    DlgDateTime.McDate.MaxDate := Trunc(Dt);
    DlgDateTime.MeTime.Text := FormatDateTime('hh:nn', Dt);
    DlgDateTime.MeDate.Text := FormatDateTime('mm/dd/yyyy', Dt);
  end;
  Result := DlgDateTime.ShowModal;
  if Result = MrOK then begin
    Dt := StrToDateTime(DlgDateTime.MeTime.Text);
    AValue := FormatDateTime(AFormat, Trunc(DlgDateTime.McDate.Date) + Dt);
  end;
end;

procedure TdlgDateTime.AcNowExecute(Sender: TObject);
var
  Dt: TDateTime;
begin
  Dt := Engine.GetCurrentServerDateTime;
  McDate.Date := Dt;
  MeDate.Text := FormatDateTime('mm/dd/yyyy', Dt);
  MeTime.Text := FormatDateTime('hh:nn', Dt);
end;

procedure TdlgDateTime.McDateClick(Sender: TObject);
var
  B: Boolean;
begin
  B := FIgnore;
  FIgnore := True;
  MeDate.Text := FormatDateTime('mm/dd/yyyy', McDate.Date);
  FIgnore := B;
end;

procedure TdlgDateTime.MeDateChange(Sender: TObject);
var
  Dt: TDateTime;
  Y, M, D: Integer;
begin
  if FIgnore then Exit;
  FIgnore := True;
  try
    D := StrToInt(Piece(MeDate.Text, '/', 2));
    M := StrToInt(Piece(MeDate.Text, '/', 1));
    Y := StrToInt(Piece(MeDate.Text, '/', 3));
    Dt := EncodeDate(Y, M, D);
    if Dt > McDate.MaxDate then begin
      MessageDLG('Future dates are not available.', MtWarning, [MbOK], 0);
      McDate.Date := McDate.MaxDate;
      MeDate.Text := FormatDateTime('mm/dd/yyyy', McDate.Date);
    end else if Dt < 0 then MessageDLG('The selected date is too far in the past.', MtWarning, [MbOK], 0)
    else begin
      McDate.Date := Dt;
    end;
  except
  end;
  FIgnore := False;
end;

end.
