unit fMDK_FallAssessement;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 3/31/08 11:23a $
  *       Site Name:    Hines OIFO
  *       Date Created: 3/11/06
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     Falls assessement dialog
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms/fMDK_FallAssessement.pas $
  *
  *       $ History: fMDK_FallAssessement.pas $
}
interface

uses
  Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Dialogs;

type
  TFallAssessment = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    GroupBox1: TGroupBox;
    Panel4: TPanel;
    LbAge: TLabel;
    Label4: TLabel;
    Rb1: TRadioButton;
    Rb2: TRadioButton;
    Rb3: TRadioButton;
    Rb4: TRadioButton;
    CbEvaluation: TCheckBox;
    Cb2: TCheckBox;
    Cb5: TCheckBox;
    Cb6: TCheckBox;
    Cb3: TCheckBox;
    Cb4: TCheckBox;
    EdOther2: TEdit;
    Panel6: TPanel;
    Label7: TLabel;
    Cb21: TCheckBox;
    CbDevice: TCheckBox;
    Cb24: TCheckBox;
    Cb22: TCheckBox;
    Cb25: TCheckBox;
    Cb23: TCheckBox;
    Cb26: TCheckBox;
    EdOther1: TEdit;
    CbConsult: TCheckBox;
    CbHandout: TCheckBox;
    EdAge: TEdit;
    procedure CbEvaluationClick(Sender: TObject);
    procedure CbDeviceClick(Sender: TObject);
    procedure Rb4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    Report: TStringList;
    procedure SetReport;
    procedure CleanUpForm;
  end;

var
  FallAssessment: TFallAssessment;

implementation

uses
  UMDK_Options, UMDK_Common, System.UITypes;

{$R *.dfm}

procedure TFallAssessment.CbEvaluationClick(Sender: TObject);
begin
  Rb1.Enabled := CbEvaluation.Checked;
  Rb2.Enabled := CbEvaluation.Checked;
  Rb3.Enabled := CbEvaluation.Checked;
  Rb4.Enabled := CbEvaluation.Checked;
  CbDevice.Enabled := CbEvaluation.Checked;
  CbHandout.Enabled := CbEvaluation.Checked;
  CbConsult.Enabled := CbEvaluation.Checked;
  Cb21.Enabled := CbEvaluation.Checked and CbDevice.Checked;
  Cb22.Enabled := CbEvaluation.Checked and CbDevice.Checked;
  Cb23.Enabled := CbEvaluation.Checked and CbDevice.Checked;
  Cb24.Enabled := CbEvaluation.Checked and CbDevice.Checked;
  Cb25.Enabled := CbEvaluation.Checked and CbDevice.Checked;
  Cb26.Enabled := CbEvaluation.Checked and CbDevice.Checked;
  EdOther1.Enabled := CbEvaluation.Checked and CbDevice.Checked;
  Cb2.Enabled := CbEvaluation.Checked and Rb4.Checked;
  Cb3.Enabled := CbEvaluation.Checked and Rb4.Checked;
  Cb4.Enabled := CbEvaluation.Checked and Rb4.Checked;
  Cb5.Enabled := CbEvaluation.Checked and Rb4.Checked;
  Cb6.Enabled := CbEvaluation.Checked and Rb4.Checked;
  EdOther2.Enabled := CbEvaluation.Checked and Rb4.Checked;
  if EdOther2.Enabled then EdOther2.Color := ClWindow
  else EdOther2.Color := ClBtnFace;
  if EdAge.Enabled then EdAge.Color := ClWindow
  else EdAge.Color := ClBtnFace;
  if EdOther1.Enabled then EdOther1.Color := ClWindow
  else EdOther1.Color := ClBtnFace;
end;

procedure TFallAssessment.CbDeviceClick(Sender: TObject);
begin
  Cb21.Enabled := CbDevice.Checked;
  Cb22.Enabled := CbDevice.Checked;
  Cb23.Enabled := CbDevice.Checked;
  Cb24.Enabled := CbDevice.Checked;
  Cb25.Enabled := CbDevice.Checked;
  Cb26.Enabled := CbDevice.Checked;
  EdOther1.Enabled := CbDevice.Checked;
  if EdOther1.Enabled then EdOther1.Color := ClWindow
  else EdOther1.Color := ClBtnFace;
end;

procedure TFallAssessment.Rb4Click(Sender: TObject);
begin
  Cb2.Enabled := Rb4.Checked;
  Cb3.Enabled := Rb4.Checked;
  Cb4.Enabled := Rb4.Checked;
  Cb5.Enabled := Rb4.Checked;
  Cb6.Enabled := Rb4.Checked;
  EdOther2.Enabled := Rb4.Checked;
  if EdOther2.Enabled then EdOther2.Color := ClWindow
  else EdOther2.Color := ClBtnFace;
end;

procedure TFallAssessment.FormCreate(Sender: TObject);
begin
  Report := TStringList.Create;
  CbEvaluation.Checked := False;
  CbEvaluationClick(nil);
end;

procedure TFallAssessment.OKBtnClick(Sender: TObject);
begin
  SetReport;
end;

procedure TFallAssessment.SetReport;
  procedure _add(AString: string);
  begin
    Report.Add(AString);
  end;

const
  // _Tab = char(VK_TAB);
  _Tab = '      ';
begin
  Report.Clear;
  if not CbEvaluation.Checked then Exit;
  // _add('');
  if Preferences.BValue(OnFallsAssessmentAsTIU) then // zzzzzzandria 2008-03-31
      _add(CbEvaluation.Caption);
  _add(LbAge.Caption + ' ' + EdAge.Text);
  if Rb1.Checked then _add(Rb1.Caption);
  if Rb2.Checked then _add(Rb2.Caption);
  if Rb3.Checked then _add(Rb3.Caption);
  if Rb4.Checked then begin
    _add(Rb4.Caption);
    if Cb2.Checked then _add(_Tab + Cb2.Caption);
    if Cb3.Checked then _add(_Tab + Cb3.Caption);
    if Cb4.Checked then _add(_Tab + Cb4.Caption);
    if Cb5.Checked then _add(_Tab + Cb5.Caption);
    if Cb6.Checked then _add(_Tab + Cb6.Caption);
    if EdOther2.Text <> '' then _add(_Tab + 'Other: ' + EdOther2.Text);
  end;
  if CbDevice.Checked then begin
    _add(CbDevice.Caption);
    if Cb21.Checked then _add(_Tab + Cb21.Caption);
    if Cb22.Checked then _add(_Tab + Cb22.Caption);
    if Cb23.Checked then _add(_Tab + Cb23.Caption);
    if Cb24.Checked then _add(_Tab + Cb24.Caption);
    if Cb25.Checked then _add(_Tab + Cb25.Caption);
    if Cb26.Checked then _add(_Tab + Cb26.Caption);
    if EdOther1.Text <> '' then _add(_Tab + 'Other: ' + EdOther1.Text);
  end;
  if CbConsult.Checked then _add(CbConsult.Caption);
  if CbHandout.Checked then _add(CbHandout.Caption);
end;

procedure TFallAssessment.FormDestroy(Sender: TObject);
begin
  Report.Free;
  inherited;
end;

procedure TFallAssessment.Button1Click(Sender: TObject);
begin
  SetReport;
  if Trim(Report.Text) = '' then
      MessageDlg('Report text is blank'#13 + 'Check form options and try again.', MtWarning, [MbOK], 0)
  else ShowMessage(Report.Text);
end;

procedure TFallAssessment.CleanUpForm;
begin
  CbDevice.Checked := False;
  CbHandout.Checked := False;
  CbConsult.Checked := False;
  Cb21.Checked := False;
  Cb22.Checked := False;
  Cb23.Checked := False;
  Cb24.Checked := False;
  Cb25.Checked := False;
  Cb26.Checked := False;
  Cb2.Checked := False;
  Cb3.Checked := False;
  Cb4.Checked := False;
  Cb5.Checked := False;
  Cb6.Checked := False;
  EdAge.Text := '';
  EdOther1.Text := '';
  EdOther2.Text := '';
  CbEvaluation.Checked := False;
  Rb1.Checked := True;
end;

end.
