unit fMDK_PainAssessmentDLG;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Mask, DBCtrls, Menus, DB;

type
  TdlgPainAssessment = class(TForm)
    GbObservations: TGroupBox;
    Panel69: TPanel;
    PnlPainPatientDetails: TPanel;
    Label14: TLabel;
    Label15: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label18: TLabel;
    DbeOtherComments: TDBEdit;
    DbeOtherTreatment: TDBEdit;
    DbeHelpMed: TDBEdit;
    DbeRelieve: TDBEdit;
    DbeWorse: TDBEdit;
    DbeImpact: TDBEdit;
    Panel1: TPanel;
    OkBtn: TBitBtn;
    CancelBtn: TBitBtn;
    BitBtn1: TBitBtn;
    Panel5: TPanel;
    DbrgPainToleration: TDBRadioGroup;
    PnlPainDetails: TPanel;
    PnlDetailsItems: TPanel;
    Label47: TLabel;
    DbcLocation: TDBComboBox;
    Label53: TLabel;
    DbcIntensity: TDBComboBox;
    Label52: TLabel;
    DbeFrequencyText: TDBEdit;
    Label50: TLabel;
    DbcOnset: TDBComboBox;
    Label49: TLabel;
    DbcDuration: TDBComboBox;
    Label48: TLabel;
    DbcQuality: TDBComboBox;
    PnlPainGeneralItems: TPanel;
    LblPostPain: TLabel;
    DbcPain: TDBComboBox;
    Label44: TLabel;
    DbeLocation: TDBComboBox;
    PnlPainForm: TPanel;
    Label19: TLabel;
    Panel9: TPanel;
    DbrgPain: TDBRadioGroup;
    Label45: TLabel;
    DbeTreatment: TDBEdit;
    LblPainTolerance: TLabel;
    LblPain: TLabel;
    PopupMenu: TPopupMenu;
    Format1: TMenuItem;
    LblPainExtra: TLabel;
    procedure DbcPainChange(Sender: TObject);
    procedure DbrgPainTolerationChange(Sender: TObject);
    procedure DbcPainEnter(Sender: TObject);
    procedure DbcPainExit(Sender: TObject);
    procedure DbcPainContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
    procedure Format1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    Originals: TStringList;
    FField: TField;
    FActive: TObject;
    procedure CheckDBFields;
    procedure CleanDBFields;
    procedure SetPainFormStatus;
    procedure SaveOriginals;
    procedure RestoreOriginals;
  public
    procedure SetUp(AType: Integer);
  end;

var
  DlgPainAssessment: TdlgPainAssessment;

function UpdatePainData(AType: Integer): Integer;

implementation

uses
  UMDK_Summary, UMDK_Options, DMDK_Data, UMDK_Dictionary, UMDK_Common,
  UMDK_CDSCommon, UMDK_Engine, FMDK_DictionaryEdit;

{$R *.dfm}

function UpdatePainData(AType: Integer): Integer;
begin
  if not Assigned(DlgPainAssessment) then Application.CreateForm(TdlgPainAssessment, DlgPainAssessment);
  DlgPainAssessment.SetUp(AType);
  DlgPainAssessment.SaveOriginals;
  Result := DlgPainAssessment.ShowModal;
  if Result = MrCancel then DlgPainAssessment.RestoreOriginals;
  FreeAndNil(DlgPainAssessment);
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TdlgPainAssessment.SetUp(AType: Integer);
begin
  case AType of
    0: begin                              // Pre-Treatment
        DbcPain.DataField := FnS_PrePain; // Integer;
        DbrgPainToleration.DataField := FnS_PrePainTolerance;
        DbeLocation.DataField := FnS_PrePainLocation;               // PrePainLocation',40,40); //
        DbrgPain.DataField := FnS_PrePainAcute;                     // PrePainAcute');
        DbeTreatment.DataField := FnS_PrePainTreatment;             // PrePainTreatment',40,40); //
        DbcLocation.DataField := FnS_PrePainIASP;                   // PrePainIASP',40,40); //;
        DbcIntensity.DataField := FnS_PrePainIntensity;             // PrePainIntensity',40,40); //;
        DbeFrequencyText.DataField := FnS_PrePainFrequencyText;     // PrePainFrequency',40,40); //;
        DbcOnset.DataField := FnS_PrePainOnset;                     // PrePainOnset',40,40); //;
        DbcDuration.DataField := FnS_PrePainDuration;               // PrePainDuration',40,40); //;
        DbcQuality.DataField := FnS_PrePainQuality;                 // PrePainQuality',40,40); //;
        DbeImpact.DataField := FnS_PrePainImpact;                   // PrePainImpact',40,40);
        DbeWorse.DataField := FnS_PrePainWorse;                     // PrePainWorse',40,40);
        DbeRelieve.DataField := FnS_PrePainRelieve;                 // PrePainRelieve',40,40);
        DbeHelpMed.DataField := FnS_PrePainHelpMed;                 // PrePainHelpMed',40,40);
        DbeOtherTreatment.DataField := FnS_PrePainOtherTreatments;  // PrePainOtherTreatments',40,40);
        DbeOtherComments.DataField := FnS_PrePainOtherComments;     // PrePainOtherComments',40,40);
      end;
    1: begin                               // Post-Treatment
        DbcPain.DataField := FnS_PostPain; // Integer;
        DbrgPainToleration.DataField := FnS_PrePainTolerance;
        DbeLocation.DataField := FnS_PostPainLocation;              // PrePainLocation',40,40); //
        DbrgPain.DataField := FnS_PostPainAcute;                    // PrePainAcute');
        DbeTreatment.DataField := FnS_PostPainTreatment;            // PrePainTreatment',40,40); //
        DbcLocation.DataField := FnS_PostPainIASP;                  // PrePainIASP',40,40); //;
        DbcIntensity.DataField := FnS_PostPainIntensity;            // PrePainIntensity',40,40); //;
        DbeFrequencyText.DataField := FnS_PostPainFrequencyText;    // PrePainFrequency',40,40); //;
        DbcOnset.DataField := FnS_PostPainOnset;                    // PrePainOnset',40,40); //;
        DbcDuration.DataField := FnS_PostPainDuration;              // PrePainDuration',40,40); //;
        DbcQuality.DataField := FnS_PostPainQuality;                // PrePainQuality',40,40); //;
        DbeImpact.DataField := FnS_PostPainImpact;                  // PrePainImpact',40,40);
        DbeWorse.DataField := FnS_PostPainWorse;                    // PrePainWorse',40,40);
        DbeRelieve.DataField := FnS_PostPainRelieve;                // PrePainRelieve',40,40);
        DbeHelpMed.DataField := FnS_PostPainHelpMed;                // PrePainHelpMed',40,40);
        DbeOtherTreatment.DataField := FnS_PostPainOtherTreatments; // PrePainOtherTreatments',40,40);
        DbeOtherComments.DataField := FnS_PostPainOtherComments;    // PrePainOtherComments',40,40);
      end;
  end;
  if Preferences.BValue(OnConsiderPainTolerance) then begin
    DbrgPainToleration.Visible := True;
    LblPainTolerance.Visible := True;
    LblPain.Caption := 'If the patient can not tolerate pain, ' + 'please answer the following:';
    PnlPainDetails.Height := 48;
    LblPainExtra.Visible := False;
  end else begin
    DbrgPainToleration.Visible := False;
    LblPainTolerance.Visible := False;
    LblPain.Caption := 'If the pain exists, please answer the following:';
    LblPainExtra.Visible := True;
    LblPainExtra.Caption := 'If the pain value is ' + Preferences.SValue(OnPainLevel) +
      ' or more, please answer the following:';
    PnlPainDetails.Height := 25;
  end;
  DbcPainChange(nil);
end;

procedure TdlgPainAssessment.CheckDBFields;
begin
  CheckDBField(DbcPain);
  CheckDBField(DbeLocation);
  CheckDBField(DbeTreatment);
  CheckDBField(DbcLocation);
  CheckDBField(DbcIntensity);
  CheckDBField(DbeFrequencyText);
  CheckDBField(DbcOnset);
  CheckDBField(DbcDuration);
  CheckDBField(DbcQuality);
  CheckDBField(DbeImpact);
  CheckDBField(DbeWorse);
  CheckDBField(DbeRelieve);
  CheckDBField(DbeHelpMed);
  CheckDBField(DbeOtherTreatment);
  CheckDBField(DbeOtherComments);
end;

procedure TdlgPainAssessment.CleanDBFields;
begin
  DmData.CdsSummary.Edit;
  if Preferences.BValue(OnConsiderPainTolerance) then
      DmData.CdsSummary.FieldByName(DbrgPainToleration.DataField).AsString := 'Yes';
  DmData.CdsSummary.FieldByName(DbcLocation.DataField).AsString := '';
  DmData.CdsSummary.FieldByName(DbcIntensity.DataField).AsString := '';
  DmData.CdsSummary.FieldByName(DbeFrequencyText.DataField).AsString := '';
  DmData.CdsSummary.FieldByName(DbcOnset.DataField).AsString := '';
  DmData.CdsSummary.FieldByName(DbcDuration.DataField).AsString := '';
  DmData.CdsSummary.FieldByName(DbcQuality.DataField).AsString := '';
  DmData.CdsSummary.FieldByName(DbeImpact.DataField).AsString := '';
  DmData.CdsSummary.FieldByName(DbeWorse.DataField).AsString := '';
  DmData.CdsSummary.FieldByName(DbeRelieve.DataField).AsString := '';
  DmData.CdsSummary.FieldByName(DbeHelpMed.DataField).AsString := '';
  DmData.CdsSummary.FieldByName(DbeOtherTreatment.DataField).AsString := '';
  DmData.CdsSummary.FieldByName(DbeOtherComments.DataField).AsString := '';
end;

procedure SetupControls(APanel: TPanel; AValue: Boolean);
var
  I: Integer;
  BEnabled: Boolean;
begin
  // bEnabled := dbrgPainToleration.Value = 'No';
  BEnabled := AValue;
  APanel.Enabled := BEnabled;
  for I := 0 to APanel.ControlCount - 1 do
    if APanel.Controls[I] is TDBEdit then TDBEdit(APanel.Controls[I]).Enabled := BEnabled
    else if APanel.Controls[I] is TDBComboBox then TDBComboBox(APanel.Controls[I]).Enabled := BEnabled
    else if APanel.Controls[I] is TPanel then TPanel(APanel.Controls[I]).Enabled := BEnabled
end;

procedure TdlgPainAssessment.DbcPainChange(Sender: TObject);
var
  I, IPain: Integer;
  S: string;
begin
  S := DbcPain.Text;
  I := StrToIntDef(S, 0);
  S := Preferences.SValue(OnPainLevel);
  IPain := StrToIntDef(S, 5);
  if Preferences.BValue(OnConsiderPainTolerance) then begin
    DbrgPainToleration.Enabled := I > 0;
    DbrgPainTolerationChange(nil);
    PnlPainGeneralItems.Height := 90;
  end else begin
    if not DmData.CdsSummary.Active then Exit;
    // dbrgPain.Enabled := i > iPain;
    DbrgPain.Enabled := I > 0;
    // setUpControls(pnlPainGeneralItems, i >= iPain);
    SetUpControls(PnlPainGeneralItems, I > 0);
    SetUpControls(PnlDetailsItems, I >= IPain);
    SetUpControls(PnlPainPatientDetails, I >= IPain);
    PnlPainGeneralItems.Height := 107;
  end;
  if I < IPain then CleanDBFields;
  CheckDBFields;
end;

procedure TdlgPainAssessment.SetPainFormStatus;
var
  I, IPain: Integer;
  S: string;
begin
  if Preferences.BValue(OnConsiderPainTolerance) then DbrgPain.Enabled := DbrgPainToleration.Value = 'No'
  else begin
    S := DbcPain.Text;
    I := StrToIntDef(S, 0);
    S := Preferences.SValue(OnPainLevel);
    IPain := StrToIntDef(S, 5);
    DbrgPain.Enabled := I >= IPain;
  end;
end;

procedure TdlgPainAssessment.DbrgPainTolerationChange(Sender: TObject);
begin
  SetPainFormStatus;
  SetUpControls(PnlPainGeneralItems, DbrgPain.Enabled);
  SetUpControls(PnlDetailsItems, DbrgPain.Enabled);
  SetUpControls(PnlPainPatientDetails, DbrgPain.Enabled);
  CheckDBFields;
end;

procedure TdlgPainAssessment.DbcPainEnter(Sender: TObject);
begin
  FField := GetActiveField(Sender);
  FActive := Sender;
end;

procedure TdlgPainAssessment.DbcPainExit(Sender: TObject);
begin
  CheckDBField(Sender);
  FField := nil;
  FActive := nil;
end;

procedure TdlgPainAssessment.DbcPainContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
var
  WinCon: TWinControl;
begin
  if Engine.CurrentOperatorMode <> RnAdmin then Exit;
  WinCon := TWinControl(Sender);
  DbcPainEnter(Sender);
  PopupMenu.Popup(WinCon.ClientOrigin.X + MousePos.X, WinCon.ClientOrigin.Y + MousePos.Y);
  Handled := True;
end;

procedure TdlgPainAssessment.Format1Click(Sender: TObject);
begin
  if FField = nil then Exit;
  try
    UpdateColumnField(FField, FField.DataSet.Name, FField.FieldName);
    CheckDBField(FActive);
  except
  end;
end;

procedure TdlgPainAssessment.FormCreate(Sender: TObject);
begin
  inherited;
  Originals := TStringList.Create;
end;

procedure TdlgPainAssessment.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Originals);
  inherited;
end;

procedure TdlgPainAssessment.SaveOriginals;
  procedure SaveItem(AName: string);
  begin
    try
      Originals.Add(AName + '=' + DmData.CdsSummary.FieldByName(AName).AsString);
    except
    end;
  end;

begin
  Originals.Clear;
  SaveItem(FnS_PrePain);
  SaveItem(FnS_PrePainTolerance);
  SaveItem(FnS_PrePainLocation);
  SaveItem(FnS_PrePainAcute);
  SaveItem(FnS_PrePainTreatment);
  SaveItem(FnS_PrePainIASP);
  SaveItem(FnS_PrePainIntensity);
  SaveItem(FnS_PrePainFrequencyText);
  SaveItem(FnS_PrePainOnset);
  SaveItem(FnS_PrePainDuration);
  SaveItem(FnS_PrePainQuality);
  SaveItem(FnS_PrePainImpact);
  SaveItem(FnS_PrePainWorse);
  SaveItem(FnS_PrePainRelieve);
  SaveItem(FnS_PrePainHelpMed);
  SaveItem(FnS_PrePainOtherTreatments);
  SaveItem(FnS_PrePainOtherComments);
  SaveItem(FnS_PostPain);
  SaveItem(FnS_PostPainTolerance);
  SaveItem(FnS_PostPainLocation);
  SaveItem(FnS_PostPainAcute);
  SaveItem(FnS_PostPainTreatment);
  SaveItem(FnS_PostPainIASP);
  SaveItem(FnS_PostPainIntensity);
  SaveItem(FnS_PostPainFrequencyText);
  SaveItem(FnS_PostPainOnset);
  SaveItem(FnS_PostPainDuration);
  SaveItem(FnS_PostPainQuality);
  SaveItem(FnS_PostPainImpact);
  SaveItem(FnS_PostPainWorse);
  SaveItem(FnS_PostPainRelieve);
  SaveItem(FnS_PostPainHelpMed);
  SaveItem(FnS_PostPainOtherTreatments);
  SaveItem(FnS_PostPainOtherComments);
end;

procedure TdlgPainAssessment.RestoreOriginals;
var
  SValue: string;
  procedure RestoreItem(AName: string);
  begin
    try
      SValue := Originals.Values[AName];
      DmData.CdsSummary.FieldByName(AName).AsString := SValue;
    except
    end;
  end;

begin
  with DmData.CdsSummary do begin
    if State <> DsEdit then Edit;
    RestoreItem(FnS_PrePain);
    RestoreItem(FnS_PrePainTolerance);
    RestoreItem(FnS_PrePainLocation);
    RestoreItem(FnS_PrePainAcute);
    RestoreItem(FnS_PrePainTreatment);
    RestoreItem(FnS_PrePainIASP);
    RestoreItem(FnS_PrePainIntensity);
    RestoreItem(FnS_PrePainFrequencyText);
    RestoreItem(FnS_PrePainOnset);
    RestoreItem(FnS_PrePainDuration);
    RestoreItem(FnS_PrePainQuality);
    RestoreItem(FnS_PrePainImpact);
    RestoreItem(FnS_PrePainWorse);
    RestoreItem(FnS_PrePainRelieve);
    RestoreItem(FnS_PrePainHelpMed);
    RestoreItem(FnS_PrePainOtherTreatments);
    RestoreItem(FnS_PrePainOtherComments);
    RestoreItem(FnS_PostPain);
    RestoreItem(FnS_PostPainTolerance);
    RestoreItem(FnS_PostPainLocation);
    RestoreItem(FnS_PostPainAcute);
    RestoreItem(FnS_PostPainTreatment);
    RestoreItem(FnS_PostPainIASP);
    RestoreItem(FnS_PostPainIntensity);
    RestoreItem(FnS_PostPainFrequencyText);
    RestoreItem(FnS_PostPainOnset);
    RestoreItem(FnS_PostPainDuration);
    RestoreItem(FnS_PostPainQuality);
    RestoreItem(FnS_PostPainImpact);
    RestoreItem(FnS_PostPainWorse);
    RestoreItem(FnS_PostPainRelieve);
    RestoreItem(FnS_PostPainHelpMed);
    RestoreItem(FnS_PostPainOtherTreatments);
    RestoreItem(FnS_PostPainOtherComments);
    Post;
  end;
end;

end.
