unit fMDK_ReloadFlowsheet;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     Reload form
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms/fMDK_ReloadFlowsheet.pas $
  *
  *       $ History: fMDK_ReloadFlowsheet.pas $
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ActnList, StdActns, System.Actions;

type
  Tdlg_ReloadFlowsheet = class(TForm)
    PnlButtons: TPanel;
    Panel2: TPanel;
    BtnOK: TBitBtn;
    BitBtn2: TBitBtn;
    ActionList1: TActionList;
    AcSelectFile: TFileOpen;
    AcSelect: TFileOpen;
    AcSaveNow: TAction;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    GrbReloadOptions: TGroupBox;
    Panel4: TPanel;
    Label11: TLabel;
    RbFlowDelete: TRadioButton;
    RbFlowInstrumentOnly: TRadioButton;
    RbFlowNotChange: TRadioButton;
    Panel7: TPanel;
    Label12: TLabel;
    Rb2NotChanged: TRadioButton;
    Rb2Instrument: TRadioButton;
    Rb2All: TRadioButton;
    Panel8: TPanel;
    Label13: TLabel;
    Rb4NotChanged: TRadioButton;
    RbReplace: TRadioButton;
    LblVista: TLabel;
    GrbDataSource: TGroupBox;
    Panel3: TPanel;
    Label5: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label3: TLabel;
    SbVista: TSpeedButton;
    SbMedList: TSpeedButton;
    SbNotes: TSpeedButton;
    SbSummary: TSpeedButton;
    EdVista: TEdit;
    EdMedList: TEdit;
    EdNotes: TEdit;
    EdSummary: TEdit;
    Panel5: TPanel;
    RbFile: TRadioButton;
    RbVistA: TRadioButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Panel1: TPanel;
    Label2: TLabel;
    Rb3NotChanged: TRadioButton;
    Rb3Instrument: TRadioButton;
    Rb3All: TRadioButton;
    Bevel3: TBevel;
    Panel6: TPanel;
    CbFile: TCheckBox;
    SpeedButton1: TSpeedButton;
    EdFName: TEdit;
    SbFFlowsheet: TSpeedButton;
    Bevel4: TBevel;
    PnlOnlyNewResults: TPanel;
    Bevel5: TBevel;
    RbNewResults: TRadioButton;
    RadioButton1: TRadioButton;
    Label1: TLabel;
    Label8: TLabel;
    procedure RbSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RbVistAClick(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure AcSaveNowExecute(Sender: TObject);
    procedure SbVistaClick(Sender: TObject);
    procedure SbFFlowsheetClick(Sender: TObject);
    procedure CbFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure SetLayout(Available: Boolean);
    function GetLogString(AName: string = ''): string;
  end;

var
  Dlg_ReloadFlowsheet: Tdlg_ReloadFlowsheet;

implementation

uses
  System.UITypes, UXML, DMDK_Data, UMDK_Engine, UMDK_Common;

{$R *.dfm}

procedure Tdlg_ReloadFlowsheet.RbSaveClick(Sender: TObject);
begin
  AcSelectFile.Enabled := CbFile.Checked;
end;

procedure Tdlg_ReloadFlowsheet.FormCreate(Sender: TObject);
begin
  RbSaveClick(nil);
  RbVistAClick(nil);
  CbFileClick(nil);
end;

procedure Tdlg_ReloadFlowsheet.RbVistAClick(Sender: TObject);
begin
  AcSelect.Enabled := not RbVistA.Checked;
  EdVista.Enabled := not RbVistA.Checked;
  EdMedList.Enabled := not RbVistA.Checked;
  EdNotes.Enabled := not RbVistA.Checked;
  if not RbVistA.Checked then EdVista.Color := ClWindow
  else EdVista.Color := ClBtnFace;
  if not RbVistA.Checked then EdMedList.Color := ClWindow
  else EdMedList.Color := ClBtnFace;
  if not RbVistA.Checked then EdNotes.Color := ClWindow
  else EdNotes.Color := ClBtnFace;
  if not RbVistA.Checked then EdSummary.Color := ClWindow
  else EdSummary.Color := ClBtnFace;
  RbFlowNotChange.Enabled := RbVistA.Checked;
  RbFlowInstrumentOnly.Enabled := RbVistA.Checked;
  RbFlowDelete.Enabled := RbVistA.Checked;
  Rb2NotChanged.Enabled := RbVistA.Checked;
  Rb2Instrument.Enabled := RbVistA.Checked;
  Rb2All.Enabled := RbVistA.Checked;
  Rb3NotChanged.Enabled := RbVistA.Checked;
  Rb3Instrument.Enabled := RbVistA.Checked;
  Rb3All.Enabled := RbVistA.Checked;
  if not RbVistA.Checked then begin
    RbFlowNotChange.Font.Color := ClInactiveCaption;
    RbFlowInstrumentOnly.Font.Color := ClInactiveCaption;
    RbFlowDelete.Font.Color := ClInactiveCaption;
    Rb2NotChanged.Font.Color := ClInactiveCaption;
    Rb2Instrument.Font.Color := ClInactiveCaption;
    Rb2All.Font.Color := ClInactiveCaption;
    Rb3NotChanged.Font.Color := ClInactiveCaption;
    Rb3Instrument.Font.Color := ClInactiveCaption;
    Rb3All.Font.Color := ClInactiveCaption;
  end else begin
    RbFlowNotChange.Font.Color := ClBtnText;
    RbFlowInstrumentOnly.Font.Color := ClBtnText;
    RbFlowDelete.Font.Color := ClBtnText;
    Rb2NotChanged.Font.Color := ClBtnText;
    Rb2Instrument.Font.Color := ClBtnText;
    Rb2All.Font.Color := ClBtnText;
    Rb3NotChanged.Font.Color := ClBtnText;
    Rb3Instrument.Font.Color := ClBtnText;
    Rb3All.Font.Color := ClBtnText;
  end;
end;

procedure Tdlg_ReloadFlowsheet.BtnOKClick(Sender: TObject);
var
  S: string;
  Sl: TStringList;
begin
  if CbFile.Checked then begin
    if (EdFName.Text = '') then begin
      MessageDLG('Save file name is not defined', MtWarning, [MbOK], 0);
      Exit;
    end
    else AcSaveNow.Execute;
  end;
  S := GetLogString;
  Engine.Report(RtDebug, S, '', 0, '', 'RELOAD');
  if not RbVistA.Checked then begin
    Sl := nil;
    if EdVista.Text = '' then ShowMessage('No file selected...')
    else
      try
        Sl := TStringList.Create;
        Sl.LoadFromFile(EdVista.Text);
        if not DmData.ValidDataSetXML(Sl.Text) then ShowMessage('Invalid File Format...')
        else ModalResult := MrOK;
      finally
        Sl.Free;
      end;
  end
  else ModalResult := MrOK;
end;

procedure Tdlg_ReloadFlowsheet.SetLayout(Available: Boolean);
var
  S: string;
begin
  if not Available then begin
    S := 'No records are available for reload';
    RbVistA.Checked := False;
    RbVistA.Enabled := False;
    LblVista.Font.Color := ClRed;
    LblVista.Font.Style := [FsBold];
    LblVista.Visible := True;
    BtnOK.Enabled := False;
  end else begin
    S := 'All available to VistA data records will be read from the VistA DB and re-processed';
    LblVista.Visible := False;
    LblVista.Font.Color := ClWindowText;
    LblVista.Font.Style := [];
    RbVistA.Checked := True;
    RbVistA.Enabled := True;
    BtnOK.Enabled := True;
  end;
  LblVista.Caption := S;
end;

function Tdlg_ReloadFlowsheet.GetLogString(AName: string = ''): string;
var
  Sl: TStringList;
  XmlSummary, XmlFlowsheet, XmlMedList, XmlNotes: string;
  procedure PrepareXMLStrings;
  begin
    with DmData do begin
      try
        CdsFlowSheet.MergeChangeLog;
        XmlFlowsheet := CdsFlowSheet.XMLData;
      except
        XmlFlowsheet := '';
      end;
      try
        CdsMedList.MergeChangeLog;
        XmlMedList := CdsMedList.XMLData;
      except
        XmlMedList := '';
      end;
      try
        CdsNotes.MergeChangeLog;
        XmlNotes := CdsNotes.XMLData;
      except
        XmlNotes := '';
      end;
      try
        CdsSummary.MergeChangeLog;
        XmlSummary := CdsSummary.XMLData;
      except
        XmlNotes := '';
      end;
    end;
  end;

begin
  if Trim(AName) = '' then Exit;
  PrepareXMLStrings;
  Sl := TStringList.Create;
  Sl.Add('FLOWSHEET');
  Sl.Add(XmlFlowsheet);
  Sl.Add('MEDICATIONS');
  Sl.Add(XmlMedList);
  Sl.Add('FLOWSHEETNOTES');
  Sl.Add(XmlNotes);
  Sl.Add('SUMMARY');
  Sl.Add(XmlSummary);
  Sl.SaveToFile(AName);
  Result := Sl.Text;
  Sl.Free;
end;

procedure Tdlg_ReloadFlowsheet.AcSaveNowExecute(Sender: TObject);
begin
  GetLogString(EdFName.Text);
end;

procedure Tdlg_ReloadFlowsheet.SbVistaClick(Sender: TObject);
begin
  if OpenDialog1.Execute then EdVista.Text := OpenDialog1.FileName;
end;

procedure Tdlg_ReloadFlowsheet.SbFFlowsheetClick(Sender: TObject);
begin
  if SaveDialog1.Execute then EdFName.Text := SaveDialog1.FileName;
end;

procedure Tdlg_ReloadFlowsheet.CbFileClick(Sender: TObject);
begin
  EdFName.Enabled := CbFile.Checked;
  if CbFile.Checked then EdFName.Color := ClWindow
  else EdFName.Color := ClBtnFace;
  AcSaveNow.Enabled := CbFile.Checked;
end;

end.
