unit fMDK_SorAndFilter;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  Contains the Application Sort and Filter form
  *       Notes:
  *
  ================================================================================
  *       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_SorAndFilter.pas $
  *
  * $History: fMDK_SorAndFilter.pas $
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/13/09    Time: 1:15p
  * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
  * Patch 19 source code
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/24/08    Time: 4:23p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/02/08    Time: 9:24a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 3  *****************
  * User: Zzzzzzandria Date: 6/20/07    Time: 3:23p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 6/04/07    Time: 9:08a
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 5/22/07    Time: 9:16a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 3/27/07    Time: 1:31p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:38p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:28p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP_HEMODIALYSIS/CP MODERNIZATION/APP-HemoDialysis/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/25/07    Time: 9:39a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/22/07    Time: 1:36p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/APP-HEMODIALYSIS/Forms
  * GUI 1.0.6.308 RC January 2007
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/22/07    Time: 1:28p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/CP MODERNIZATION/APP-HemoDialysis/Forms
  * GUI 1.0.6.308 RC January 2007
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/28/06    Time: 5:15p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
}
interface

uses
  Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ActnList, ComCtrls, System.Actions;

type
  TdlgSort = class(TForm)
    ActionList1: TActionList;
    AcBack: TAction;
    AcForth: TAction;
    AcFilter: TAction;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    SbForth: TSpeedButton;
    Sbback: TSpeedButton;
    RbNo: TRadioButton;
    RbYes: TRadioButton;
    EdSort: TEdit;
    LbFrom: TListBox;
    LbTo: TListBox;
    TabSheet2: TTabSheet;
    Panel3: TPanel;
    Panel2: TPanel;
    OKBtn: TButton;
    CancelBtn: TButton;
    TsHelp: TTabSheet;
    Memo1: TMemo;
    Panel5: TPanel;
    Panel6: TPanel;
    CmbField: TComboBox;
    CmbAction: TComboBox;
    EdValue: TEdit;
    SpeedButton1: TSpeedButton;
    ComboBox19: TComboBox;
    Panel4: TPanel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Edit1: TEdit;
    ComboBox3: TComboBox;
    Panel7: TPanel;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    Edit2: TEdit;
    ComboBox6: TComboBox;
    Panel8: TPanel;
    ComboBox7: TComboBox;
    ComboBox8: TComboBox;
    Edit3: TEdit;
    ComboBox9: TComboBox;
    Panel9: TPanel;
    Panel10: TPanel;
    MmFilter: TMemo;
    Panel11: TPanel;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    procedure LbFromClick(Sender: TObject);
    procedure AcBackExecute(Sender: TObject);
    procedure AcForthExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AcFilterExecute(Sender: TObject);
  private
    { Private declarations }
  public
    procedure SetButtonStatus;
  end;

var
  DlgSort: TdlgSort;

implementation

{$R *.dfm}

procedure TdlgSort.LbFromClick(Sender: TObject);
begin
  RbYes.Checked := True;
end;

procedure TdlgSort.SetButtonStatus;
begin
  SbForth.Enabled := LbFrom.Items.Count > 0;
  SbBack.Enabled := LbTo.Items.Count > 0;
  EdSort.Text := LbTo.Items.DelimitedText;
end;

procedure TdlgSort.AcBackExecute(Sender: TObject);
begin
  if LbTo.ItemIndex < 0 then LbTo.ItemIndex := 0;
  LbFrom.Items.Add(LbTo.Items[LbTo.ItemIndex]);
  LbTo.Items.Delete(LbTo.ItemIndex);
  SetButtonStatus;
end;

procedure TdlgSort.AcForthExecute(Sender: TObject);
begin
  if LbFrom.ItemIndex < 0 then LbFrom.ItemIndex := 0;
  LbTo.Items.Add(LbFrom.Items[LbFrom.ItemIndex]);
  LbFrom.Items.Delete(LbFrom.ItemIndex);
  SetButtonStatus;
end;

procedure TdlgSort.FormCreate(Sender: TObject);
begin
  LbTo.Items.Delimiter := ';';
  LbTo.Items.QuoteChar := '''';
end;

procedure TdlgSort.AcFilterExecute(Sender: TObject);
begin
  MmFilter.Text := CmbField.Text + ' ' + CmbAction.Text + ' ''' + EdValue.Text + '''';
end;

end.
