unit uMDK_FreseniusKeywords;

interface

const
  kwFRES_BPSystolic =           'BP Systolic';
  kwFRES_BPDiastolic =          'BP Diastolic';
  kwFRES_Pulse =                'Pulse';
  kwFRES_BloodFlowRate =        'Blood Flow Rate';
  kwFRES_ArterialPressure =     'Arterial Pressure';
  kwFRES_VenousPressure =       'Venous Pressure';
  kwFRES_UltraFiltrationRate =  'Ultra Filtration Rate';
  kwFRES_Temperature =          'Temperature';

  kwFRES_TransMembranePressure = 'Trans Membrane Pressure';
  kwFRES_Conductivity =         'Conductivity';
  kwFRES_DialysateFlowRate =    'Dialysate Flow Rate';
  kwFRES_UltraFiltrationRemoved = 'Ultra Filtration Removed';
  kwFres_HeparinInfused =       'Total Heparin Infused';

  kwFres_GoalWeight =           'Goal Weight'; // Tx Goal Weight  zzzzzzandria 051208
  //  kwFres_StatuionNumber = ''; // zzzzzzandria 051208
  //  kwFres_MachineNumber = ''; // zzzzzzandria 051208

    // 050920 - zzzzzzandria
  kwFRES_PreTemperature =       'PRE Vital Temperature';
  kwFRES_PreWeight =            'PRE Vital Weight';
  kwFRES_PrePulse =             'PRE Vital Pulse';
  kwFRES_PreBPSystolicSitting = 'PRE BP Systolic Sitting';
  kwFRES_PreBPDiastolicSitting = 'PRE BP Diastolic Sitting';
  kwFRES_PreBPSystolicStanding = 'PRE BP Systolic Standing';
  kwFRES_PreBPDiastolicStanding = 'PRE BP Diastolic Standing';

  kwFRES_PostTemperature =      'POST Vital Temperature';
  kwFRES_PostWeight =           'POST Vital Weight';
  kwFRES_PostPulse =            'POST Vital Pulse';
  kwFRES_PostBPSystolicSitting = 'POST BP Systolic Sitting';
  kwFRES_PostBPDiastolicSitting = 'POST BP Diastolic Sitting';
  kwFRES_PostBPSystolicStanding = 'POST BP Systolic Standing';
  kwFRES_PostBPDiastolicStanding = 'POST BP Diastolic Standing';

  kwFRES_RemainingTime =        'Remaining Time On Dialysis';
  kwFRES_MAP =                  'Mean Arterial Pressure';

  kwFRES_EffectiveKTV =         'Effective KtV';
  kwFRES_TotalUF =              'Total UF';

  kwFRES_PreviousGoalWeight =   'Previous Goal Weight';

  kwFRES_TotalUltraFiltration = 'Total Ultra Filtration';
  kwFRES_TotalBV =              'Total Blood Volume';
  kwFRES_MeanBF =               'Mean Blood Flow';
  kwFRES_MeanDF =               'Mean Dialysate Flow';
  kwFRES_MeanUFR =              'Mean Ultra Filtration Rate';
  kwFRES_MeanTMP =              'Mean Trans Memb Pressure';
  kwFRES_MeanTemp =             'Mean Temperature';
  kwFRES_TimeOn =               'Time On';
  kwFRES_TimeOff =              'Time Off';
  kwFRES_TargetWL =             'Target Weight Loss';

  kwFRES_TreatmentStarted =     'Time On';
  kwFRES_TreatmentStoped =      'Time Off';

  // Prescription
  kwFRES_DialyzerType =         'Dialyzer Type';
  kwFRES_DialyzerReuse =        'Dialyzer Reuse Nbr';
  kwFRES_TreatmentLength =      'Treatment Length';
  kwFRES_PrBloodFlowRate =      'Blood Flow Rate';
  kwFRES_DialysateFormula =     'Dialysate Formula';
  kwFRES_ModelingNa =           'Modeling Na';
  kwFRES_SodiumProgram =        'Sodium Program';
  kwFRES_SodiumProgramTime =    'Sodium Program Time';
  kwFRES_SodiumBaseConductivity = 'Sodium Base Conductivity';
  kwFRES_DialysateFlow =        'Dialysate Flow';
  kwFRES_AnticoagulantLoad =    'Anticoagulant Load';
  kwFRES_AnticoagulantUnitsPerHour = 'Anticoagulant Units Per Hour';
  kwFRES_AnticoagulantType =    'Anticoagulant Type';
  kwFRES_DryWeight =            'Dry Weight';

  //Medications
  kwFRES_MedicationType =       'Medication Type';
  kwFRES_ICD9Description =      'ICD 9 Description';
  kwFRES_ICD9Code =             'ICD 9 Code';
  kwFRES_MeasurementType =      'Measurement Type';
  kwFRES_RouteType =            'Route Type';
  kwFRES_PatientCareInitials =  'Patient Care Initials';
  kwFRES_Dose =                 'Dose';

  kwFRES_CurrentPostTreatmentParameters = 'Current POST Treatment Parameters';
  kwFRES_CurrentPreTreatmentParameters = 'Current PRE Treatment Parameters';
  kwFRES_PreviousPostTreatmentParameters = 'Previous POST Treatment Parameters';
  kwFRES_PreviousPreTreatmentParameters = 'Previous PRE Treatment Parameters';
  kwFRES_Note = 'Note';
  // zzzzzzandria 2007-06-27 - Notes are not coming through
  kwFRES_NoteCreatedDateTime =  'Note Created Date Time';
  kwFRES_NoteCreatedBy =        'Note Created By';
  // 060627
  kwFres_StationID =            'Station ID';
  kwFres_InstrumentID =         'Machine Number';
  kwFres_TreatmentDuration =    'Treatment Duration';

function isFreseniusKeyword(aValue:String): Boolean;

implementation

var
  sKeywords:String;

function isFreseniusKeyword(aValue:String): Boolean;
begin
  Result := pos(aValue+#13#10,sKeywords)>0;
end;

initialization
  sKeywords :=
    kwFRES_BPSystolic  + #13#10 +
    kwFRES_BPDiastolic  + #13#10 +
    kwFRES_Pulse  + #13#10 +
    kwFRES_BloodFlowRate  + #13#10 +
    kwFRES_ArterialPressure  + #13#10 +
    kwFRES_VenousPressure  + #13#10 +
    kwFRES_UltraFiltrationRate  + #13#10 +
    kwFRES_Temperature  + #13#10 +

    kwFRES_TransMembranePressure  + #13#10 +
    kwFRES_Conductivity  + #13#10 +
    kwFRES_DialysateFlowRate  + #13#10 +
    kwFRES_UltraFiltrationRemoved  + #13#10 +
    kwFres_HeparinInfused  + #13#10 +

    kwFres_GoalWeight  + #13#10 +
    //  kwFres_StatuionNumber  + #13#10 + ''; // zzzzzzandria 051208
    //  kwFres_MachineNumber  + #13#10 + ''; // zzzzzzandria 051208

      // 050920 - zzzzzzandria
    kwFRES_PreTemperature  + #13#10 +
    kwFRES_PreWeight  + #13#10 +
    kwFRES_PrePulse  + #13#10 +
    kwFRES_PreBPSystolicSitting  + #13#10 +
    kwFRES_PreBPDiastolicSitting  + #13#10 +
    kwFRES_PreBPSystolicStanding  + #13#10 +
    kwFRES_PreBPDiastolicStanding  + #13#10 +

    kwFRES_PostTemperature  + #13#10 +
    kwFRES_PostWeight  + #13#10 +
    kwFRES_PostPulse  + #13#10 +
    kwFRES_PostBPSystolicSitting  + #13#10 +
    kwFRES_PostBPDiastolicSitting  + #13#10 +
    kwFRES_PostBPSystolicStanding  + #13#10 +
    kwFRES_PostBPDiastolicStanding  + #13#10 +

    kwFRES_RemainingTime  + #13#10 +
    kwFRES_MAP  + #13#10 +

    kwFRES_EffectiveKTV  + #13#10 +
    kwFRES_TotalUF  + #13#10 +

    kwFRES_PreviousGoalWeight  + #13#10 +

    kwFRES_TotalUltraFiltration  + #13#10 +
    kwFRES_TotalBV  + #13#10 +
    kwFRES_MeanBF  + #13#10 +
    kwFRES_MeanDF  + #13#10 +
    kwFRES_MeanUFR  + #13#10 +
    kwFRES_MeanTMP  + #13#10 +
    kwFRES_MeanTemp  + #13#10 +
    kwFRES_TimeOn  + #13#10 +
    kwFRES_TimeOff  + #13#10 +
    kwFRES_TargetWL  + #13#10 +

    kwFRES_TreatmentStarted  + #13#10 +
    kwFRES_TreatmentStoped  + #13#10 +

    // Prescription
    kwFRES_DialyzerType  + #13#10 +
    kwFRES_DialyzerReuse  + #13#10 +
    kwFRES_TreatmentLength  + #13#10 +
    kwFRES_PrBloodFlowRate  + #13#10 +
    kwFRES_DialysateFormula  + #13#10 +
    kwFRES_ModelingNa  + #13#10 +
    kwFRES_SodiumProgram  + #13#10 +
    kwFRES_SodiumProgramTime  + #13#10 +
    kwFRES_SodiumBaseConductivity  + #13#10 +
    kwFRES_DialysateFlow  + #13#10 +
    kwFRES_AnticoagulantLoad  + #13#10 +
    kwFRES_AnticoagulantUnitsPerHour  + #13#10 +
    kwFRES_AnticoagulantType  + #13#10 +
    kwFRES_DryWeight  + #13#10 +

    //Medications
    kwFRES_MedicationType  + #13#10 +
    kwFRES_ICD9Description  + #13#10 +
    kwFRES_ICD9Code  + #13#10 +
    kwFRES_MeasurementType  + #13#10 +
    kwFRES_RouteType  + #13#10 +
    kwFRES_PatientCareInitials  + #13#10 +
    kwFRES_Dose  + #13#10 +

    kwFRES_CurrentPostTreatmentParameters  + #13#10 +
    kwFRES_CurrentPreTreatmentParameters  + #13#10 +
    kwFRES_PreviousPostTreatmentParameters  + #13#10 +
    kwFRES_PreviousPreTreatmentParameters  + #13#10 +
    kwFRES_Note  + #13#10 +
    // zzzzzzandria 2007-06-27 - Notes are not coming through
    kwFRES_NoteCreatedDateTime  + #13#10 +
    kwFRES_NoteCreatedBy  + #13#10 +
    // 060627
    kwFres_StationID  + #13#10 +
    kwFres_InstrumentID  + #13#10 +
    kwFres_TreatmentDuration  + #13#10;

finalization
end.
