unit iMDK_Presenter;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:38a $
  *       Site Name:    Hines OIFO
  *       Date Created: 5/01/07
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     I_Presenter definition
  *       Notes:
  *
  ================================================================================
}
interface

uses
  Classes, Menus;

type
  I_DataPresenter = interface
    ['{EF4727F7-59E1-487E-AF7A-6CF01377B466}']
    procedure matchGUI;
    // map GUI elements to data sources and controllers
    procedure unmatchGUI;
    // break links to controllers
    procedure updateGUI;
    // update presentation based on data values
    procedure getData;
    // get values from data sources
    procedure setData;
    // set values based on GUI status
    procedure refreshGUI;
    // getData;
    // updateGUI;
    procedure wakeupGUI;
    // activate
    procedure laydownGUI;
    // deactivate
    function getMainMenu: TMainMenu;
    // get access to presenter actions
    function getHelpContext: Integer;
    // get presenter help index
  end;

implementation

end.
