unit uMDK_BillingInfo;
{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:38a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     Billing information object
  *       Notes:
  *
  ================================================================================
  *       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Objects/uMDK_BillingInfo.pas $
  *
  * $History: uMDK_BillingInfo.pas $
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/13/09    Time: 1:15p
  * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Objects
  * Patch 19 source code
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/24/08    Time: 4:23p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/02/08    Time: 9:25a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 3  *****************
  * User: Zzzzzzandria Date: 6/20/07    Time: 3:23p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 6/04/07    Time: 9:08a
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 5/22/07    Time: 9:16a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 3/27/07    Time: 1:31p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:38p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:28p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP_HEMODIALYSIS/CP MODERNIZATION/APP-HemoDialysis/Objects
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/25/07    Time: 9:39a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/22/07    Time: 1:36p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/APP-HEMODIALYSIS/Objects
  * GUI 1.0.6.308 RC January 2007
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/22/07    Time: 1:28p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/CP MODERNIZATION/APP-HemoDialysis/Objects
  * GUI 1.0.6.308 RC January 2007
  *
  * *****************  Version 4  *****************
  * User: Zzzzzzandria Date: 12/13/06   Time: 1:53p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Objects
  *
  * *****************  Version 3  *****************
  * User: Zzzzzzandria Date: 7/12/06    Time: 9:41a
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Objects
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 5/19/06    Time: 5:46p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Objects
  * May 19
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/28/06    Time: 5:18p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Objects
}

interface

uses
  Classes, SysUtils;

type
  TMDK_Provider = class(TObject)
    ID: string;
    Name: string;
    Primary: Boolean;
  end;

  TMDK_Diagnosis = class(TObject)
    ID: string;
    IEN: string;
    Category: string;
    Title: string;
    Primary: Boolean;
  end;

  TMDK_Procedure = class(TObject)
    ID: string;
    IEN: string;
    Category: string;
    Title: string;
    Quantity: Integer;
  end;

  TMDK_BillingInfo = class(TObject)
  private
    fSCC, fMST, fAOE, fIRE, fHNC, fEC, fCV, fCLV: Integer;
    FStudyID: string;
    FXMLData: string;
    FLegacy: string;
    FService, FProcedures, FDiagnoses, FProviders: TStringList;
    procedure SetXMLData(AValue: string);
    procedure SetLegacy(AValue: string);
    function GetIStudyID: Integer;
    function GetXMLData: string;
    function GetLegacy: string;
  public
    property SCC: Integer read FSCC write FSCC;
    property MST: Integer read FMST write FMST;
    property AOE: Integer read FAOE write FAOE;
    property IRE: Integer read FIRE write FIRE;
    property HNC: Integer read FHNC write FHNC;
    property EC: Integer read FEC write FEC;
    property CV: Integer read FCV write FCV;
    property CLV: Integer read FCLV write FCLV;
    property Legacy: string read GetLegacy write SetLegacy;
    property XMLData: string read GetXMLData write SetXMLData;
    property StudyID: string read FStudyID;
    property IStudyID: Integer read GetIStudyID;
    property Procedures: TStringList read FProcedures write FProcedures;
    property Diagnoses: TStringList read FDiagnoses write FDiagnoses;
    property Providers: TStringList read FProviders write FProviders;
    procedure Clear;
    constructor Create;
    destructor Destroy; override;
  end;

const
  IICD9Keyword          = 1;
  IICDIEN               = 2;
  IICD9Code             = 3;
  IICD9ShortDescription = 5;
  IICD9Primary          = 6;
  ICPTKeyword           = 1;
  ICPTIEN               = 2;
  ICPTCode              = 3;
  ICPTSHortDescription  = 5;
  ICPTQuantity          = 7;
  IPRVKeyword           = 1;
  IPRVCode              = 2;
  IPRVName              = 4;
  IPRVPrimary           = 6;

implementation

uses
  UXML, XMLIntf, UROR_CommonUtils;

constructor TMDK_BillingInfo.Create;
begin
  inherited;
  FProcedures := TStringList.Create;
  FDiagnoses := TStringList.Create;
  FProviders := TStringList.Create;
  FService := TStringList.Create;
end;

destructor TMDK_BillingInfo.Destroy;
begin
  Clear;
  FreeAndNil(FProcedures);
  FreeAndNil(FProviders);
  FreeAndNil(FDiagnoses);
  FreeAndNil(FService);
  inherited;
end;

procedure TMDK_BillingInfo.Clear;
begin
  FSCC := -1;
  FMST := -1;
  FAOE := -1;
  FIRE := -1;
  FHNC := -1;
  FEC := -1;
  FCV := -1;
  FCLV := -1;
  FStudyID := '';
  FXMLData := '';
  while FProviders.Count > 0 do begin
    if FProviders.Objects[0] <> nil then
      try
        TMDK_Provider(FProviders.Objects[0]).Free;
      except
      end;
    FProviders.Delete(0);
  end;
  while FDiagnoses.Count > 0 do begin
    if FDiagnoses.Objects[0] <> nil then
      try
        TMDK_Diagnosis(FDiagnoses.Objects[0]).Free;
      except
      end;
    FDiagnoses.Delete(0);
  end;
  while FProcedures.Count > 0 do begin
    if FProcedures.Objects[0] <> nil then
      try
        TMDK_Procedure(FProcedures.Objects[0]).Free;
      except
      end;
    FProcedures.Delete(0);
  end;
end;

procedure TMDK_BillingInfo.SetXMLData(AValue: string);
var
  OK: Boolean;
  I: Integer;
  XDOC: IXMLDocument;
  XNode: IXMLNode;
  __SCC, __MST, __AOE, __IRE, __HNC, __EC, __CV, __CLV: Integer;
  __StudyID: string;
  function GetChildByName(AName: string): Integer;
  begin
    try
      Result := StrToIntDef(XNode.ChildValues[AName], -1);
    except
      Result := -1;
    end;
  end;
  function GetChildStringByName(AName: string): string;
  begin
    try
      Result := XNode.ChildValues[AName];
    except
      Result := '';
    end;
  end;

begin
  __SCC := -1;
  __MST := -1;
  __AOE := -1;
  __IRE := -1;
  __HNC := -1;
  __EC := -1;
  __CV := -1;
  __CLV := -1;
  try
    OK := False;
    try
      FXMLData := '';
      if (Pos('-1', AValue) <> 1) and (Trim(AValue) <> '') then XDOC := XMLDocument(AValue)
      else Exit;
    except
      Exit;
    end;
    with XDoc.DocumentElement do begin
      for I := 0 to ChildNodes.Count - 1 do begin
        XNode := ChildNodes[I];
        if XNode.NodeName = 'STATUS' then OK := XNOde.NodeValue = 'OK';
        if XNode.NodeName <> 'RECORD' then Continue;
        __StudyID := GetChildStringByName('STUDY_ID');
        __SCC := GetChildByName('SC_CONDITION');
        __MST := GetChildByName('MST');
        __AOE := GetChildByName('AO_EXPOSURE');
        __IRE := GetChildByName('IR_EXPOSURE');
        __HNC := GetChildByName('HEAD_NECK_CANCER');
        __EC := GetChildByName('EV_CONTAMINENTS');
        __CV := GetChildByName('COMBAT_VETERAN');
        __CLV := GetChildByName('CAMP_LEJEUNE');
      end;
    end;
  except
    OK := False;
  end;
  if not OK then Exit;
  FSCC := __SCC;
  FMST := __MST;
  FAOE := __AOE;
  FIRE := __IRE;
  FHNC := __HNC;
  FEC := __EC;
  FCV := __CV;
  FCLV := __CLV;
  FStudyID := __StudyID;
  FXMLData := AValue;
end;

function TMDK_BillingInfo.GetIStudyID: Integer;
begin
  try
    Result := StrToInt(FStudyID);
  except
    Result := -1;
  end;
end;

function TMDK_BillingInfo.GetXMLData: string;
begin
  Result := FXMLData;
end;

function TMDK_BillingInfo.GetLegacy: string;
var
  Ss: string;
  I: Integer;
  APro: TMDK_Provider;
  AProc: TMDK_Procedure;
  ADiag: TMDK_Diagnosis;
  function SetCB(AName: string; Ckb: Integer): string;
  begin
    Result := '';
    if AName = '' then Exit;
    if Ckb >= 0 then begin
      Result := AName + ';1^';
      if Ckb = 1 then Result := Result + '1;'
      else Result := Result + '0;';
    end
    else Result := AName + ';0^;';
  end;

begin
  Ss := '';
  try
    Ss := Ss + SetCB('SC', FSCC);
    Ss := Ss + SetCB('AO', FAOE);
    Ss := Ss + SetCB('IR', FIRE);
    Ss := Ss + SetCB('EC', FEC);
    Ss := Ss + SetCB('MST', FMST);
    Ss := Ss + SetCB('HNC', FHNC);
    Ss := Ss + SetCB('CV', FCV);
//    Ss := Ss + ';0^;';
//    Ss := Ss + ';^;';              // placeholder for SHAD, added during CLV
    Ss := Ss + SetCB('CLV', FCLV);
    Ss := Ss + #13#10;
    {
      iPRVKeyword = 1;
      iPRVCode = 2;
      iPRVName = 4;
      iPRVPrimary = 6;
    }
    for I := 0 to Providers.Count - 1 do begin
      APro := TMDK_Provider(Providers.Objects[I]);
      Ss := Ss + 'PRV^' + APro.ID + '^^' + APro.Name + '^^';
      if APro.Primary then Ss := Ss + '1';
      Ss := Ss + #13#10;
    end;
    {
      iICD9Keyword = 1;
      iICD9Code = 3;
      iICD9ShortDescription = 5;
      iICD9Primary = 6;
    }
    for I := 0 to Diagnoses.Count - 1 do begin
      ADiag := TMDK_Diagnosis(Diagnoses.Objects[I]);
      Ss := Ss + 'POV^' + ADiag.IEN + '^' + ADiag.ID + '^^' + ADiag.Title + '^';
      if ADiag.Primary then Ss := Ss + '1';
      Ss := Ss + #13#10;
    end;
    {
      iCPTKeyword = 1;
      iCPTCode = 3;
      iCPTSHortDescription = 5;
      iCPTQuantity = 7;
    }
    for I := 0 to Procedures.Count - 1 do begin
      AProc := TMDK_Procedure(Procedures.Objects[I]);
      Ss := Ss + 'CPT^' + AProc.IEN + '^' + AProc.ID + '^^' + AProc.Title + '^^';
      if AProc.Quantity > 0 then Ss := Ss + IntToStr(AProc.Quantity);
      Ss := Ss + #13#10;
    end;
  except
  end;
  Result := Ss;
end;

procedure TMDK_BillingInfo.SetLegacy(AValue: string);
var
  I: Integer;
  SL: TStringList;
  procedure SetConnectionData(AV: string);
    function Connection(ASource: string): Integer;
    var
      S1, S2: string;
    begin
      Result := -1;
      if ASource = '' then Exit;
      S1 := Piece(ASource, '^', 1);
      S2 := Piece(Piece(ASource, '^', 2), ';', 1);
      if S1 = '0' then begin
        Result := -1;
      end else begin
        Result := StrToIntDef(S2, 0);
      end;
    end;

  var
    Ss: string;
  begin
    Ss := Piece(AV, 'SC;', 2);
    FSCC := Connection(Ss);
    Ss := Piece(AV, 'AO;', 2);
    FAOE := Connection(Ss);
    Ss := Piece(AV, 'IR;', 2);
    FIRE := Connection(Ss);
    Ss := Piece(AV, 'EC;', 2);
    FEC := Connection(Ss);
    Ss := Piece(AV, 'HNC;', 2);
    FHNC := Connection(Ss);
    Ss := Piece(AV, 'MST;', 2);
    FMST := Connection(Ss);
    Ss := Piece(AV, 'CV;', 2);
    FCV := Connection(Ss);
    // Note:  a placeholder for SHAD was added to GetLegacy, but is not assigned to any variables here.
    Ss := Piece(AV, 'CLV;', 2);
    FCLV := Connection(Ss);
  end;
  procedure AddProvider(ASource: string);
  var
    AProvider: TMDK_Provider;
  begin
    AProvider := TMDK_Provider.Create;
    AProvider.ID := Piece(ASource, '^', IPRVCode);
    AProvider.Name := Piece(ASource, '^', IPRVName);
    AProvider.Primary := Piece(ASource, '^', IPRVPrimary) = '1';
    FProviders.AddObject(AProvider.Name, AProvider);
  end;
  procedure AddCPT(ASource: string);
  var
    AProcedure: TMDK_Procedure;
  begin
    AProcedure := TMDK_Procedure.Create;
    AProcedure.ID := Piece(ASource, '^', ICPTCode);
    AProcedure.IEN := Piece(ASource, '^', ICPTIEN);
    AProcedure.Title := Piece(ASource, '^', ICPTShortDescription);
    AProcedure.Quantity := StrToIntDef(Piece(ASource, '^', ICPTQuantity), 1);
    FProcedures.AddObject(AProcedure.Title, AProcedure);
  end;
  procedure AddICD(ASource: string);
  var
    ADiagnosys: TMDK_Diagnosis;
  begin
    ADiagnosys := TMDK_Diagnosis.Create;
    ADiagnosys.IEN := Piece(ASource, '^', IICDIEN);
    ADiagnosys.ID := Piece(ASource, '^', IICD9Code);
    ADiagnosys.Title := Piece(ASource, '^', IICD9ShortDescription);
    ADiagnosys.Primary := Piece(ASource, '^', IICD9Primary) = '1';
    FDiagnoses.AddObject(ADiagnosys.Title, ADiagnosys);
  end;

begin
  Clear;
  FLegacy := AValue;
  SL := TStringList.Create;
  SL.Text := AValue;
  if SL.Count < 1 then Exit;
  SetConnectionData(SL[0]); // Sets environmental indicators
  for I := 1 to SL.Count - 1 do begin
    if Piece(SL[I], '^', 1) = 'PRV' then AddProvider(SL[I]);
    if Piece(SL[I], '^', 1) = 'POV' then AddICD(SL[I]);
    if Piece(SL[I], '^', 1) = 'CPT' then AddCPT(SL[I]);
  end;
end;

end.
