unit uMDK_Info;
{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:38a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     Info object
  *       Notes:
  *
  ================================================================================
  *       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Objects/uMDK_Info.pas $
  *
  * $History: uMDK_Info.pas $
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/13/09    Time: 1:16p
  * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Objects
  * Patch 19 source code
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/24/08    Time: 4:23p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/02/08    Time: 9:25a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 3  *****************
  * User: Zzzzzzandria Date: 6/20/07    Time: 3:23p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 6/04/07    Time: 9:08a
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 5/22/07    Time: 9:17a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 2  *****************
  * User: Zzzzzzandria Date: 3/27/07    Time: 1:31p
  * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:38p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 3/26/07    Time: 12:28p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP_HEMODIALYSIS/CP MODERNIZATION/APP-HemoDialysis/Objects
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/25/07    Time: 9:39a
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/22/07    Time: 1:36p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/APP-HEMODIALYSIS/Objects
  * GUI 1.0.6.308 RC January 2007
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 1/22/07    Time: 1:28p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/CP MODERNIZATION/APP-HemoDialysis/Objects
  * GUI 1.0.6.308 RC January 2007
  *
  * *****************  Version 1  *****************
  * User: Zzzzzzandria Date: 4/28/06    Time: 5:18p
  * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Objects
}

interface

uses
  Sysutils,
  DBClient;

procedure CreateInfoDS(aCDS: TClientDataSet);

type
  TMDK_Info = class(TObject)
  private
  public
    PatientID: string;        // 'PatientID';
    StudyID: string;          // 'StudyID';
    StudyDate: TDateTime;     // 'StudyDate';
    Diagnosis: string;        // 'Diagnosis';
    DiagnosisDate: TDateTime; // 'DDate';
    TherapyDate: TDateTime;   // 'TDate';
    Modality: string;         // 'Modality';
    CodeStatus: string;       // 'CodeStatus';
    Nephrologist: string;     // 'Nephrologist';
    AD: Boolean;              // 'Mon';
    Mon: Boolean;             // 'Mon';
    Tue: Boolean;             // 'Tue';
    Wed: Boolean;             // 'Wen';
    Thu: Boolean;             // 'Thu';
    Fri: Boolean;             // 'Fra';
    Sat: Boolean;             // 'Sat';
    Sun: Boolean;             // 'Sun';
    function EqualTo(aValue: TMDK_Info): Boolean;
    function Clone: TMDK_Info;
    procedure setEqualTo(aValue: TMDK_Info);
    procedure saveToCDS(aCDS: TClientDataSet);
    function Description: string;
  end;

  // function getInfoRecord(aCDS: TClientDataSet):TMDK_Info;

const
  fnI_PatientID     = 'PatientID';
  fnI_StudyID       = 'StudyID';
  fnI_StudyDate     = 'StudyDate';
  fnI_Diagnosis     = 'Diagnosis';
  fnI_DiagnosisDate = 'DDate';
  fnI_TherapyDate   = 'TDate';
  fnI_Modality      = 'Modality';
  fnI_CodeStatus    = 'CodeStatus';
  fnI_Nephrologist  = 'Nephrologist';
  fnI_Mon           = 'Mon';
  fnI_Tue           = 'Tue';
  fnI_Wed           = 'Wed';
  fnI_Thu           = 'Thu';
  fnI_Fri           = 'Fri';
  fnI_Sat           = 'Sat';
  fnI_Sun           = 'Sun';
  fnI_AD            = 'AdvancedD';
  fnI_LastOpened    = 'LastOpened';
  fnI_LastUser      = 'LastUser';
  fnI_BStatus       = 'BStatus';
  fnI_BDate         = 'BDate';
  fnI_BBy           = 'BBy';

implementation

uses
  uMDK_CDSCommon, uMDK_Common;

procedure CreateInfoDS(aCDS: TClientDataSet);
begin
  try
    NewStringField(aCDS, fnI_PatientID, 'PatientID', 8, 20); // String;
    NewStringField(aCDS, fnI_StudyID, 'StudyID', 8, 20); // String;
    NewDateTimeField(aCDS, fnI_StudyDate, 'StudyDate', 16); // Date;
    NewStringField(aCDS, fnI_Diagnosis, 'Diagnosis', 8, 200); // String;
    NewDateTimeField(aCDS, fnI_DiagnosisDate, 'Diagnosis Date', 16); // Date;
    NewDateTimeField(aCDS, fnI_TherapyDate, 'Therapy Date', 16); // Date;
    NewStringField(aCDS, fnI_Modality, 'Modality', 12, 40);
    NewStringField(aCDS, fnI_CodeStatus, 'CodeStatus', 12, 40);
    NewStringField(aCDS, fnI_Nephrologist, 'Nephrologist', 12, 40);
    NewBooleanField(aCDS, fnI_AD, 'Advanced D');
    NewBooleanField(aCDS, fnI_Mon, 'Mon');
    NewBooleanField(aCDS, fnI_Tue, 'Tue');
    NewBooleanField(aCDS, fnI_Wed, 'Wed');
    NewBooleanField(aCDS, fnI_Thu, 'Thu');
    NewBooleanField(aCDS, fnI_Fri, 'Fri');
    NewBooleanField(aCDS, fnI_Sat, 'Sat');
    NewBooleanField(aCDS, fnI_Sun, 'Sun');
    NewStringField(aCDS, fnI_LastOpened, 'Last Opened', 20, 40);
    NewStringField(aCDS, fnI_LastUser, 'Last User', 30, 40);
    NewStringField(aCDS, fnI_BStatus, 'BStatus', 30, 40);
    NewStringField(aCDS, fnI_BDate, 'BStatus Date', 30, 40);
    NewStringField(aCDS, fnI_BBy, 'BStatus By', 30, 40);
    aCDS.CreateDataSet;
  except
  end;
end;

function getInfoRecord(aCDS: TClientDataSet): TMDK_Info;
var
  aR: TMDK_Info;
begin
  aR := nil;
  Result := nil;
  try
    try
      aCDS.First;
    except
    end;
    if not aCDS.Eof then begin
      aR := TMDK_Info.Create;
      aR.StudyDate := 0;
      aR.PatientID := aCDS.FieldByName(fnI_PatientID).AsString;
      aR.StudyID := aCDS.FieldByName(fnI_StudyID).AsString;
      aR.StudyDate := aCDS.FieldByName(fnI_StudyDate).AsDateTime;
      aR.Diagnosis := aCDS.FieldByName(fnI_Diagnosis).AsString;
      aR.DiagnosisDate := aCDS.FieldByName(fnI_DiagnosisDate).AsDateTime;
      aR.TherapyDate := aCDS.FieldByName(fnI_TherapyDate).AsDateTime;
      aR.Modality := aCDS.FieldByName(fnI_Modality).AsString;
      aR.CodeStatus := aCDS.FieldByName(fnI_CodeStatus).AsString;
      aR.Nephrologist := aCDS.FieldByName(fnI_Nephrologist).AsString;
      aR.AD := aCDS.FieldByName(fnI_AD).AsBoolean;
      aR.Mon := aCDS.FieldByName(fnI_Mon).AsBoolean;
      aR.Tue := aCDS.FieldByName(fnI_Tue).AsBoolean;
      aR.Wed := aCDS.FieldByName(fnI_Wed).AsBoolean;
      aR.Thu := aCDS.FieldByName(fnI_Thu).AsBoolean;
      aR.Fri := aCDS.FieldByName(fnI_Fri).AsBoolean;
      aR.Sat := aCDS.FieldByName(fnI_Sat).AsBoolean;
      aR.Sun := aCDS.FieldByName(fnI_Sun).AsBoolean;
      aR.Sun := aCDS.FieldByName(fnI_AD).AsBoolean;
    end;
    Result := aR;
  except
  end;
end;

procedure TMDK_Info.saveToCDS(aCDS: TClientDataSet);
begin
  try
    aCDS.Open;
  except
  end;
  if aCDS.Eof then begin
    aCDS.Insert;
  end else begin
    try
      aCDS.Edit;
    except
    end;
  end;
  aCDS.FieldByName(fnI_PatientID).AsString := PatientID;
  aCDS.FieldByName(fnI_StudyID).AsString := StudyID;
  aCDS.FieldByName(fnI_StudyDate).AsDateTime := StudyDate;
  aCDS.FieldByName(fnI_Diagnosis).AsString := Diagnosis;
  aCDS.FieldByName(fnI_DiagnosisDate).AsDateTime := DiagnosisDate;
  aCDS.FieldByName(fnI_TherapyDate).AsDateTime := TherapyDate;
  aCDS.FieldByName(fnI_Modality).AsString := Modality;
  aCDS.FieldByName(fnI_CodeStatus).AsString := CodeStatus;
  aCDS.FieldByName(fnI_Nephrologist).AsString := Nephrologist;
  aCDS.FieldByName(fnI_AD).AsBoolean := AD;
  aCDS.FieldByName(fnI_Mon).AsBoolean := Mon;
  aCDS.FieldByName(fnI_Tue).AsBoolean := Tue;
  aCDS.FieldByName(fnI_Wed).AsBoolean := Wed;
  aCDS.FieldByName(fnI_Thu).AsBoolean := Thu;
  aCDS.FieldByName(fnI_Fri).AsBoolean := Fri;
  aCDS.FieldByName(fnI_Sat).AsBoolean := Sat;
  aCDS.FieldByName(fnI_Sun).AsBoolean := Sun;
  aCDS.FieldByName(fnI_AD).AsBoolean := AD;
  try
    aCDS.Post;
  except
  end;
end;

function TMDK_Info.EqualTo(aValue: TMDK_Info): Boolean;
begin
  Result := (PatientID = aValue.PatientID) and // 'PatientID'
    (StudyID = aValue.StudyID) and             // 'StudyID'
    (StudyDate = aValue.StudyDate) and         // 'StudyDate'
    (Diagnosis = aValue.Diagnosis) and         // 'Diagnosis'
    (DiagnosisDate = aValue.DiagnosisDate) and // 'DDate'
    (TherapyDate = aValue.TherapyDate) and     // 'TDate'
    (Modality = aValue.Modality) and           // 'Modality'
    (CodeStatus = aValue.CodeStatus) and       // 'CodeStatus'
    (Nephrologist = aValue.Nephrologist) and   // 'Nephrologist'
    (AD = aValue.AD) and                       // 'AdvancedDirectives'
    (Mon = aValue.Mon) and                     // 'Mon'
    (Tue = aValue.Tue) and                     // 'Tue'
    (Wed = aValue.Wed) and                     // 'Wen'
    (Thu = aValue.Thu) and                     // 'Thu'
    (Fri = aValue.Fri) and                     // 'Fra'
    (Sat = aValue.Sat) and                     // 'Sat'
    (Sun = aValue.Sun);                        // 'Sun'
end;

procedure TMDK_Info.setEqualTo(aValue: TMDK_Info);
begin
  if aValue = nil then Exit;
  PatientID := aValue.PatientID;         // 'PatientID'
  StudyID := aValue.StudyID;             // 'StudyID'
  StudyDate := aValue.StudyDate;         // 'StudyDate'
  Diagnosis := aValue.Diagnosis;         // 'Diagnosis'
  DiagnosisDate := aValue.DiagnosisDate; // 'DDate'
  TherapyDate := aValue.TherapyDate;     // 'TDate'
  Modality := aValue.Modality;           // 'Modality'
  CodeStatus := aValue.CodeStatus;       // 'CodeStatus'
  Nephrologist := aValue.Nephrologist;   // 'Nephrologist'
  AD := aValue.AD;                       // 'AdvancedDirectives'
  Mon := aValue.Mon;                     // 'Mon'
  Tue := aValue.Tue;                     // 'Tue'
  Wed := aValue.Wed;                     // 'Wen'
  Thu := aValue.Thu;                     // 'Thu'
  Fri := aValue.Fri;                     // 'Fra'
  Sat := aValue.Sat;                     // 'Sat'
  Sun := aValue.Sun;                     // 'Sun'
end;

function TMDK_Info.Clone: TMDK_Info;
begin
  Result := TMDK_Info.Create;
  Result.PatientID := PatientID;         // 'PatientID'
  Result.StudyID := StudyID;             // 'StudyID'
  Result.StudyDate := StudyDate;         // 'StudyDate'
  Result.Diagnosis := Diagnosis;         // 'Diagnosis'
  Result.DiagnosisDate := DiagnosisDate; // 'DDate'
  Result.TherapyDate := TherapyDate;     // 'TDate'
  Result.Modality := Modality;           // 'Modality'
  Result.CodeStatus := CodeStatus;       // 'CodeStatus'
  Result.Nephrologist := Nephrologist;   // 'Nephrologist'
  Result.AD := AD;                       // 'AdvancedDirectives'
  Result.Mon := Mon;                     // 'Mon'
  Result.Tue := Tue;                     // 'Tue'
  Result.Wed := Wed;                     // 'Wen'
  Result.Thu := Thu;                     // 'Thu'
  Result.Fri := Fri;                     // 'Fra'
  Result.Sat := Sat;                     // 'Sat'
  Result.Sun := Sun;                     // 'Sun'
end;

function TMDK_Info.Description: string;
begin
  Result := '';
  try
    Result := ' Study: ' + StudyID + #13#10 + ' Diagnosis: ' + Diagnosis + #13#10 + ' Diagnosis Date : ' +
      FormatDateTime(gMDK_DateFMT, DiagnosisDate) + #13#10 + ' Modaluty: ' + Modality + #13#10 + ' Code Status: ' +
      CodeStatus + #13#10 + ' Nephrologist: ' + Nephrologist;
  except
    on E: Exception do Result := '';
  end;
end;

end.
