unit uMDK_SubmitHistory;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:38a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     SubmitHistorey CDS object
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects/uMDK_SubmitHistory.pas $
  *
  *       $ History: uMDK_SubmitHistory.pas $
}
interface

uses
  SysUtils, Classes, DBClient, DB;

procedure CreateSubmitHistoryDS(aCDS: TClientDataSet);
function AddSubmitHistoryRecord(aDS: TClientDataSet; aPatientId, aStudy, aDUZ, aDate: string): string;
procedure RestoreSubmtHistory(aDS: TClientDataSet; s: string);

const
  fnSH_PatientID  = 'PatientID';  // String;
  fnSH_StudyID    = 'StudyID';    // String;
  fnSH_SubmitDate = 'SubmitDate'; // String;
  fnSH_SubmitBy   = 'SubmitBy';   // String;

implementation

uses
  uMDK_CDSCommon, uMDK_Utils;

procedure CreateSubmitHistoryDS(aCDS: TClientDataSet);
begin
  try
    NewStringField(aCDS, fnSH_PatientID, 'PatientID', 8, 20); // String;
    NewStringField(aCDS, fnSH_StudyID, fnSH_StudyID, 8, 20); // String;
    NewStringField(aCDS, fnSH_SubmitBy, fnSH_SubmitBy, 8, 20); // String;
    NewDateTimeField(aCDS, fnSH_SubmitDate, fnSH_SubmitDate, 20, gMDK_DateTimeFMT); // TDateTime;
    aCDS.IndexFieldNames := fnSH_SubmitDate;
    aCDS.CreateDataSet;
  except
  end;
end;

function AddSubmitHistoryRecord(aDS: TClientDataSet; aPatientId, aStudy, aDUZ, aDate: string): string;
begin
  Result := '';
  if (trim(aPatientId) + trim(aStudy) + trim(aDUZ) + trim(aDate)) = '' then Exit;
  Result := '-1';
  try
    if not aDS.Active then aDS.Open;
    aDS.Insert;
    aDS.FieldByName(fnSH_PatientID).AsString := aPatientId;
    aDS.FieldByName(fnSH_StudyID).AsString := aStudy;
    aDS.FieldByName(fnSH_SubmitBy).AsString := aDUZ;
    aDS.FieldByName(fnSH_SubmitDate).AsString := aDate;
    aDS.Post;
  except
    Exit;
  end;
  Result := '';
end;

procedure RestoreSubmtHistory(aDS: TClientDataSet; s: string);
begin
  if aDS.Active then aDS.Close;
  aDS.Fields.Clear;
  CreateSubmitHistoryDS(aDS);
  try
    aDS.Open;
  except
  end;
end;

end.
