unit uMDK_VitalsAgent;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:38a $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     vitals agent
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects/uMDK_VitalsAgent.pas $
  *
  *       $ History: uMDK_VitalsAgent.pas $
}
interface

uses
  Classes, Sysutils, iMDK_VitalsQualifiers, oDBController_Renal;

type
  TMDK_VitalsAgent = class(TInterfacedObject, I_Vitals)
  private
    fRenalController: TDBController_Renal;
  public
    constructor CreateByRenalController(aController: TDBController_Renal);
    function getQualifiersByVitalType(aTypeIEN: string): string;
    function getQualifiersAll: string;
    function getVitalTypesAll: string;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
  end;

implementation

constructor TMDK_VitalsAgent.CreateByRenalController(aController: TDBController_Renal);
begin
  inherited;
  fRenalController := aController;
end;

function TMDK_VitalsAgent.getQualifiersByVitalType(aTypeIEN: string): string;
begin
  Result := fRenalController.getQualifiersByVitalType(aTypeIEN);
end;

function TMDK_VitalsAgent.getQualifiersAll: string;
begin
  Result := fRenalController.getQualifiersAll;
end;

function TMDK_VitalsAgent.getVitalTypesAll: string;
begin
  Result := fRenalController.getVitalTypesAll;
end;

function TMDK_VitalsAgent._AddRef: Integer;
begin
  Result := -1;
end;

function TMDK_VitalsAgent._Release: Integer;
begin
  Result := -1;
end;

end.
