unit uMDK_GeneralInfoCollector;

interface

uses
  iMDK_Assessment, Forms, Controls, Windows;

type
  TSrvGeneralInfoCollector = class(TInterfacedObject, I_Assessment)
  public
    function getAssessmentText: string;
    function updateAssessmentText(aText: string): string;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
  end;

function NewSrvGeneralInfoCollector: TSrvGeneralInfoCollector;

implementation

uses
  dMDK_Data, fMDK_GeneralInfoDLG, uMDK_Info, uMDK_Summary;

function NewSrvGeneralInfoCollector: TSrvGeneralInfoCollector;
begin
  Result := TSrvGeneralInfoCollector.Create;
end;
/// /////////////////////////////////////////////////////////////////////////////

function TSrvGeneralInfoCollector._AddRef;
begin
  Result := -1;
end;

function TSrvGeneralInfoCollector._Release;
begin
  Result := -1;
end;

function TSrvGeneralInfoCollector.getAssessmentText: string;
  function getGeneralInfoReport: string;
  var
    ss, s: string;
  const
    _B = '<';
    _E = '>';
    _T = Char(VK_TAB);
  begin
    Result := '';
    s := '';
    with dmData do begin
      s := s + 'Current Treatment Date: ' + _T + _B + cdsInfo.FieldByName(fnI_StudyDate).AsString + _E + #13#10;
      s := s + 'Diagnosis:' + _T + _T + _B + cdsInfo.FieldByName(fnI_Diagnosis).AsString + _E + #13#10;
      s := s + 'Diagnosis Date:' + _T + _T + _B + cdsInfo.FieldByName(fnI_DiagnosisDate).AsString + _E + #13#10;
      s := s + 'Initial Therapy Date:' + _T + _T + _B + cdsInfo.FieldByName(fnI_TherapyDate).AsString + _E + #13#10;
      s := s + 'Modalities:' + _T + _T + _B + cdsInfo.FieldByName(fnI_Modality).AsString + _E + #13#10;
      s := s + 'Code Status:' + _T + _T + _B + cdsInfo.FieldByName(fnI_CodeStatus).AsString + _E + #13#10;
      s := s + 'Attending Nephrologist:' + _T + _B + cdsInfo.FieldByName(fnI_Nephrologist).AsString + _E + #13#10;
      s := s + 'Visit Schedule:';
      ss := '';
      if cdsInfo.FieldByName(fnI_Mon).AsBoolean then ss := ss + 'Monday,';
      if cdsInfo.FieldByName(fnI_Tue).AsBoolean then ss := ss + ' Tuesday,';
      if cdsInfo.FieldByName(fnI_Wed).AsBoolean then ss := ss + ' Wednesday,';
      if cdsInfo.FieldByName(fnI_Thu).AsBoolean then ss := ss + ' Thursday,';
      if cdsInfo.FieldByName(fnI_Fri).AsBoolean then ss := ss + ' Friday,';
      if cdsInfo.FieldByName(fnI_Sat).AsBoolean then ss := ss + ' Saturday,';
      if cdsInfo.FieldByName(fnI_Sun).AsBoolean then ss := ss + 'Sunday,';
      if ss <> '' then begin
        ss := copy(ss, 1, Length(ss) - 1);
        ss := _T + _T + _B + ss + _E;
      end;
      s := s + ss + #13#10;
      s := s + 'Transplant status:';
      if not cdsSummary.FieldByName(fnS_TrnCandidate).AsBoolean then
          s := s + _T + _T + _B + 'Non Candidate' + _E + #13#10
      else begin
        s := s + _T + _T + _B + 'Candidate' + _E + #13#10;
        if cdsSummary.FieldByName(fnS_TrnWIP).AsBoolean then
            s := s + _T + _T + _T + _B + 'Work in progress' + _E + #13#10;
        if cdsSummary.FieldByName(fnS_TrnReferred).AsBoolean then
            s := s + _T + _T + _T + _B + 'Referred to Transplant Center' + _E + #13#10;
      end;
    end;
    Result := s;
  end;

begin
  Result := { dmData. } getGeneralInfoReport;
end;

function TSrvGeneralInfoCollector.updateAssessmentText(aText: string): string;
var
  i: Integer;
begin
  Result := aText;
  i := UpdateGeneralInfoData;
  if i <> mrCancel then Result := getAssessmentText;
end;

end.
