unit fMDK_Access;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 4/03/08 1:09p $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  Contains the Application Access form
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Tabs/fMDK_Access.pas $
  *
  *       $ History: fMDK_Access.pas $
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Grids, DBGrids, ActnList, ImgList,
  Buttons, DBCtrls, DBClient, Mask, uMDK_CDSCommon, DB, Menus, frMDK_Comments, uMDK_VASite, System.Actions;

type
  TfrmAccess = class(TForm)
    pnlAccess: TPanel;
    pnlSilteList: TPanel;
    pnlSiteListToolbar: TPanel;
    pnlAccessList: TPanel;
    tvAccess: TTreeView;
    imglstAccess: TImageList;
    ActionList1: TActionList;
    acVASiteAdd: TAction;
    acVASiteSelect: TAction;
    acVASiteRemove: TAction;
    acAssessRecordAdd: TAction;
    acAssessRecordRemove: TAction;
    acInfecrtionRecordAdd: TAction;
    acInfectionRecordRemove: TAction;
    pnlDetails: TPanel;
    pnlSiteInfo: TPanel;
    pnlCurrent: TPanel;
    pnlTest: TPanel;
    pnlCathTreatment: TPanel;
    ckbTT: TCheckBox;
    pnlInfection: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    dtpInfection: TDateTimePicker;
    edInfection: TEdit;
    pnlFistula: TPanel;
    Panel93: TPanel;
    Label475: TLabel;
    Panel92: TPanel;
    Label474: TLabel;
    rbAVBruit: TRadioButton;
    rbAVBruit1: TRadioButton;
    Panel99: TPanel;
    lbMature: TLabel;
    rbAVmature: TRadioButton;
    rbAVmature1: TRadioButton;
    Panel100: TPanel;
    lblInf: TLabel;
    rbAVInfiltrated: TRadioButton;
    rbAVInfiltrated1: TRadioButton;
    pnlAssessStatus: TPanel;
    cbAVAssessed: TCheckBox;
    cbSelected: TCheckBox;
    pnlHistory: TPanel;
    mmComments: TMemo;
    mmHistory: TRichEdit;
    rbAVThrill: TRadioButton;
    rbAVThrill1: TRadioButton;
    pnlLegend: TPanel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    acLegend: TAction;
    PopupMenu1: TPopupMenu;
    ShowHideLegend1: TMenuItem;
    AddSite1: TMenuItem;
    Remove1: TMenuItem;
    Select1: TMenuItem;
    N1: TMenuItem;
    cbInfection: TCheckBox;
    pnlSelectedSiteToolbar: TPanel;
    Panel1: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Bevel2: TBevel;
    FrameMDK_Comments: TFrameMDK_Comments;
    pnlHistoryToolbar: TPanel;
    lblHistoryTitle: TLabel;
    pnlCurrentStatusToolbar: TPanel;
    lblCurrentSiteStatus: TLabel;
    pnlSiteActions: TPanel;
    lblAccessStatus: TLabel;
    Label16: TLabel;
    SpeedButton3: TSpeedButton;
    Panel3: TPanel;
    Label13: TLabel;
    lblTypeName: TLabel;
    Label467: TLabel;
    Label468: TLabel;
    Label470: TLabel;
    lblAVFacility0: TLabel;
    dbtLocation: TDBText;
    dbtPlacedDate: TDBText;
    dbtPlacedby: TDBText;
    dbtFacility: TDBText;
    Label8: TLabel;
    Label11: TLabel;
    Label10: TLabel;
    Label9: TLabel;
    dbtRemoved: TDBText;
    dbtReason: TDBText;
    dbtRemovedBy: TDBText;
    dbtRFacility: TDBText;
    pnlVASiteRemove2d: TPanel;
    SpeedButton4: TSpeedButton;
    pnlSiteListActions: TPanel;
    SpeedButton2: TSpeedButton;
    ActionList2: TActionList;
    acMoveComments: TAction;
    acShowOldComments: TAction;
    pnlCommentsFix: TPanel;
    acVerify: TAction;
    SpeedButton1: TSpeedButton;
    spbSHowOldComments: TSpeedButton;
    spbUpdateOldComments: TSpeedButton;
    acReport: TAction;
    SpeedButton5: TSpeedButton;
    ds: TDataSource;
    cdsAccessNotes: TClientDataSet;
    DBGrid1: TDBGrid;
    Panel4: TPanel;
    mnMain: TMainMenu;
    Comments1: TMenuItem;
    Edit2: TMenuItem;
    New1: TMenuItem;
    Edit1: TMenuItem;
    Delete1: TMenuItem;
    Refresh1: TMenuItem;
    Remove2: TMenuItem;
    Select2: TMenuItem;
    Add1: TMenuItem;
    mniComments: TMenuItem;
    N2: TMenuItem;
    Refresh2: TMenuItem;
    pnlRemove3D: TPanel;
    BitBtn1: TBitBtn;
    pnlSiteSelect3D: TPanel;
    BitBtn2: TBitBtn;
    pnlVASiteAdd3d: TPanel;
    BitBtn3: TBitBtn;
    procedure acVASiteAddExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbAVAssessedClick(Sender: TObject);
    procedure tvAccessChange(Sender: TObject; Node: TTreeNode);
    procedure FormCreate(Sender: TObject);
    procedure acVASiteSelectExecute(Sender: TObject);
    procedure acVASiteRemoveExecute(Sender: TObject);
    procedure cbSelectedClick(Sender: TObject);
    procedure rbAVThrillClick(Sender: TObject);
    procedure rbAVBruitClick(Sender: TObject);
    procedure rbAVmatureClick(Sender: TObject);
    procedure rbAVInfiltratedClick(Sender: TObject);
    procedure mmCommentsChange(Sender: TObject);
    procedure edInfectionChange(Sender: TObject);
    procedure dtpInfectionChange(Sender: TObject);
    procedure tvAccessDblClick(Sender: TObject);
    procedure ckbTTClick(Sender: TObject);
    procedure acLegendExecute(Sender: TObject);
    procedure cbInfectionClick(Sender: TObject);
    procedure acShowOldCommentsExecute(Sender: TObject);
    procedure acMoveCommentsExecute(Sender: TObject);
    procedure acVerifyExecute(Sender: TObject);
    procedure acReportExecute(Sender: TObject);
  private
    { Private declarations }
    fReadOnly: Boolean;
    fIgnore: Boolean;
    fAssessDataSaved: Boolean;
    fInfectionDataSaved: Boolean;
    fCurrentItemID: string;
    fStudyID: string;
    fPatientID, fOperator: string;
    fVAP, fVAPH, fVAPIH: TClientDataSet;
    fRoot: TTreeNode;
    fReportEvent: TReportEvent;
    procedure setStudyID(anID: string);
    procedure setCurrentSiteControlStatus(aValue: Boolean);
    procedure SelectSite(aValue: Boolean);
    procedure ReportEvent(anEventType, aDescription: string);
    procedure CleanUpTree;
    procedure CleanUpNode(aNode: TTreeNode);
    function getRoot: TTreeNode;
    function getNodeReport(aNode: TTreeNode; ShowComments: Boolean = true): string;
    function getNodeTitle(aNode: TTreeNode): string;
    procedure PaintSyntax(aStart, anEnd: string; aColor: TColor);
    procedure setReadOnly(aReadOnly: Boolean);
    procedure saveSiteData(aSite: TVASite);
    procedure setCurrentItemID(anItemID: string);
  public
    { Public declarations }
    property CurrentItemID: string read fCurrentItemID write setCurrentItemID;
    property OperatorID: string read fOperator write fOperator;
    property StudyID: string read fStudyID write setStudyID;
    property PatientID: string read fPatientID write fPatientID;
    property Ignore: Boolean read fIgnore write fIgnore;
    property VAP: TClientDataSet read fVAP write fVAP;
    property VAPH: TClientDataSet read fVAPH write fVAPH;
    property VAPIH: TClientDataSet read fVAPIH write fVAPIH;
    property Root: TTreeNode read getRoot;
    property AccessReadOnly: Boolean read fReadOnly write setReadOnly;
    procedure LoadPatientData;
    procedure SavePatientData;
    function AssessReport: string;
    procedure AssessPointsReport(aRE: TRichEdit = nil; aDelim: string = ':'; aColor: TColor = clNavy);
    procedure ReportStatus;
    procedure ReloadData;
    procedure setupGUI;
    procedure updateGUI;
    function Verify: string;
    procedure ActivateTabForm;
    procedure setActionStatus;
    function getMainMenu: TMainMenu;
  end;

var
  frmAccess: TfrmAccess;

implementation

uses
  fMDK_VAAdd, System.UITypes, fMDK_VADelete, uMDK_VADataSet, uMDK_Common, uMDK_Options, uMDK_Engine, uMDK_ReportEngine,
  dMDK_Data, uMDK_Notes, fMDK_Info;

{$R *.dfm}
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmAccess.FormCreate(Sender: TObject);
begin
  CreateNoteListCDS(cdsAccessNotes);
  setupGUI;
  fIgnore := False;
  fAssessDataSaved := False;
  fInfectionDataSaved := False;
end;

procedure TfrmAccess.setupGUI;
  procedure SetUpTextField(aField: TDBText; aName: string);
  begin
    if aField.DataField <> '' then Exit;
    aField.DataField := aName;
  end;

begin
  dtpInfection.MinDate := 0;
  dtpInfection.MaxDate := Now + 0.1;
  dtpInfection.Date := Now; // zzzzzzandria 050322
  try
    SetUpTextField(dbtPlacedDate, fnSite_PlacedDate);
    SetUpTextField(dbtPlacedby, fnSite_PlacedBy);
    SetUpTextField(dbtFacility, fnSite_PlacedAt);
    SetUpTextField(dbtLocation, fnSite_Location);
    SetUpTextField(dbtReason, fnSite_RREason);
    SetUpTextField(dbtRFacility, fnSite_RemovedAt);
    SetUpTextField(dbtRemoved, fnSite_RemovedDate);
    SetUpTextField(dbtRemovedBy, fnSite_RemovedBy);
  except
  end;
  FrameMDK_Comments.setUpCanvas(Engine.NoteList_CDS, pnAccess);
end;

procedure TfrmAccess.ReportEvent(anEventType, aDescription: string);
begin
  if Assigned(fReportEvent) then fReportEvent(anEventType, aDescription);
end;

procedure TfrmAccess.setStudyID(anID: string);
begin
  fStudyID := '';
  if anID = '' then ReportEvent(rtWarning, 'Blank study ID')
  else fStudyID := anID;
end;

function TfrmAccess.getRoot: TTreeNode;
begin
  if fRoot = nil then fRoot := tvAccess.Items.AddChild(nil, 'Vascular Access Point(s)');
  Result := fRoot;
end;

// ACTIONS ////////////////////////////////////////////////////////////////////

procedure TfrmAccess.acLegendExecute(Sender: TObject);
begin
  pnlLegend.Visible := not pnlLegend.Visible;
end;

procedure TfrmAccess.acVASiteAddExecute(Sender: TObject);
var
  aSite: TVASite;
  tn: TTreeNode;
begin
  aSite := NewAccessSite(PatientID, OperatorID);
  if aSite = nil then Exit;
  if addSiteRecord(fVAP, aSite) then begin
    ReportEvent(etVASiteNew, aSite.Description);
    tn := tvAccess.Items.AddChildObject(Root, SiteTypeNameByType(aSite.AccessType) + ':  ' + aSite.Location, aSite);
    tn.StateIndex := apImageOpened;
    tvAccess.Selected := tn;
    acVASiteRemove.Enabled := true;
    mniComments.Enabled := true;
  end
  else ReportEvent(etVASiteNewFailed, aSite.Description);
end;

procedure TfrmAccess.acVASiteRemoveExecute(Sender: TObject);
var
  aSite: TVASite;
begin
  if not Assigned(tvAccess.Selected.Data) then Exit;
  aSite := TVASite(tvAccess.Selected.Data);
  if RemoveAccessSite(aSite, OperatorID) then begin
    tvAccess.Selected.StateIndex := apImageClosed;
    try
      fVAP.Edit;
      fVAP.FieldByName(fnSite_Status).AsString := SiteStatusNameByStatus(asRemoved);
      fVAP.FieldByName(fnSite_RemovedAt).AsString := aSite.RemovalFacility;
      fVAP.FieldByName(fnSite_RRegisteredBy).AsString := aSite.RemovalRegisteredBy;
      fVAP.FieldByName(fnSite_RREason).AsString := aSite.RemovalReason;
      fVAP.FieldByName(fnSite_RemovedBy).AsString := aSite.RemovalSurgeon;
      fVAP.FieldByName(fnSite_RemovedDate).AsDateTime := aSite.RemovalDate;
      fVAP.Post;
      ReportEvent(etVASiteRemoved, aSite.Description);
      tvAccess.Selected.StateIndex := apImageClosed;
      dbtRemoved.Visible := true; // !!
      setCurrentSiteControlStatus(False);
      cbAVAssessed.Enabled := False;
      cbSelected.Enabled := False;
      cbInfection.Enabled := False;
      acVASiteRemove.Enabled := False;
      acVASiteSelect.Enabled := False;
    except
      ReportEvent(etVASiteRemovedFailed, aSite.Description);
    end;
  end;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmAccess.tvAccessChange(Sender: TObject; Node: TTreeNode);
var
  aSite: TVASite;
  InfectionDateTime: TDateTime;
  procedure SetRB(TheSite: TVASite);
  begin
    fIgnore := true;
    try
      rbAVBruit.Checked := TheSite.AssessData.APH_Bruit;
      rbAVThrill.Checked := TheSite.AssessData.APH_Thrill;
      rbAVmature.Checked := TheSite.AssessData.APH_Mature;
      rbAVInfiltrated.Checked := TheSite.AssessData.APH_Infiltrated;
      rbAVBruit1.Checked := not TheSite.AssessData.APH_Bruit;
      rbAVThrill1.Checked := not TheSite.AssessData.APH_Thrill;
      rbAVmature1.Checked := not TheSite.AssessData.APH_Mature;
      rbAVInfiltrated1.Checked := not TheSite.AssessData.APH_Infiltrated;
    except
      rbAVBruit.Checked := False;
      rbAVThrill.Checked := False;
      rbAVmature.Checked := False;
      rbAVInfiltrated.Checked := False;
      rbAVBruit1.Checked := true;
      rbAVThrill1.Checked := true;
      rbAVmature1.Checked := true;
      rbAVInfiltrated1.Checked := true;
    end;
    fIgnore := False;
  end;
  procedure SetHistory(aSiteHR: TVASiteHistoryRecord);
  begin
    fIgnore := true;
    try
      rbAVBruit.Checked := aSiteHR.APH_Bruit;
      rbAVThrill.Checked := aSiteHR.APH_Thrill;
      rbAVmature.Checked := aSiteHR.APH_Mature;
      rbAVInfiltrated.Checked := aSiteHR.APH_Infiltrated;
      rbAVBruit1.Checked := not aSiteHR.APH_Bruit;
      rbAVThrill1.Checked := not aSiteHR.APH_Thrill;
      rbAVmature1.Checked := not aSiteHR.APH_Mature;
      rbAVInfiltrated1.Checked := not aSiteHR.APH_Infiltrated;
    except
    end;
    fIgnore := False;
  end;
  procedure SetPanels(TheSite: TVASite);
  begin
    SetRB(TheSite);
    pnlSiteInfo.Visible := true;
    pnlCurrent.Visible := aSite.Status <> asRemoved;
    pnlHistory.Visible := aSite.Status = asRemoved;
    fIgnore := true;
    case TheSite.AccessType of
      atFistula: begin
          pnlFistula.Visible := true;
          pnlFistula.Enabled := true;
          pnlInfection.Visible := False;
          pnlCathTreatment.Visible := False;
        end;
      atGraft: begin
          pnlFistula.Visible := true;
          pnlFistula.Enabled := true;
          pnlInfection.Visible := False;
          pnlCathTreatment.Visible := False;
        end;
      atTunneled: begin
          pnlFistula.Visible := False;
          if pnlCathTreatment.Visible then begin
            pnlCathTreatment.Align := alBottom;
            pnlCathTreatment.Visible := False;
            pnlCurrent.Invalidate;
            Application.ProcessMessages;
          end;
          pnlInfection.Visible := true;
          pnlCathTreatment.Visible := true;
          pnlCathTreatment.Align := alTop;
        end;
      atTmpCatheter: begin
          pnlFistula.Visible := False;
          pnlInfection.Visible := False;
          pnlCathTreatment.Visible := true;
        end;
    end;
    fIgnore := False;
  end;
  procedure setUpRoot(aNote: TTreeNode);
  begin
  end;
  procedure setUpSiteNode(aNote: TTreeNode);
  begin
  end;
  procedure setUpHistoryNode(aNote: TTreeNode);
  begin
  end;
  procedure setUpInfectionNode(aNote: TTreeNode);
  begin
  end;
  procedure ProcessEmptyNode;
    procedure ShowFistulaGraftNodeHistory(TheNode: TTreeNode);
    var
      _tn: TTreeNode;
    begin
      _tn := TheNode.getFirstChild;
      if _tn <> nil then mmHistory.Lines.Text := mmHistory.Lines.Text + getNodeTitle(_tn);
      while _tn <> nil do begin
        mmHistory.Lines.Text := mmHistory.Lines.Text + getNodeReport(_tn, False);
        _tn := _tn.getNextSibling;
      end;
    end;
    procedure ShowTunneledNodeHistory(TheNode: TTreeNode);
    var
      _tn: TTreeNode;
    begin
      _tn := TheNode.getFirstChild;
      if TObject(_tn.Data).ClassName = 'TVASiteHistoryRecord' then begin
        while _tn <> nil do begin
          mmHistory.Lines.Text := mmHistory.Lines.Text + TVASiteHistoryRecord(_tn.Data).getTreatmentLine(False);
          _tn := _tn.getNextSibling;
        end;
      end;
    end;
    procedure ShowTmpNodeHistory(TheNode: TTreeNode);
    begin
      ShowTunneledNodeHistory(TheNode);
    end;

  begin
    pnlCurrent.Visible := False;
    pnlHistory.Visible := true;
    FrameMDK_Comments.Visible := False;
    if Node.Parent = nil then // the root node
    begin
      AssessPointsReport;
      lblAccessStatus.Caption := 'Access Summary';
      pnlSiteInfo.Visible := False; // False; To be able to add a new site
      lblHistoryTitle.Caption := 'Access Points Summary';
    end else begin // History Node
      lblTypeName.Caption := SiteTypeNameByType(TVASite(Node.Parent.Data).AccessType);
      mmHistory.Lines.Text := #13 + 'To see the comments select the date node of the tree' + #13#13;
      aSite := TVASite(Node.Parent.Data);
      case aSite.AccessType of
        atFistula, atGraft: ShowFistulaGraftNodeHistory(Node);
        atTunneled: ShowTunneledNodeHistory(Node);
        atTmpCatheter: ShowTmpNodeHistory(Node);
      end;
      lblHistoryTitle.Caption := 'History Summary';
      lblAccessStatus.Caption := 'Access Site Detail';
      pnlSiteInfo.Visible := true;
      PaintSyntax(sBB, sBE, clNavy);
    end;
  end;
  procedure ProcessSiteNode;
  var
    i: Integer;
  begin
    aSite := TVASite(Node.Data);
    CurrentItemID := aSite.ID;
    StudyID := fStudyID;
    FrameMDK_Comments.setUpCanvas(Engine.NoteList_CDS, pnAccess);
    FrameMDK_Comments.Visible := true;
    lblAccessStatus.Caption := 'Access Site Details';
    lblTypeName.Caption := SiteTypeNameByType(aSite.AccessType);
    if aSite.Status <> asRemoved then begin
      dbtRemoved.Visible := aSite.RemovalDate > 1; // patch
      cbAVAssessed.Visible := true;
      cbAVAssessed.Enabled := true;
      acVASiteSelect.Enabled := aSite.Assessed; // True;  //zzzzzzandria 2007-07-02 build 312 #25
      acVASiteRemove.Enabled := not aSite.Selected;
    end else begin
      dbtRemoved.Visible := true;
      cbAVAssessed.Visible := False;
      acVASiteSelect.Enabled := False;
      acVASiteRemove.Enabled := False;
      mmHistory.Lines.Text := TVASite(Node.Data).Description;
      PaintSyntax(sBB, sBE, clNavy);
    end;
    SetPanels(aSite);
    fIgnore := true;
    cbAVAssessed.Checked := aSite.Assessed;
    cbSelected.Checked := aSite.Selected;
    mmComments.Text := aSite.AssessData.APH_Comments;
    Verify;
    try
      dtpInfection.MinDate := 0;
      dtpInfection.MaxDate := Now + 0.1;
      dtpInfection.MinDate := Round(aSite.PlacedDate) - 1.0;
    except
    end;
    InfectionDateTime := Now;
    if Assigned(aSite.InfectionData) then
      try
        edInfection.Text := aSite.InfectionData.APIH_Infection;
        cbInfection.Checked := edInfection.Text <> ''; // zzzzzzandria 051006
        if aSite.InfectionData.APIH_InfectionDateTime > 0 then
            InfectionDateTime := aSite.InfectionData.APIH_InfectionDateTime;
        try
          dtpInfection.Date := InfectionDateTime;
        except
          on E: Exception do MessageDLG(E.Message, mtWarning, [mbOK], 0);
        end;
      except
      end;
    ckbTT.Checked := aSite.AssessData.APH_TTreatment;
    fIgnore := False;
    try
      if fVAP.Locate('ID', aSite.ID, []) then setCurrentSiteControlStatus(aSite.Assessed);
    except
    end;
    // Filter notes based on TabName and SiteID
    // reset Comments frame
    FrameMDK_Comments.ItemTag := fCurrentItemID;
    for i := 0 to Engine.NoteList_CDS.Fields.Count - 1 do
      if Engine.NoteList_CDS.Fields[i].FieldName = fnNL_ItemID then break;
    if i < Engine.NoteList_CDS.Fields.Count then
      try
        Engine.NoteList_CDS.Filtered := False;
        Engine.NoteList_CDS.Filter := fnNL_Tag + '=''' + pnAccess + '''' + ' and ' + fnNL_ItemID + '=''' + CurrentItemID
          + '''' + ' and ' + fnNL_StudyID + '=''' + fStudyID + '''';
        Engine.NoteList_CDS.Filtered := true;
        FrameMDK_Comments.CleanSBX;
        FrameMDK_Comments.ResetSBX;
      except
      end;
  end;
  procedure ProcessHistoryNode;
  var
    i: Integer;
    sNodeID, sStudyID, sHistory: string;
  begin
    FrameMDK_Comments.Visible := true;
    aSite := TVASite(Node.Parent.Parent.Data);
    CurrentItemID := aSite.ID;
    pnlSiteInfo.Visible := true;
    pnlHistory.Visible := true;
    pnlCurrent.Visible := False;
    lblTypeName.Caption := SiteTypeNameByType(aSite.AccessType);
    lblAccessStatus.Caption := 'Access Site Detail';
    lblHistoryTitle.Caption := 'History Details'
{$IFDEF AANTEST}
      + ' -- ' + TVASiteHistoryRecord(Node.Data).APH_SessionID + '  ' + CurrentItemID
{$ENDIF}
      ;
    mmHistory.Lines.Text := '';
    case aSite.AccessType of
      atFistula, atGraft: begin
          mmHistory.Lines.Text := mmHistory.Lines.Text + getNodeTitle(Node);
          mmHistory.Lines.Text := mmHistory.Lines.Text + getNodeReport(Node);
        end;
    else mmHistory.Lines.Text := TVASiteHistoryRecord(Node.Data).getTreatmentLine;
    end;
    PaintSyntax(sBB, sBE, clNavy);
    dmData.cdsAPHistory.Locate(fnNL_ID + ';' + fnNL_StudyID,
      varArrayof([TVASiteHistoryRecord(Node.Data).APH_ID, TVASiteHistoryRecord(Node.Data).APH_SessionID]), []);
    // getNotesByStudyID
    FrameMDK_Comments.CleanSBX;
    if Engine.fRenalController.GetStudyItem('704.202', '.5', TVASiteHistoryRecord(Node.Data).APH_SessionID, sHistory)
    then begin
      if pos('-1', sHistory) <> 1 then begin
        sHistory := copy(sHistory, 1, Length(sHistory) - 2);
        mmComments.Text := sHistory;
        try
          CDSInitByString(cdsAccessNotes, sHistory);
        except
        end;
        FrameMDK_Comments.setUpCanvas(cdsAccessNotes, pnAccess);
        // filterNotes based on siteID and StudyID
        // reset Comments frame based on notes history or Update History report
        fCurrentItemID := fnNL_ID;
        FrameMDK_Comments.ItemTag := fCurrentItemID;
        for i := 0 to cdsAccessNotes.Fields.Count - 1 do
          if cdsAccessNotes.Fields[i].FieldName = fnNL_ItemID then break;
        if i < cdsAccessNotes.Fields.Count then
          try
            sNodeID := TVASiteHistoryRecord(Node.Data).APH_ID;
            sStudyID := TVASiteHistoryRecord(Node.Data).APH_SessionID;
            cdsAccessNotes.Filtered := False;
            cdsAccessNotes.Filter := fnNL_Tag + '=''' + pnAccess + '''' + ' and ' + fnNL_ItemID + '=''' + sNodeID + ''''
              + ' and ' + fnNL_StudyID + '=''' + sStudyID + '''';
            cdsAccessNotes.Filtered := true;
            FrameMDK_Comments.CleanSBX;
            FrameMDK_Comments.ResetSBX;
          except
          end;
        /// /
      end;
    end;
    FrameMDK_Comments.ReadOnly := true;
  end;
  procedure processInfectionNode;
  begin
    pnlSiteInfo.Visible := true;
    FrameMDK_Comments.Visible := true;
    lblAccessStatus.Caption := 'Access Site Detail';
    cbAVAssessed.Visible := False;
    mmHistory.Lines.Text := TVASiteInfectionRecord(Node.Data).Description;
    pnlHistory.Visible := true;
    pnlCurrent.Visible := False;
    PaintSyntax(sBB, sBE, clNavy);
  end;
  procedure RefreshGUI;
  var
    i: Integer;
    iHeight: Integer;
  begin
    if pnlCurrent.Visible then begin
      iHeight := 0;
      for i := 0 to pnlCurrent.ComponentCount - 1 do
        if pnlCurrent.Components[i] is TPanel then
          if TPanel(pnlCurrent.Components[i]).Visible then iHeight := iHeight + TPanel(pnlCurrent.Components[i]).Height;
      pnlCurrent.Height := iHeight;
    end;
    setReadOnly(Engine.CurrentPatient.ReadOnly);
  end;

begin
  fIgnore := true;
  cbAVAssessed.Enabled := False;
  fIgnore := False;
  lblTypeName.Caption := '  ';
  fCurrentItemID := '';
  if tvAccess.Items.Count < 1 then Exit;
  acVASiteSelect.Enabled := False;
  acVASiteRemove.Enabled := False;
  pnlFistula.Enabled := False;
  setCurrentSiteControlStatus(False); // disable everything on the pnlCurrent
  if not Assigned(Node.Data) then ProcessEmptyNode
  else if TObject(Node.Data).ClassName = 'TVASite' then ProcessSiteNode
  else if TObject(Node.Data).ClassName = 'TVASiteHistoryRecord' then ProcessHistoryNode
  else if TObject(Node.Data).ClassName = 'TVASiteInfectionRecord' then processInfectionNode;
  RefreshGUI;
  if Assigned(Node.Data) then begin
    if (TObject(Node.Data).ClassName = 'TVASiteHistoryRecord') then FrameMDK_Comments.ReadOnly := true
    else FrameMDK_Comments.acAdd.Enabled := not Engine.CurrentPatient.ReadOnly;
  end;
end;

// CONTROLS ///////////////////////////////////////////////////////////////////

procedure TfrmAccess.setCurrentSiteControlStatus(aValue: Boolean);
begin
  cbSelected.Enabled := aValue;
  cbInfection.Enabled := aValue;
  ckbTT.Enabled := aValue;
  rbAVThrill.Enabled := aValue;
  rbAVThrill1.Enabled := aValue;
  rbAVBruit.Enabled := aValue;
  rbAVBruit1.Enabled := aValue;
  rbAVmature.Enabled := aValue;
  rbAVmature1.Enabled := aValue;
  rbAVInfiltrated.Enabled := aValue;
  rbAVInfiltrated1.Enabled := aValue;
  if not aValue then cbInfection.Checked := False;
  edInfection.Enabled := aValue and cbInfection.Checked;
  dtpInfection.Enabled := aValue and cbInfection.Checked;
  if aValue then begin
    mmComments.Color := clWindow;
    if cbInfection.Checked then begin
      edInfection.Color := clWindow;
      dtpInfection.Color := clWindow;
    end else begin
      edInfection.Color := Preferences.iValue(onReadOnlyFieldColor);
      dtpInfection.Color := Preferences.iValue(onReadOnlyFieldColor);
    end;
  end else begin
    mmComments.Color := Preferences.iValue(onReadOnlyFieldColor);
    edInfection.Color := Preferences.iValue(onReadOnlyFieldColor);
    dtpInfection.Color := Preferences.iValue(onReadOnlyFieldColor);
  end;
end;

procedure TfrmAccess.cbAVAssessedClick(Sender: TObject);
begin
  if fIgnore then Exit;
  TVASite(tvAccess.Selected.Data).Assessed := cbAVAssessed.Checked;
  if cbAVAssessed.Checked then begin
    TVASite(tvAccess.Selected.Data).AssessData.APH_DateTime := Now;
    tvAccess.Selected.StateIndex := apImageAssessed;
  end else begin
    TVASite(tvAccess.Selected.Data).AssessData.APH_DateTime := 0;
    cbSelected.Checked := False; // zzzzzzandria 050324
    tvAccess.Selected.StateIndex := apImageOpened;
  end;
  acVASiteSelect.Enabled := cbAVAssessed.Checked;
  setCurrentSiteControlStatus(cbAVAssessed.Checked);
  ReportStatus;
end;

procedure TfrmAccess.rbAVThrillClick(Sender: TObject);
begin
  if fIgnore then Exit;
  try
    TVASite(tvAccess.Selected.Data).AssessData.APH_Thrill := rbAVThrill.Checked;
    fAssessDataSaved := False;
  except
  end;
end;

procedure TfrmAccess.rbAVBruitClick(Sender: TObject);
begin
  if fIgnore then Exit;
  try
    TVASite(tvAccess.Selected.Data).AssessData.APH_Bruit := rbAVBruit.Checked;
    fAssessDataSaved := False;
  except
  end;
end;

procedure TfrmAccess.rbAVmatureClick(Sender: TObject);
begin
  if fIgnore then Exit;
  try
    TVASite(tvAccess.Selected.Data).AssessData.APH_Mature := rbAVmature.Checked;
    fAssessDataSaved := False;
  except
  end;
end;

procedure TfrmAccess.rbAVInfiltratedClick(Sender: TObject);
begin
  if fIgnore then Exit;
  try
    TVASite(tvAccess.Selected.Data).AssessData.APH_Infiltrated := rbAVInfiltrated.Checked;
    fAssessDataSaved := False;
  except
  end;
end;

procedure TfrmAccess.mmCommentsChange(Sender: TObject);
var
  i: Integer;
  s: string;
  dbe: TMemo;
begin
  if fIgnore then Exit;
  try
    s := Preferences.sValue(onSignatureKey);
    if (s = yoUndefined) or (s = '') then Exit;
    dbe := mmComments;
    i := pos(s, dbe.Text);
    if i = 0 then begin
      TVASite(tvAccess.Selected.Data).AssessData.APH_Comments := dbe.Text;
      Exit;
    end;
    fIgnore := true;
    dbe.SelStart := i - 1;
    dbe.SelLength := Length(s);
    dbe.SelText := Engine.Signature;
    dbe.SelStart := i + 3 + Length(Engine.Signature) - 2;
    dbe.SelLength := 0;
    fIgnore := False;
    TVASite(tvAccess.Selected.Data).AssessData.APH_Comments := dbe.Text;
    fAssessDataSaved := False;
  except
  end;
end;

procedure TfrmAccess.ckbTTClick(Sender: TObject);
begin
  try
    TVASite(tvAccess.Selected.Data).AssessData.APH_TTreatment := ckbTT.Checked;
    fAssessDataSaved := False;
  except
  end;
end;

procedure TfrmAccess.cbInfectionClick(Sender: TObject);
begin
  dtpInfection.Enabled := TCheckBox(Sender).Checked;
  edInfection.Enabled := TCheckBox(Sender).Checked;
  if TCheckBox(Sender).Checked then begin
    edInfection.Color := clWindow;
    dtpInfection.Color := clWindow;
  end else begin
    edInfection.Text := '';
    edInfection.Color := Preferences.iValue(onReadOnlyFieldColor);
    dtpInfection.Color := Preferences.iValue(onReadOnlyFieldColor);
  end;
end;

procedure TfrmAccess.edInfectionChange(Sender: TObject);
var
  TheSite: TVASite;
begin
  TheSite := TVASite(tvAccess.Selected.Data);
  if Assigned(TheSite) then begin
    TheSite.InfectionData.APIH_Infection := edInfection.Text;
    TheSite.InfectionData.APIH_RegisteredBy := Engine.UserDUZ;
    TheSite.InfectionData.APIH_RegisteredDateTime := Now;
    TheSite.InfectionData.APIH_InfectionDateTime := dtpInfection.Date;
    saveSiteData(TheSite);
  end;
end;

procedure TfrmAccess.dtpInfectionChange(Sender: TObject);
begin
  edInfectionChange(Sender);
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmAccess.SelectSite(aValue: Boolean);
var
  aSite: TVASite;
  tn: TTreeNode;
begin
  if aValue then begin
    tn := tvAccess.Items[0];
    if tn <> nil then begin
      tn := tn.getFirstChild;
      while tn <> nil do begin
        if (tn.Data <> nil) and (TObject(tn.Data) is TVASite) and TVASite(tn.Data).Selected then begin
          if (MessageDLG('You are sure you want to select more then one access site for this treatment?',
            mtConfirmation, [mbYes, mbNo], 0) = mrYes) then break
          else begin
            cbSelected.Checked := False;
            Exit;
          end;
        end;
        tn := tn.getNextSibling;
      end;
    end;
  end;
  if Assigned(tvAccess.Selected) and (tvAccess.Selected.Data <> nil) then
    try
      aSite := TVASite(tvAccess.Selected.Data);
      aSite.Selected := aValue;
      aSite.AssessData.APH_Selected := aValue;
      if aValue then tvAccess.Selected.StateIndex := apImageselected
      else tvAccess.Selected.StateIndex := apImageAssessed;
      acVASiteRemove.Enabled := not aSite.Selected;
    except
    end
  else acVASiteRemove.Enabled := False;
  ReportStatus;
end;

procedure TfrmAccess.cbSelectedClick(Sender: TObject);
begin
  if fIgnore then Exit;
  SelectSite(cbSelected.Checked);
  fAssessDataSaved := False;
end;

procedure TfrmAccess.acVASiteSelectExecute(Sender: TObject);
var
  aSite: TVASite;
begin
  aSite := TVASite(tvAccess.Selected.Data);
  SelectSite(not aSite.Selected);
  fIgnore := true;
  cbSelected.Checked := aSite.Selected;
  fIgnore := False;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmAccess.CleanUpTree;
var
  tnS: TTreeNode;
begin
  tnS := Root;
  if tnS = nil then Exit;
  tnS := tnS.getFirstChild;
  while tnS <> nil do begin
    CleanUpNode(tnS);
    tnS := tnS.getNextSibling;
  end;
  tvAccess.Items.Clear;
  fRoot := nil;
end;

// LOAD DATA  /////////////////////////////////////////////////////////////////

procedure TfrmAccess.LoadPatientData;
var
  tn: TTreeNode;
  tnc: TTreeNode;
  aSite: TVASite;
  aVAPH: TVASiteHistoryRecord;
  aVAPIH: TVASiteInfectionRecord;
begin
  CleanUpTree; // CleanUp Access points Tree;
  if not Assigned(fVAP) then Exit; // client data set with the patient data
  if not fVAP.Active then // open data sets
    try
      fVAP.Active := true;
    except
      Exit;
    end;
  if not fVAPH.Active then // open data sets
    try
      fVAPH.Active := true;
    except
      Exit;
    end;
  if not fVAPIH.Active then // open data sets
    try
      fVAPIH.Active := true;
    except
      Exit;
    end;
  with fVAP do begin
    fVAP.First;
    while not fVAP.Eof do begin
      aSite := getVASiteRecord(fVAP);
      if aSite = nil then begin
        fVAP.Next;
        continue;
      end;
      aSite.PatientID := fPatientID;
      if aSite.Status = asPlaced then begin
        tn := tvAccess.Items.AddChildObjectFirst(Root, SiteTypeNameByType(aSite.AccessType) + ':  ' +
          aSite.Location, aSite);
        tn.StateIndex := apImageOpened;
      end else begin
        tn := tvAccess.Items.AddChildObject(Root, SiteTypeNameByType(aSite.AccessType) + ':  ' + aSite.Location
          { Description } , aSite);
        tn.StateIndex := apImageClosed;
      end;
      // Load Access History Data
      tnc := nil;
      try
        fVAPH.First;
        // tnc := nil;
        while not fVAPH.Eof do begin
          aVAPH := getVAHRecord(fVAPH);
          if aVAPH.APH_SessionID = fStudyID then begin
            aSite.Assessed := aVAPH.APH_Assessed;
            aSite.Selected := aVAPH.APH_Selected;
            aSite.AssessData.APH_Assessed := aVAPH.APH_Assessed;
            aSite.AssessData.APH_Selected := aVAPH.APH_Selected;
            aSite.AssessData.APH_Thrill := aVAPH.APH_Thrill;
            aSite.AssessData.APH_TTreatment := aVAPH.APH_TTreatment;
            aSite.AssessData.APH_Mature := aVAPH.APH_Mature;
            aSite.AssessData.APH_Infiltrated := aVAPH.APH_Infiltrated;
            aSite.AssessData.APH_Bruit := aVAPH.APH_Bruit;
            aSite.AssessData.APH_Comments := aVAPH.APH_Comments;
            aSite.AssessData.APH_ABF := aVAPH.APH_ABF;
            aSite.AssessData.APH_VP0 := aVAPH.APH_VP0;
            aSite.AssessData.APH_VP200 := aVAPH.APH_VP200;
            aSite.AssessData.APH_ID := aVAPH.APH_ID;
            aSite.AssessData.APH_SessionID := aVAPH.APH_SessionID;
            if aSite.Status = asRemoved then tn.StateIndex := apImageClosed
            else if aSite.Selected then tn.StateIndex := apImageselected
            else if aSite.Assessed then tn.StateIndex := apImageAssessed
            else if aSite.Status = asPlaced then tn.StateIndex := apImageOpened;
          end else begin
            if tnc = nil then tnc := tvAccess.Items.AddChild(tn, 'Treatment History');
            tvAccess.Items.AddChildObjectFirst(tnc, FormatDateTime(gMDK_DateFMT, aVAPH.APH_DateTime)
              // v. 1.0 build 312 (#18) adding STudy ID to the history record
              + ' (' + aVAPH.APH_SessionID + ')', aVAPH);
          end;
          fVAPH.Next;
        end;
      except
      end;
      // Load Infection History Data
      try
        fVAPIH.First;
        if not fVAPIH.Eof then tnc := nil;
        while not fVAPIH.Eof do begin
          aVAPIH := getVAIHRecord(fVAPIH);
          if aVAPIH.APIH_StudyID = fStudyID then begin
            aSite.InfectionData.APIH_InfectionDateTime := aVAPIH.APIH_InfectionDateTime;
            aSite.InfectionData.APIH_Infection := aVAPIH.APIH_Infection;
            aSite.InfectionData.APIH_RegisteredBy := aVAPIH.APIH_RegisteredBy;
            aSite.InfectionData.APIH_StudyID := aVAPIH.APIH_StudyID;
            cbInfection.Checked := true;
          end else begin
            if aVAPIH.APIH_InfectionDateTime <> 0 then
            // we don't need 0 dates.
            begin
              if tnc = nil then tnc := tvAccess.Items.AddChild(tn, 'Infection History');
              tvAccess.Items.AddChildObjectFirst(tnc, FormatDateTime(gMDK_DateFMT,
                aVAPIH.APIH_InfectionDateTime), aVAPIH);
            end;
          end;
          fVAPIH.Next;
        end;
      except
      end;
      fVAP.Next;
    end;
  end;
  try
    if fRoot <> nil then fRoot.Expand(False);
  except
  end;
  try
    if (tvAccess.Items.Count > 1) and ((tvAccess.Selected = nil) or (tvAccess.Selected = tvAccess.Items[0])) then
        tvAccess.Selected := tvAccess.Items[1]
    else begin
      pnlHistory.Visible := False;
      pnlCurrent.Visible := False;
      pnlSiteInfo.Visible := False;
    end;
  except
  end;
end;

// SAVE DATA  /////////////////////////////////////////////////////////////////

procedure TfrmAccess.saveSiteData(aSite: TVASite);
var
  aHR: TVASiteHistoryRecord;
  aIHR: TVASiteInfectionRecord;
begin
  if not Assigned(aSite) then Exit;
  SetVASiteRecord(VAP, aSite); // will add data if no record found
  if aSite.Status <> asRemoved then begin
    aHR := TVASiteHistoryRecord.Create;
    aHR.APH_ID := aSite.ID;
    aHR.APH_SessionID := StudyID;
    aHR.APH_Selected := aSite.AssessData.APH_Selected;
    aHR.APH_Assessed := aSite.AssessData.APH_Assessed;
    aHR.APH_DateTime := aSite.AssessData.APH_DateTime;
    aHR.APH_RegisteredBy := aSite.AssessData.APH_RegisteredBy;
    aHR.APH_Thrill := aSite.AssessData.APH_Thrill;
    aHR.APH_TTreatment := aSite.AssessData.APH_TTreatment;
    aHR.APH_Bruit := aSite.AssessData.APH_Bruit;
    aHR.APH_Mature := aSite.AssessData.APH_Mature;
    aHR.APH_Infiltrated := aSite.AssessData.APH_Infiltrated;
    aHR.APH_Comments := aSite.AssessData.APH_Comments;
    aHR.APH_ABF := aSite.AssessData.APH_ABF;
    aHR.APH_VP0 := aSite.AssessData.APH_VP0;
    aHR.APH_VP200 := aSite.AssessData.APH_VP200;
    SetVAHRecord(VAPH, aHR);
    aHR.Free;
  end;
  if (aSite.AccessType = atTunneled) then begin
    aIHR := TVASiteInfectionRecord.Create;
    aIHR.APIH_ID := aSite.ID; // 'ID';
    aIHR.APIH_StudyID := StudyID;
    // 'InfectionDateTime';
    aIHR.APIH_InfectionDateTime := aSite.InfectionData.APIH_InfectionDateTime;
    // 'Infection';
    aIHR.APIH_Infection := aSite.InfectionData.APIH_Infection;
    // 'RegisteredBy';
    aIHR.APIH_RegisteredBy := aSite.InfectionData.APIH_RegisteredBy;
    aIHR.APIH_RegisteredDateTime := Now; // 'RegisteredDateTime';
    SetVAIHRecord(VAPIH, aIHR);
    aIHR.Free;
  end;
end;

procedure TfrmAccess.SavePatientData;
var
  tn: TTreeNode;
  anObject: TObject;
begin
  tn := Root.getFirstChild;
  while tn <> nil do begin
    try
      anObject := TObject(tn.Data);
      if anObject is TVASite then saveSiteData(TVASite(anObject));
    except
    end;
    tn := tn.getNextSibling;
  end;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmAccess.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i: Integer;
  aSite: TVASite;
  anObject: TObject;
begin
  for i := 0 to tvAccess.Items.Count - 1 do
    try
      anObject := TObject(tvAccess.Items[i].Data);
      if anObject is TVASite then begin
        aSite := TVASite(tvAccess.Items[i].Data);
        FreeAndNil(aSite);
      end else if anObject is TObject then begin
        TObject(tvAccess.Items[i].Data).Free;
      end;
    except
    end;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmAccess.CleanUpNode(aNode: TTreeNode);
var
  tn: TTreeNode;
  tnH, tnIH: TTreeNode;
  aNO: TObject;
begin
  tn := aNode;
  if Assigned(tn.Data) then begin
    aNO := tn.Data;
    TVASite(aNO).Free;
    tnH := tn.getFirstChild;
    if tnH = nil then Exit;
    tnIH := tnH.getNextSibling;
    if Assigned(tnH) then begin
      tnH := tnH.getFirstChild;
      if tnH <> nil then
        repeat
          if Assigned(tnH.Data) then TVASiteHistoryRecord(tnH.Data).Free;
          tnH := tnH.getNextSibling;
        until tnH = nil;
    end;
    if Assigned(tnIH) then begin
      tnIH := tnIH.getFirstChild;
      if tnIH <> nil then
        repeat
          if Assigned(tnIH.Data) then TVASiteInfectionRecord(tnIH.Data).Free;
          tnIH := tnIH.getNextSibling;
        until tnIH = nil;
    end;
  end;
end;

procedure TfrmAccess.tvAccessDblClick(Sender: TObject);
var
  aNO: TObject;
begin
  if Engine.CurrentOperatorMode <> rnAdmin then Exit;
  if Engine.CurrentPatient.ReadOnly then Exit;
  aNO := TObject(tvAccess.Selected.Data);
  if (aNO is TVASite) and (not TVASite(aNO).Selected) // zzzzzzandria 2008-04-03
    and (not TVASite(aNO).Assessed) // zzzzzzandria 2008-04-03
    and (TVASite(aNO).RemovalDate = 0) // zzzzzzandria 2008-04-03
    and (tvAccess.Selected.Count = 0) // zzzzzzandria 2008-04-03
    and (MessageDLG('Delete the Node?', mtConfirmation, [mbYes, mbNo], 0) = mrYes) then begin
    CleanUpNode(tvAccess.Selected);
    tvAccess.Items.Delete(tvAccess.Selected);
  end;
end;

// Summary report generation

function TfrmAccess.AssessReport: string;
var
  tn: TTreeNode;
  aSite: TVASite;
  anObject: TObject;
const
  NoCommentsFound = 'No comments found';
  function getSiteComments(anID: string): string;
  begin
    Result := // 'Comments for site: '+anID+#13#10+
      dmData.getCommentsReport(fnNL_Tag + '=''' + pnAccess + '''' + ' and ' + fnNL_ItemID + '=''' + anID +
      '''') + #13#10;
    if (aSite.AssessData.APH_Comments <> '') and (pos(NoCommentsFound, Result) = 1) then Result := '';
  end;

begin
  tn := Root.getFirstChild;
  Result := '';
  while tn <> nil do begin
    try
      anObject := TObject(tn.Data);
      if (anObject is TVASite) and (TVASite(anObject).Selected or TVASite(anObject).Assessed) { // Loma Linda request }
      then begin
        aSite := TVASite(anObject);
        Result := Result + 'Type: ' + SiteTypeNameByType(aSite.AccessType) + #13#10;
        Result := Result + 'Location: ' + aSite.Location + #13#10;
        Result := Result + 'Date Placed: ' + FormatDateTime(gMDK_DateFMT, aSite.PlacedDate) + #13#10;
        Result := Result + 'Surgeon: ' + aSite.Surgeon + #13#10;
        Result := Result + 'Medical Facility: ' + aSite.Facility + #13#10;
        Result := Result + #13#10;
        case aSite.AccessType of
          atFistula, atGraft: begin
              if aSite.AssessData.APH_Thrill then Result := Result + 'Thrill: Yes' + #13#10
              else Result := Result + 'Thrill: No' + #13#10;
              if aSite.AssessData.APH_Bruit then Result := Result + 'Bruit: Yes' + #13#10
              else Result := Result + 'Bruit: No' + #13#10;
              if aSite.AssessData.APH_Mature then Result := Result + 'Mature: Yes' + #13#10
              else Result := Result + 'Mature: No' + #13#10;
              if aSite.AssessData.APH_Infiltrated then Result := Result + 'Infiltrated: Yes' + #13#10
              else Result := Result + 'Infiltrated: No' + #13#10;
            end;
          atTunneled: begin
              if aSite.AssessData.APH_TTreatment then
                  Result := Result + 'Thrombolytic Treatment Done This Dialysis: Yes' + #13#10
              else Result := Result + 'Thrombolytic Treatment Done This Dialysis: No' + #13#10;
              if aSite.InfectionData.APIH_Infection <> '' then begin
                Result := Result + 'Date of last infection: ' + FormatDateTime(gMDK_DateFMT,
                  aSite.InfectionData.APIH_InfectionDateTime) + #13#10;
                Result := Result + 'Infection: ' + aSite.InfectionData.APIH_Infection + #13#10
              end;
            end;
          atTmpCatheter: begin
              if aSite.AssessData.APH_TTreatment then
                  Result := Result + 'Thrombolytic Treatment Done This Dialysis: Yes' + #13#10
              else Result := Result + 'Thrombolytic Treatment Done This Dialysis: No' + #13#10;
            end;
        end;
        Result := Result + #13#10;
        if aSite.Selected then Result := Result + 'Selected: Yes' + #13#10
        else Result := Result + 'Selected: No' + #13#10;
        if aSite.AssessData.APH_Comments <> '' then begin
          Result := Result + 'Comments:' + aSite.AssessData.APH_Comments;
          if pos(#13#10, aSite.AssessData.APH_Comments) <> Length(aSite.AssessData.APH_Comments) - 1 then
              Result := Result + #13#10;
        end;
        // Adding comments from Notes table
        Result := Result + getSiteComments(aSite.ID);
        Result := Result + #13#10;
        Result := Result + #13#10;
      end;
    except
    end;
    tn := tn.getNextSibling;
  end;
  if Result = '' then Result := 'No Data on the access points used in the procedure is available';
end;

procedure TfrmAccess.AssessPointsReport(aRE: TRichEdit = nil; aDelim: string = ':'; aColor: TColor = clNavy);
var
  tn: TTreeNode;
  aSite: TVASite;
  anObject: TObject;
  procedure Add(aValue: string);
  begin
    mmHistory.Lines.Add(aValue);
  end;

begin
  if aRE = nil then aRE := mmHistory;
  aRE.Lines.Clear;
  tn := Root.getFirstChild;
  while tn <> nil do begin
    try
      anObject := TObject(tn.Data);
      if anObject is TVASite then begin
        aSite := TVASite(anObject);
        Add('Type: ' + sBB + SiteTypeNameByType(aSite.AccessType) + sBE);
        Add('Location: ' + sBB + aSite.Location + sBE);
        Add(Format('Date Placed: <%-20.20s', [FormatDateTime(gMDK_DateFMT, aSite.PlacedDate)]) + sBE);
        Add(Format('Placed At:   <%-20.20s', [aSite.Facility]) + sBE);
        Add(Format('Placed By:   <%-20.20s', [aSite.Surgeon]) + sBE);
        if aSite.RemovalDate <> 0 then begin
          Add(' ');
          Add('Date Removed:' + sBB + FormatDateTime(gMDK_DateFMT, aSite.RemovalDate) + sBE);
          Add('Removed At:' + sBB + aSite.RemovalFacility + sBE);
          Add('Removed By:' + sBB + aSite.RemovalSurgeon + sBE);
          Add('Removal Reason:' + sBB + aSite.RemovalReason + sBE);
          Add(' ');
        end;
        Add('_____________________________________________________________');
        Add('');
      end;
    except
    end;
    tn := tn.getNextSibling;
  end;
  try
    mmHistory.Lines.Delete(mmHistory.Lines.Count - 1);
    mmHistory.Lines.Delete(mmHistory.Lines.Count - 1);
  except
  end;
  PaintSyntax(sBB, sBE, clNavy);
end;

procedure TfrmAccess.PaintSyntax(aStart, anEnd: string; aColor: TColor);
begin
  uMDK_ReportEngine.PaintSyntax(mmHistory, False);
end;

function TfrmAccess.getNodeReport(aNode: TTreeNode; ShowComments: Boolean = true): string;
var
  anObject: TObject;
begin
  Result := 'Unknown node type' + #13#10;
  anObject := TObject(aNode.Data);
  if anObject is TVASiteInfectionRecord then Result := TVASiteInfectionRecord(aNode.Data).getDescriptionLine
  else if anObject is TVASiteHistoryRecord then
      Result := TVASiteHistoryRecord(aNode.Data).getDescriptionLine(ShowComments);
end;

function TfrmAccess.getNodeTitle(aNode: TTreeNode): string;
var
  anObject: TObject;
begin
  Result := 'Unknown node type' + #13#10;
  if not Assigned(aNode.Data) then Exit;
  anObject := TObject(aNode.Data);
  if anObject is TVASiteInfectionRecord then Result := TVASiteInfectionRecord(aNode.Data).getTitleLine
  else if anObject is TVASiteHistoryRecord then Result := TVASiteHistoryRecord(aNode.Data).getTitleLine;
end;

procedure TfrmAccess.ReportStatus;
var
  iCode: Integer;
  iSelected, iAssessed: Integer;
  tn: TTreeNode;
  aSite: TVASite;
begin
  iSelected := 0;
  iAssessed := 0;
  iCode := 0;
  tn := nil;
  if fRoot <> nil then tn := fRoot.getFirstChild;
  while tn <> nil do begin
    if Assigned(tn.Data) and (TObject(tn.Data).ClassName = 'TVASite') then begin
      aSite := TVASite(tn.Data);
      if aSite.Status <> asRemoved then begin
        if aSite.Selected then inc(iSelected);
        if aSite.Assessed then inc(iAssessed);
      end;
    end;
    tn := tn.getNextSibling;
  end;
  if iSelected < 1 then iCode := 1;
  if iAssessed < 1 then iCode := iCode + 1;
  Engine.ReportStatus(pnAccess, iCode, Format('Assessed: %d, Selected: %d', [iAssessed, iSelected]));
  if Parent is TTabSheet then begin
    if iCode = 0 then TTabSheet(Parent).ImageIndex := indexOK
    else TTabSheet(Parent).ImageIndex := indexWarning;
  end;
  updateGUI;
end;

procedure TfrmAccess.updateGUI;
begin
  tvAccess.Color := Preferences.iValue(onReadOnlyFieldColor);
  pnlLegend.Color := Preferences.iValue(onReadOnlyFieldColor);
  pnlDetails.Color := Preferences.iValue(onColorBackGround);
  mmHistory.Color := Preferences.iValue(onColorBackGround);
  FrameMDK_Comments.pnlToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlSiteListToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlSelectedSiteToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlCurrentStatusToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlHistoryToolbar.Color := Preferences.iValue(onColorToolbar);
  if pnlHistory.Align <> alClient then pnlHistory.Align := alClient;
  if pnlCurrent.Align <> alClient then pnlCurrent.Align := alClient;
  pnlVASiteRemove2d.Visible := not devOptions.bValue(donWindowsXPTheme);
  pnlSiteActions.Visible := not devOptions.bValue(donWindowsXPTheme);
  pnlSiteListActions.Visible := not devOptions.bValue(donWindowsXPTheme);
  pnlSiteSelect3D.Visible := devOptions.bValue(donWindowsXPTheme);
  pnlVASiteAdd3d.Visible := devOptions.bValue(donWindowsXPTheme);
  pnlRemove3D.Visible := devOptions.bValue(donWindowsXPTheme);
end;

procedure TfrmAccess.ReloadData;
begin
end;

procedure TfrmAccess.setReadOnly(aReadOnly: Boolean);
begin
  // setup Read Only access to the form
  FrameMDK_Comments.ReadOnly := aReadOnly;
  acVASiteAdd.Enabled := not aReadOnly;
  if aReadOnly then begin
    acVASiteRemove.Enabled := False;
    acVASiteSelect.Enabled := False;
  end;
  pnlCurrent.Enabled := not aReadOnly;
  pnlSiteInfo.Enabled := not aReadOnly;
  if aReadOnly then pnlDetails.Color := Preferences.iValue(onColorReview)
  else pnlDetails.Color := Preferences.iValue(onColorBackGround);
end;

function TfrmAccess.Verify: string;
var
  tn: TTreeNode;
  anObject: TObject;
  function VerifySiteData(aSite: TVASite): string;
  begin
    Result := '';
    if aSite.AssessData.APH_Comments <> '' then Result := aSite.AssessData.APH_Comments + #13#10;
  end;

begin
  Result := '';
  tn := Root.getFirstChild;
  while tn <> nil do begin
    try
      anObject := TObject(tn.Data);
      if anObject is TVASite then Result := Result + VerifySiteData(TVASite(anObject));
    except
    end;
    tn := tn.getNextSibling;
  end;
end;

procedure TfrmAccess.ActivateTabForm;
begin
  if Assigned(tvAccess.Selected) then begin
    tvAccessChange(nil, tvAccess.Selected);
    try
      FrameMDK_Comments.ActivateFrame;
      mniComments.Enabled := true;
    except
    end;
  end else if tvAccess.Items.Count > 0 then begin
    tvAccess.Selected := tvAccess.Items[0];
    mniComments.Enabled := true;
  end
  else
    try
      FrameMDK_Comments.Visible := False;
      mniComments.Enabled := False;
    except
    end;
  ReportStatus;
  setReadOnly(Engine.CurrentPatient.ReadOnly);
end;

procedure TfrmAccess.setActionStatus;
begin
end;

procedure TfrmAccess.setCurrentItemID;
begin
  fCurrentItemID := anItemID;
  FrameMDK_Comments.ItemTag := fCurrentItemID;
  dmData.cdsNotes.Filter := fnNL_Tag + '=''' + pnAccess + '''' + ' and ' + fnNL_ItemID + '=''' + fCurrentItemID + '''';
  FrameMDK_Comments.CleanSBX;
  FrameMDK_Comments.ResetSBX;
end;

procedure TfrmAccess.acShowOldCommentsExecute(Sender: TObject);
begin
{$IFDEF AANTEST}
  pnlTest.Visible := not pnlTest.Visible;
{$ENDIF}
  mmComments.Enabled := true;
  mmComments.ReadOnly := False;
end;

procedure TfrmAccess.acMoveCommentsExecute(Sender: TObject);
begin
  if mmComments.Text = '' then Exit;
  if MessageDLG('Old style comments field contains data.' + #13#10#13#10 +
    'Do you want to convert this comment to a new format?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    if FrameMDK_Comments.addNewComment(mmComments.Text, CurrentItemID, true) <> '' then begin
      mmComments.Text := '';
      if Assigned(tvAccess.Selected.Data) then begin
        saveSiteData(TVASite(tvAccess.Selected.Data));
        TVASite(tvAccess.Selected.Data).AssessData.APH_Comments := '';
      end;
    end;
    tvAccessChange(tvAccess, tvAccess.Selected);
  end;
end;

procedure TfrmAccess.acVerifyExecute(Sender: TObject);
var
  s: string;
begin
  s := Verify;
  if s = '' then s := 'No comments to convert...';
  MessageDLG(s, mtInformation, [mbOK], 0);
end;

procedure TfrmAccess.acReportExecute(Sender: TObject);
begin
  ShowInfo(AssessReport);
end;

function TfrmAccess.getMainMenu: TMainMenu;
begin
  Result := mnMain;
end;

end.
