unit fMDK_Pre;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 4/23/08 12:19p $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  this unit contains the Hemodialysis application
  *                     Pre treatment form
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Build309/Tabs/fMDK_Pre.pas $
  *
  *       $ History: fMDK_Pre.pas $
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, uMDK_Summary, DBCtrls, Mask, Buttons, DB, ActnList, Menus, uMDK_Vitals, ComCtrls,
  frMDK_Comments, ImgList, fr_Simple, frMDK_Assessment, IMDK_Assessment, System.Actions;

type
  TfrmPre = class(TForm, i_Assessment)
    pnlPreTreatment: TPanel;
    Panel16: TPanel;
    Panel1: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Bevel1: TBevel;
    Label10: TLabel;
    dbcBTLNone: TDBCheckBox;
    dbcBTLVisual: TDBCheckBox;
    dbcBTLDesire: TDBCheckBox;
    dbcBTLEmotional: TDBCheckBox;
    dbcBTLReligious: TDBCheckBox;
    dbcBTLCognition: TDBCheckBox;
    dbcBTLLanguage: TDBCheckBox;
    dbcBTLPhysical: TDBCheckBox;
    Panel7: TPanel;
    Bevel4: TBevel;
    Label12: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    dbeEduInit: TDBEdit;
    Panel10: TPanel;
    Bevel2: TBevel;
    Label4: TLabel;
    dbcConfused: TDBCheckBox;
    dbcSedated: TDBCheckBox;
    dbcUnresponsive: TDBCheckBox;
    dbcLethargic: TDBCheckBox;
    dbcRestless: TDBCheckBox;
    dbcAlert: TDBCheckBox;
    dbcPreOriented: TDBCheckBox;
    Panel71: TPanel;
    pnlTemp: TPanel;
    Bevel54: TBevel;
    Label284: TLabel;
    Label271: TLabel;
    Label316: TLabel;
    dbeTemp: TDBEdit;
    pnlWeight: TPanel;
    Bevel53: TBevel;
    Label270: TLabel;
    Label269: TLabel;
    Label285: TLabel;
    Label17: TLabel;
    Label312: TLabel;
    Label313: TLabel;
    Label21: TLabel;
    dbeGoal: TDBEdit;
    dbeWeight: TDBEdit;
    Panel108: TPanel;
    Bevel59: TBevel;
    Label296: TLabel;
    Label302: TLabel;
    Label303: TLabel;
    Label304: TLabel;
    Label305: TLabel;
    Label306: TLabel;
    Label307: TLabel;
    Label318: TLabel;
    Label319: TLabel;
    Label320: TLabel;
    Label325: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    Label9: TLabel;
    dbePulseStanding: TDBEdit;
    dbePulseSeated: TDBEdit;
    dbeDiasStand: TDBEdit;
    dbeDiasSit: TDBEdit;
    dbeSysSit: TDBEdit;
    dbeSysStand: TDBEdit;
    Label20: TLabel;
    Panel28: TPanel;
    dbcPreOrientedText: TDBRadioGroup;
    Panel2: TPanel;
    Panel20: TPanel;
    Bevel3: TBevel;
    Label5: TLabel;
    Label6: TLabel;
    Panel21: TPanel;
    Label7: TLabel;
    Panel22: TPanel;
    dbrgSOB: TDBRadioGroup;
    Panel23: TPanel;
    Label8: TLabel;
    Panel24: TPanel;
    dbrgEdema: TDBRadioGroup;
    dbeResp: TDBEdit;
    Panel27: TPanel;
    dbrgEducated: TDBRadioGroup;
    Panel29: TPanel;
    Label16: TLabel;
    Bevel7: TBevel;
    dbcTransportation: TDBComboBox;
    dbeEDW: TDBEdit;
    dbeEduKey: TDBComboBox;
    ActionList1: TActionList;
    acFormatField: TAction;
    PopupMenu1: TPopupMenu;
    Format1: TMenuItem;
    acFormatEdit: TAction;
    acFormatDropDown: TAction;
    PopupMenu2: TPopupMenu;
    MenuItem1: TMenuItem;
    N1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    FrameMDK_Comments: TFrameMDK_Comments;
    spltDetails: TSplitter;
    alPain: TActionList;
    acEdit: TAction;
    ImageList1: TImageList;
    pnlComments: TPanel;
    pnlPreToolbar: TPanel;
    Label15: TLabel;
    pnlPreAssessment: TPanel;
    frPain: TfrAssessment;
    ActionList2: TActionList;
    acMoveComments: TAction;
    acShowOldComments: TAction;
    pnlPreNotes: TPanel;
    lblNotes: TLabel;
    dbmComments: TDBMemo;
    mnMain: TMainMenu;
    Comments1: TMenuItem;
    New1: TMenuItem;
    Edit1: TMenuItem;
    Delete1: TMenuItem;
    Refresh1: TMenuItem;
    N2: TMenuItem;
    Edit2: TMenuItem;
    Notes1: TMenuItem;
    spbUpdateOldComments: TSpeedButton;
    N3: TMenuItem;
    Refresh2: TMenuItem;
    Label24: TLabel;
    dbeStation: TDBEdit;
    Label25: TLabel;
    dbeMachine: TDBEdit;
    Label22: TLabel;
    Panel8: TPanel;
    Panel26: TPanel;
    dbrgSafety: TDBRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure dbeWeightDblClick(Sender: TObject);
    procedure dbeWeightChange(Sender: TObject);
    procedure dbeWeightExit(Sender: TObject);
    procedure dbmCommentsChange(Sender: TObject);
    procedure dbcPreOrientedClick(Sender: TObject);
    procedure dbcPainExit(Sender: TObject);
    procedure dbrgEducatedChange(Sender: TObject);
    procedure dbcBTLNoneClick(Sender: TObject);
    procedure dbcBTLVisualClick(Sender: TObject);
    procedure dbcTransportationDblClick(Sender: TObject);
    procedure dbcAlertEnter(Sender: TObject);
    procedure dbcAlertExit(Sender: TObject);
    procedure acFormatFieldExecute(Sender: TObject);
    procedure dbeEDWChange(Sender: TObject);
    procedure dbcTransportationContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
    procedure acEditExecute(Sender: TObject);
    procedure frPainacUpdateExecute(Sender: TObject);
    procedure acMoveCommentsExecute(Sender: TObject);
  private
    fField: TField;
    fActive: TObject;
    fPainReport: string;
    function getFieldVitalType(Sender: TObject): TVitalType;
    function Verify: string;
    function getAssessmentText: string;
    function updateAssessmentText(aText: string): string;
  public
    ignore: Boolean;
    procedure setUp;
    procedure ReportStatus;
    procedure setReadOnly(aReadOnly: Boolean = False);
    procedure ActivateTabForm;
    procedure SetActionStatus;
    function getMainMenu: TMainMenu;
  end;

var
  frmPre: TfrmPre;

implementation

uses
  dMDK_Data, System.UITypes, uMDK_CDSCommon, uMDK_Engine, uMDK_Common, uMDK_Options, fMDK_DictionaryEdit,
  uMDK_Dictionary, uMDK_ReportEngine, fMDK_PainAssessmentDLG;
{$R *.dfm}

procedure TfrmPre.setUp;
begin
  fPainReport := getPatternValue(kw_PrePainReport);
  frPain.re.Text := fPainReport;
  frPain.Color := Preferences.iValue(onColorBackground);
  frPain.pnlToolbar.Color := Preferences.iValue(onColorToolbar);
  frPain.pnlButtons3D.Visible := devOptions.bValue(donWindowsXPTheme);
  frPain.pnlButtons2D.Visible := not devOptions.bValue(donWindowsXPTheme);
  FrameMDK_Comments.Color := Preferences.iValue(onReadOnlyFieldColor);
  FrameMDK_Comments.pnlToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlPreToolbar.Color := Preferences.iValue(onColorToolbar);
  spbUpdateOldComments.Visible := devOptions.bValue(donIncludeCommentsUpdate);
  setReadOnly(Engine.CurrentPatient.ReadOnly);
end;

procedure TfrmPre.FormCreate(Sender: TObject);
begin
  dbeWeight.DataField := fnS_PreWeight;
  dbeEDW.DataField := fnS_RxEDW;
  dbeTemp.DataField := fnS_PreTemp;
  dbePulseSeated.DataField := fnS_PrePulseSeated;
  dbePulseStanding.DataField := fnS_PrePulseStanding;
  dbeSysSit.DataField := fnS_PreBPSysSitting;
  dbeDiasSit.DataField := fnS_PreBPDiasSitting;
  dbeSysStand.DataField := fnS_PreBPSysStanding;
  dbeDiasStand.DataField := fnS_PreBPDiasStanding;
  dbeResp.DataField := fnS_PreRespirations;
  dbcAlert.DataField := fnS_PreAlert;
  dbcConfused.DataField := fnS_PreConfused;
  dbcSedated.DataField := fnS_PreSedated;
  dbcUnresponsive.DataField := fnS_PreUnresposive;
  dbcLethargic.DataField := fnS_PreLethargic;
  dbcRestless.DataField := fnS_PreRestless;
  dbrgSOB.DataField := fnS_PreSOB;
  dbrgEdema.DataField := fnS_PreEdema;
  dbmComments.DataField := fnS_PreNotes;
  dbrgSafety.DataField := fnS_SafetyChecksOK;
  dbeGoal.DataField := fnS_RxGoalWeight;
  dbrgEducated.DataField := fnS_EDU;
  dbeEduKey.DataField := fnS_EDUKey;
  dbeEduInit.DataField := fnS_EDUInit;
  dbcBTLNone.DataField := fnS_BTLNone; // 'BTLNone';
  dbcBTLVisual.DataField := fnS_BTLVisual; // 'BTLVisual';
  dbcBTLDesire.DataField := fnS_BTLDesire; // 'BTLDesire';
  dbcBTLCognition.DataField := fnS_BTLCognition; // 'BTLCognition';
  dbcBTLReligious.DataField := fnS_BTLReligious; // 'BTLReligious';
  dbcBTLEmotional.DataField := fnS_BTLEmotional; // 'BTLEmotional';
  dbcBTLLanguage.DataField := fnS_BTLLanguage; // 'BTLLanguage';
  dbcBTLPhysical.DataField := fnS_BTLPhysical; // 'BTLPhysical';
  dbcPreOriented.DataField := fnS_PreOriented;
  dbcPreOrientedText.DataField := fnS_PreOrientedText;
  dbcTransportation.DataField := fnS_PreTransportation;
  dbeStation.DataField := fnS_Station;
  dbeMachine.DataField := fnS_Machine;
  ignore := False;
  FrameMDK_Comments.setUpCanvas(Engine.NoteList_CDS, pnPre);
  frPain.setAssessmentInterface(Self as i_Assessment);
  frPain.setAssessmentCaption('Pain Assessment');
end;

function TfrmPre.getFieldVitalType(Sender: TObject): TVitalType;
var
  aVT: TVitalType;
begin
  if (Sender = dbeWeight) or (Sender = dbeGoal) then aVT := vtWeight
  else if (Sender = dbePulseSeated) or (Sender = dbePulseStanding) then aVT := vtPulse
  else if Sender = dbeTemp then aVT := vtTemp
  else if Sender = dbeResp then aVT := vtResp
  else if (Sender = dbeSysSit) or (Sender = dbeDiasSit) or (Sender = dbeSysStand) or (Sender = dbeDiasStand) then
      aVT := vtBP
  else aVT := vtUnknown;
  Result := aVT;
end;

procedure TfrmPre.dbeWeightDblClick(Sender: TObject);
begin
  UpdateDBEditField(TDBEdit(Sender), getFieldVitalType(Sender));
end;

procedure TfrmPre.dbeWeightExit(Sender: TObject);
var
  s: string;
  aVT: TVitalType;
  bMetric: Boolean;
begin
  CheckDBField(Sender);
  fField := nil;
  fActive := nil;
  if dmdata.bIgnore then Exit;
  s := TDBEdit(Sender).Text;
  if s = '' then Exit;
  aVT := getFieldVitalType(Sender);
  if (Sender = dbeWeight) or (Sender = dbeGoal) then bMetric := True
  else bMetric := False;
  if not(aVT = vtUnknown) then
    if not ValidVS(aVT, s, bMetric) then // zzzzzzandria 2008-04-15 set TRUE
    begin
      ShowMessage(HintString(bMetric, aVT)); // zzzzzzandria 2008-04-15 set TRUE
      TDBEdit(Sender).SetFocus;
    end;
  ReportStatus;
end;

procedure TfrmPre.dbeWeightChange(Sender: TObject);
var
  s: string;
begin
  s := TDBEdit(Sender).Text;
  case Length(s) of
    1: Exit;
    2: if pos('.', s) = 2 then Exit;
  else dbeWeightExit(Sender);
  end;
end;

procedure TfrmPre.dbmCommentsChange(Sender: TObject);
begin
  if ignore then Exit;
  ignore := True;
  UpdateMemo(Sender, Engine.Signature);
  ignore := False;
  spbUpdateOldComments.Enabled := dbmComments.Text <> '';
end;

procedure TfrmPre.ReportStatus;
var
  iCode: Integer;
  sComment: string;
  oldIgnore: Boolean;
  function AddFieldReport(aReport: string): string;
  begin
    if aReport <> '' then Result := aReport + ', '
    else Result := aReport;
  end;

begin
  if not dmdata.cdsSummary.Active then Exit;
  oldIgnore := ignore;
  ignore := True;
  try
    iCode := 0;
    sComment := '';
    sComment := sComment + AddFieldReport(CheckDBField(dbeWeight));
    sComment := sComment + AddFieldReport(CheckDBField(dbeGoal));
    sComment := sComment + AddFieldReport(CheckDBField(dbeTemp));
    sComment := sComment + AddFieldReport(CheckDBField(dbeSysSit));
    sComment := sComment + AddFieldReport(CheckDBField(dbeDiasSit));
    sComment := sComment + AddFieldReport(CheckDBField(dbePulseSeated));
    sComment := sComment + AddFieldReport(CheckDBField(dbeSysStand));
    sComment := sComment + AddFieldReport(CheckDBField(dbeDiasStand));
    sComment := sComment + AddFieldReport(CheckDBField(dbePulseStanding));
    sComment := sComment + AddFieldReport(CheckDBField(dbeResp));
    sComment := sComment + AddFieldReport(CheckDBField(dbeStation));
    sComment := sComment + AddFieldReport(CheckDBField(dbeMachine));
    sComment := sComment + AddFieldReport(CheckDBField(dbeEduKey));
    sComment := sComment + AddFieldReport(CheckDBField(dbeEduInit));
    sComment := sComment + AddFieldReport(CheckDBField(dbmComments));
    if sComment <> '' then begin
      sComment := 'Required Fields without data: ' + sComment;
      sComment := copy(sComment, 1, Length(sComment) - 2) + '. ';
    end;
    sComment := sComment + Verify;
    if sComment <> '' then iCode := 1;
    if sComment = '' then sComment := 'OK';
    Engine.ReportStatus(pnPre, iCode, sComment);
    try
      if sComment = 'OK' then TTabSheet(Parent).ImageIndex := indexOK
      else TTabSheet(Parent).ImageIndex := indexWarning;
    except
    end;
  except
  end;
  FrameMDK_Comments.Color := Preferences.iValue(onReadOnlyFieldColor);
  frPain.re.Color := Preferences.iValue(onReadOnlyFieldColor);
  if devOptions.bValue(donShowHorizontalScrollBarsInReports) then begin
    frPain.re.ScrollBars := ssBoth;
    frPain.re.WordWrap := False;
  end else begin
    frPain.re.ScrollBars := ssVertical;
    frPain.re.WordWrap := True;
  end;
  ignore := oldIgnore;
  FrameMDK_Comments.pnlButtons2DH.Visible := not devOptions.bValue(donWindowsXPTheme);
  FrameMDK_Comments.pnlButtons3DH.Visible := devOptions.bValue(donWindowsXPTheme);
end;

procedure TfrmPre.dbcPreOrientedClick(Sender: TObject);
begin
  dbcPreOrientedText.Enabled := dbcPreOriented.Checked;
end;

procedure TfrmPre.dbcPainExit(Sender: TObject);
begin
  CheckDBField(Sender);
  fField := nil;
  fActive := nil;
  try
    dmdata.cdsSummary.Post;
  except
  end;
end;

procedure TfrmPre.dbrgEducatedChange(Sender: TObject);
begin
  dbeEduKey.Enabled := dbrgEducated.ItemIndex = 0;
  dbeEduInit.Enabled := dbrgEducated.ItemIndex = 0;
  if dbrgEducated.ItemIndex = 0 then begin
    dbeEduKey.Color := clWindow;
    dbeEduInit.Color := clWindow;
  end else begin
    dbeEduKey.Color := clBtnFace;
    dbeEduInit.Color := clBtnFace;
    dmdata.cdsSummary.FieldByName(dbeEduKey.DataField).Clear;
    dmdata.cdsSummary.FieldByName(dbeEduInit.DataField).Clear;
  end;
  CheckDBField(dbeEduKey);
  CheckDBField(dbeEduInit);
end;

procedure TfrmPre.dbcBTLNoneClick(Sender: TObject);
begin
  if ignore then Exit;
  if dbcBTLNone.Checked then begin
    dbcBTLVisual.Checked := False;
    dbcBTLDesire.Checked := False;
    dbcBTLCognition.Checked := False;
    dbcBTLReligious.Checked := False;
    dbcBTLEmotional.Checked := False;
    dbcBTLLanguage.Checked := False;
    dbcBTLPhysical.Checked := False;
  end;
end;

procedure TfrmPre.dbcBTLVisualClick(Sender: TObject);
begin
  if TDBCheckBox(Sender).Checked then begin
    ignore := True;
    dbcBTLNone.Checked := False;
    ignore := False;
  end;
end;
/// /////////////////////////////////////////////////////////////////////////////

procedure TfrmPre.dbcTransportationDblClick(Sender: TObject);
begin
  UpdateColumnField(TField(Sender), TDBComboBox(Sender).DataSource.DataSet.Name, TDBComboBox(Sender).DataField);
end;

procedure TfrmPre.dbcAlertEnter(Sender: TObject);
begin
  fField := getActiveField(Sender);
  fActive := Sender;
end;

procedure TfrmPre.dbcAlertExit(Sender: TObject);
begin
  CheckDBField(Sender);
  fField := nil;
  fActive := nil;
  ReportStatus;
end;

procedure TfrmPre.dbeEDWChange(Sender: TObject);
begin
  CheckDBField(dbeEDW);
end;

procedure TfrmPre.acFormatFieldExecute(Sender: TObject);
var
  aVT: TVitalType;
begin
  if fField = nil then Exit;
  try
    aVT := getFieldVitalType(fActive);
    UpdateColumnField(fField, fField.DataSet.Name, fField.FieldName, aVT);
    CheckDBField(fActive);
  except
  end;
end;

procedure TfrmPre.dbcTransportationContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
var
  WinCon: TWinControl;
begin
{$IFNDEF DICTIONARY_FORMAT}// zzzzzzandria 2007-07-12 b. 312 #26
  Exit; // zzzzzzandria 20070326 no access to dictionary
{$ENDIF}
  if not devOptions.bValue(onAllowDictionaryEdit) then Exit;
  if Engine.CurrentOperatorMode <> rnAdmin then Exit;
  dbcAlertEnter(Sender);
  WinCon := TWinControl(Sender);
  PopupMenu1.Popup(WinCon.ClientOrigin.X + MousePos.X, WinCon.ClientOrigin.Y + MousePos.Y);
end;

procedure TfrmPre.setReadOnly(aReadOnly: Boolean = False);
begin
  pnlPreAssessment.Enabled := not aReadOnly;
  dbmComments.ReadOnly := aReadOnly;
  FrameMDK_Comments.ReadOnly := aReadOnly;
  if aReadOnly then pnlPreAssessment.Color := Preferences.iValue(onColorReview)
  else pnlPreAssessment.Color := Preferences.iValue(onColorBackground);
  frPain.acUpdate.Enabled := not aReadOnly;
end;

procedure TfrmPre.acEditExecute(Sender: TObject);
begin
  UpdatePainData(0);
  setUp;
end;

procedure TfrmPre.SetActionStatus;
begin
  acMoveComments.Enabled := dbmComments.Text <> '';
  FrameMDK_Comments.SetActionStatus;
  Invalidate;
end;

function TfrmPre.Verify: string;
begin
  Result := '';
  if dbmComments.Text <> '' then Result := 'Old Comments field is not empty  ';
end;

procedure TfrmPre.ActivateTabForm;
begin
  setUp;
  ReportStatus;
  FrameMDK_Comments.ActivateFrame;
end;

function TfrmPre.getAssessmentText: string;
begin
  Result := frPain.re.Text;
end;

function TfrmPre.updateAssessmentText(aText: string): string;
begin
  UpdatePainData(0);
  setUp;
  Result := fPainReport;
end;

procedure TfrmPre.frPainacUpdateExecute(Sender: TObject);
begin
  frPain.acUpdateExecute(Sender);
end;

procedure TfrmPre.acMoveCommentsExecute(Sender: TObject);
begin
  if dbmComments.Modified then
    try
      dmdata.cdsSummary.Post;
    except
    end;
  if dbmComments.Text <> '' then FrameMDK_Comments.moveComment(dbmComments.DataField, '')
  else MessageDLG('No comments available for update', mtInformation, [mbOK], 0);
end;

function TfrmPre.getMainMenu: TMainMenu;
begin
  Result := mnMain;
end;

end.
