unit fMDK_RxLab;

{
  ================================================================================
  *
  *       Package:      MDK - Clinical Procedures
  *       Revision:     $Revision: 1 $  $Modtime: 3/27/08 2:50p $
  *       Site Name:    Hines OIFO
  *       Date Created: 7/29/05
  *       Developers:   dddddddddomain.user@domain.ext
  *       Description:  Contains the Application RxLab form
  *       Notes:
  *
  ================================================================================
  *       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Tabs/fMDK_RxLab.pas $
  *
  *       $ History: fMDK_RxLab.pas $
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Mask, DBCtrls, Buttons, ActnList,
  Menus, DB, uMDK_MDateTime, frMDK_Comments, System.Actions;

type
  TfrmRxLab = class(TForm)
    pnlRXLabs: TPanel;
    pnlComments: TPanel;
    pnlAnticoagulants: TPanel;
    pnlRx: TPanel;
    pnlLab: TPanel;
    pnlLabResults: TPanel;
    tvLabs: TTreeView;
    Panel26: TPanel;
    Label13: TLabel;
    Label20: TLabel;
    Label22: TLabel;
    Label24: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Bevel12: TBevel;
    Label3: TLabel;
    pnlDialysate: TPanel;
    Label51: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    Panel96: TPanel;
    Label55: TLabel;
    Label85: TLabel;
    Label89: TLabel;
    Label115: TLabel;
    Label132: TLabel;
    Label2: TLabel;
    Bevel5: TBevel;
    Label11: TLabel;
    Bevel19: TBevel;
    dbeDF_HCO3: TDBEdit;
    dbeDF_NA: TDBEdit;
    dbeDF_CA: TDBEdit;
    dbeDF_K: TDBEdit;
    Panel1: TPanel;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    dbeMod_NA: TDBEdit;
    dbeMod_HCO3: TDBEdit;
    dbeMod_Ultrafiltration: TDBEdit;
    dbeAC_Other: TDBEdit;
    dbeAC_Load: TDBEdit;
    dbeAC_Doses: TDBEdit;
    dbeAC_EndTime: TDBEdit;
    dbeRxReuseNum: TDBEdit;
    dbeRxTxLength: TDBEdit;
    dbeRxBFR: TDBEdit;
    dbeRxDialysisFlow: TDBEdit;
    dbeRxTemp: TDBEdit;
    dbcbAC_Type: TDBComboBox;
    Label8: TLabel;
    Label9: TLabel;
    lblRxTemp: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    dbeEDW: TDBEdit;
    dbeUltra: TDBEdit;
    Label18: TLabel;
    Label19: TLabel;
    Label1: TLabel;
    Label23: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    dbcbRxDialyser: TDBComboBox;
    Label17: TLabel;
    Label10: TLabel;
    Bevel18: TBevel;
    Label21: TLabel;
    ActionList1: TActionList;
    acCopy: TAction;
    PopupMenu1: TPopupMenu;
    Copy1: TMenuItem;
    Panel3: TPanel;
    acGetLabData: TAction;
    cbAuto: TCheckBox;
    pnlLabToolbar: TPanel;
    acFormat: TAction;
    PopupMenu2: TPopupMenu;
    Format1: TMenuItem;
    PopupMenu3: TPopupMenu;
    MenuItem1: TMenuItem;
    N1: TMenuItem;
    Copy2: TMenuItem;
    Paste1: TMenuItem;
    pnlPhysicianOrders: TPanel;
    Label29: TLabel;
    rePhysicianOrders: TRichEdit;
    FrameMDK_Comments: TFrameMDK_Comments;
    Panel7: TPanel;
    Splitter1: TSplitter;
    Panel11: TPanel;
    pnlPhysicianOrdersToolbar: TPanel;
    pnlOtherOrders: TPanel;
    Label12: TLabel;
    dbmRxOtherOrders: TDBMemo;
    Panel2: TPanel;
    Label30: TLabel;
    pnlRxOrder: TPanel;
    pnlRxToolbar: TPanel;
    Label31: TLabel;
    pnlFormula: TPanel;
    Panel4: TPanel;
    Panel6: TPanel;
    lblDateRange: TLabel;
    Label28: TLabel;
    cbDateRange: TComboBox;
    ActionList2: TActionList;
    acMoveComments: TAction;
    acShowOldComments: TAction;
    pnlRxNotes: TPanel;
    dbmLabNotes: TDBMemo;
    Panel5: TPanel;
    Panel8: TPanel;
    lblNotes: TLabel;
    Bevel17: TBevel;
    mnMain: TMainMenu;
    RxMainMenu: TMenuItem;
    New1: TMenuItem;
    Edit1: TMenuItem;
    Delete1: TMenuItem;
    Refresh1: TMenuItem;
    Notes1: TMenuItem;
    spbUpdateOldComments: TSpeedButton;
    N2: TMenuItem;
    Refresh2: TMenuItem;
    Panel9: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure dbeRxTxLengthEnter(Sender: TObject);
    procedure dbeRxTxLengthKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure acCopyExecute(Sender: TObject);
    procedure acGetLabDataExecute(Sender: TObject);
    procedure cbDateRangeChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure acFormatExecute(Sender: TObject);
    procedure dbcbRxDialyserEnter(Sender: TObject);
    procedure dbcbRxDialyserExit(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure dbcbRxDialyserContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
    procedure acMoveCommentsExecute(Sender: TObject);
    procedure acShowOldCommentsExecute(Sender: TObject);
  private
    fField: TField;
    fActive: TObject;
    fReadOnly: Boolean;
    procedure setupUI;
  public
    LabDateRange: TMDateTimeRange;
    Ignore: Boolean;
    procedure setPatientLabInfo(aValue: string);
    procedure ReportStatus;
    procedure SaveData;
    procedure setReadOnly(aReadOnly: Boolean = False);
    procedure ActivateTabForm;
    procedure setup;
    procedure setActionStatus;
    function Verify: string;
    function getMainMenu: TMainMenu;
    procedure setMainMenuVisible(aValue: Boolean);
  end;

var
  frmRxLab: TfrmRxLab;

implementation

uses
  uROR_CommonUtils, System.UITypes, dMDK_Data, uMDK_Summary, uMDK_CDSCommon, uMDK_Engine, uMDK_Common, uMDK_Options,
  Clipbrd, fMDK_DictionaryEdit, uMDK_Dictionary, uMDK_ReportEngine;
{$R *.dfm}

procedure TfrmRxLab.FormCreate(Sender: TObject);
begin
  Ignore := True;
  LabDateRange := TMDateTimeRange.create;
  setupUI;
end;

procedure TfrmRxLab.setupUI;
begin
  dbcbRxDialyser.DataField := fnS_rxDialyser; // 'Dialyzer';
  dbeRxReuseNum.DataField := fnS_rxReuseNum;  // 'ReuseNum';
  dbeRxTxLength.DataField := fnS_rxTxLength;  // 'TxLength';
  TTimeField(dbeRxTxLength.Field).DisplayFormat := 'hh:nn';
  dbeRxTxLength.Field.EditMask := '00:00';
  dbeRxBFR.DataField := fnS_rxBFR;                   // 'BFR';
  dbeRxDialysisFlow.DataField := fnS_rxDialysisFlow; // 'DFlow';
  dbeRxTemp.DataField := fnS_rxTemp;                 // 'Temp';
  dbeDF_K.DataField := fnS_DF_K;                     // 'DFK';
  dbeDF_HCO3.DataField := fnS_DF_HCO3;               // 'DFHCO3';
  dbeDF_NA.DataField := fnS_DF_NA;                   // 'DFNA';
  dbeDF_CA.DataField := fnS_DF_CA;                   // 'DFCA';
  dbcbAC_Type.DataField := fnS_AC_Type;              // 'ACType';
  dbeAC_Load.DataField := fnS_AC_Load;               // 'ACLoad';
  dbeAC_Doses.DataField := fnS_AC_Doses;             // 'ACDoses';
  dbeAC_EndTime.DataField := fnS_AC_EndTime;         // 'ACEndTime';
  TDateTimeField(dbeAC_EndTime.Field).DisplayFormat := 'hh:nn';
  dbeAC_EndTime.Field.EditMask := '00:00';
  dbeAC_Other.DataField := fnS_AC_Other; // 'ACOther';
  dbeMod_NA.DataField := fnS_MoD_NA;     // 'MODNA';
  dbeMod_HCO3.DataField := fnS_MoD_HCO3; // 'MODHCO3';
  dbeMod_Ultrafiltration.DataField := fnS_Mod_Ultrafiltration; // 'MODUF';
  dbmRxOtherOrders.DataField := fnS_OtherOrders; // 'RxOther';
  dbmLabNotes.DataField := fnS_LabNotes;
  dbeUltra.DataField := fnS_RxUltra;
  dbeEDW.DataField := fnS_RxEDW;
  FrameMDK_Comments.setUpCanvas(Engine.NoteList_CDS, pnRxLab);
end;

procedure TfrmRxLab.FormDestroy(Sender: TObject);
begin
  LabDateRange.Free;
end;

procedure TfrmRxLab.setPatientLabInfo(aValue: string);
var
  s: string;
  sl: TStringList;
  i: Integer;
  tvn: TTreeNode;
  function findNode(aKey: string): TTreeNode;
  var
    j: Integer;
  begin
    Result := nil;
    for j := 0 to tvLabs.Items.Count - 1 do
      if piece(tvLabs.Items[j].Text, '--', 1) = piece(aKey, '--', 1) then begin
        Result := tvLabs.Items[j];
        exit;
      end;
  end;

begin
  if pos('Error', aValue) = 1 then begin
    MessageDLG(aValue, mtInformation, [mbOK], 0);
    exit;
  end;
  sl := nil;
  try
    sl := TStringList.create;
    sl.Text := aValue;
    tvLabs.Items.Clear;
    for i := 0 to sl.Count - 1 do begin
      s := sl[i];
      tvn := findNode(s);
      if tvn <> nil then s := piece(sl[i], '--', 2, 99);
      if s <> '' then tvLabs.Items.AddChild(tvn, s);
    end;
    tvLabs.ShowLines := (tvLabs.Items.Count <> 0);
    if pos('Error', aValue) = 1 then tvLabs.ShowLines := False;
    if tvLabs.Items.Count = 0 then begin
      tvLabs.ShowLines := False;
      tvLabs.Items.AddChild(nil, ' ');
      tvLabs.Items.AddChild(nil, 'Period: ' + lblDateRange.Caption);
      tvLabs.Items.AddChild(nil, 'Result: No Lab Data found');
      tvLabs.Items.AddChild(nil, ' ');
      tvLabs.Items.AddChild(nil, 'Change the Period and try again');
      tvLabs.ShowLines := False;
    end;
  finally
    sl.Free;
  end;
  tvLabs.FullCollapse; // Expand;
end;

procedure TfrmRxLab.FormDeactivate(Sender: TObject);
begin
  try
    dmData.cdsSummary.Post;
  except
  end;
end;

procedure TfrmRxLab.dbeRxTxLengthEnter(Sender: TObject);
var
  s: string;
  aF: TDateTimeField;
begin
  aF := TDateTimeField(TDBEdit(Sender).Field);
  s := FormatDateTime(aF.DisplayFormat, aF.AsDateTime);
  TDBEdit(Sender).DataSource.DataSet.Edit;
  TDBEdit(Sender).EditText := s;
  TDBEdit(Sender).SelLength := Length(s);
  fField := TDBEdit(Sender).Field;
  fActive := Sender;
end;

procedure TfrmRxLab.dbeRxTxLengthKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then dbeRxTxLengthEnter(Sender)
end;

procedure TfrmRxLab.ReportStatus;
var
  s: string;
  i: Integer;
  function AddFieldReport(aReport: string): string;
  begin
    if aReport <> '' then Result := aReport + ', '
    else Result := aReport;
  end;

begin
  try
    s := '';
    s := s + AddFieldReport(CheckDBField(dbcbRxDialyser));
    s := s + AddFieldReport(CheckDBField(dbeRxReuseNum));
    s := s + AddFieldReport(CheckDBField(dbeRxTxLength));
    s := s + AddFieldReport(CheckDBField(dbeUltra));
    s := s + AddFieldReport(CheckDBField(dbeEDW));
    s := s + AddFieldReport(CheckDBField(dbeRxBFR));
    s := s + AddFieldReport(CheckDBField(dbeRxDialysisFlow));
    s := s + AddFieldReport(CheckDBField(dbeRxTemp));
    s := s + AddFieldReport(CheckDBField(dbeDF_K));
    s := s + AddFieldReport(CheckDBField(dbeDF_HCO3));
    s := s + AddFieldReport(CheckDBField(dbeDF_NA));
    s := s + AddFieldReport(CheckDBField(dbeDF_CA));
    s := s + AddFieldReport(CheckDBField(dbcbAC_Type));
    s := s + AddFieldReport(CheckDBField(dbeAC_Load));
    s := s + AddFieldReport(CheckDBField(dbeAC_Doses));
    s := s + AddFieldReport(CheckDBField(dbeAC_EndTime));
    s := s + AddFieldReport(CheckDBField(dbeAC_Other));
    s := s + AddFieldReport(CheckDBField(dbeMod_NA));
    s := s + AddFieldReport(CheckDBField(dbeMod_Ultrafiltration));
    s := s + AddFieldReport(CheckDBField(dbmRxOtherOrders));
    s := s + AddFieldReport(CheckDBField(dbmLabNotes));
    if s <> '' then begin
      s := 'Required Fields without data: ' + s;
      s := copy(s, 1, Length(s) - 2);
      i := 1;
    end else begin
      s := 'OK';
      i := 0;
    end;
    Engine.ReportStatus(pnRxLab, i, s);
    try
      if s = 'OK' then TTabSheet(Parent).ImageIndex := indexOK
      else TTabSheet(Parent).ImageIndex := indexWarning;
    except
    end;
    // setup;
    FrameMDK_Comments.pnlButtons2DH.Visible := not devOptions.bValue(donWindowsXPTheme);
    FrameMDK_Comments.pnlButtons3DH.Visible := devOptions.bValue(donWindowsXPTheme);
  except
  end;
end;

procedure TfrmRxLab.acCopyExecute(Sender: TObject);
var
  i: Integer;
  s: string;
begin
  for i := 0 to tvLabs.Items.Count - 1 do begin
    if not tvLabs.Items[i].Selected then continue;
    if tvLabs.Items[i].Level > 0 then
        s := s + piece(tvLabs.Items[i].Parent.Text, '--', 1) + ' -- ' + tvLabs.Items[i].Text
    else s := s + tvLabs.Items[i].Text;
    s := s + #13#10;
  end;
  Clipboard.AsText := s;
end;

procedure TfrmRxLab.acGetLabDataExecute(Sender: TObject);
var
  s: string;
begin
  s := Engine.getPatientLabInfoForPeriod(LabDateRange.Start.getSMDate + '^' + LabDateRange.Stop.getSMDate);
  setPatientLabInfo(s);
end;

procedure TfrmRxLab.cbDateRangeChange(Sender: TObject);
begin
  if LabDateRange.setMRange(cbDateRange.Text) then begin
    lblDateRange.Caption := LabDateRange.getSWRange;
    acGetLabDataExecute(nil);
  end;
end;

procedure TfrmRxLab.acFormatExecute(Sender: TObject);
begin
  if not devOptions.bValue(onAllowDictionaryEdit) then exit;
  if fField = nil then exit;
  try
    UpdateColumnField(fField, fField.DataSet.Name, fField.FieldName);
    CheckDBField(fActive);
  except
  end;
end;

procedure TfrmRxLab.dbcbRxDialyserEnter(Sender: TObject);
begin
  fField := getActiveField(Sender);
  fActive := Sender;
end;

procedure TfrmRxLab.dbcbRxDialyserExit(Sender: TObject);
begin
  CheckDBField(Sender);
  fField := nil;
  fActive := nil;
  ReportStatus;
end;

procedure TfrmRxLab.Paste1Click(Sender: TObject);
begin
  try
    if (Engine.Summary_CDS.State = dsBrowse) then Engine.Summary_CDS.Edit;
    dbmLabNotes.SelText := Clipboard.AsText;
  except
  end;
end;

procedure TfrmRxLab.dbcbRxDialyserContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
var
  WinCon: TWinControl;
begin
{$IFNDEF DICTIONARY_FORMAT}// zzzzzzandria 2007-07-12 b. 312 #26
  exit;                    // zzzzzzandria 20070326 no access to dictionary
{$ENDIF}
  if Engine.CurrentOperatorMode <> rnAdmin then exit;
  WinCon := TWinControl(Sender);
  dbcbRxDialyserEnter(Sender);
  PopupMenu2.Popup(WinCon.ClientOrigin.X + MousePos.X, WinCon.ClientOrigin.Y + MousePos.Y);
end;

procedure TfrmRxLab.SaveData;
begin
  try
    dbcbRxDialyserExit(fActive);
  except
  end;
end;

procedure TfrmRxLab.setReadOnly(aReadOnly: Boolean = False);
begin
  fReadOnly := aReadOnly;
  setup;
  pnlRx.Enabled := not aReadOnly;
  pnlDialysate.Enabled := not aReadOnly;
  if aReadOnly then pnlRxOrder.Color := Preferences.iValue(onColorReview)
  else pnlRxOrder.Color := Preferences.iValue(onColorBackground);
  dbmRxOtherOrders.ReadOnly := aReadOnly;
  FrameMDK_Comments.ReadOnly := aReadOnly;
end;

procedure TfrmRxLab.setup;
begin
  tvLabs.Color := Preferences.iValue(onReadOnlyFieldColor);
  rePhysicianOrders.Color := Preferences.iValue(onReadOnlyFieldColor);
  pnlRxToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlPhysicianOrdersToolbar.Color := Preferences.iValue(onColorToolbar);
  FrameMDK_Comments.Color := Preferences.iValue(onReadOnlyFieldColor);
  FrameMDK_Comments.pnlToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlLabToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlRxOrder.Color := Preferences.iValue(onColorBackground);
  pnlLabResults.Color := Preferences.iValue(onColorBackground);
  if devOptions.bValue(donShowHorizontalScrollBarsInComments) then begin
    dbmLabNotes.ScrollBars := ssBoth;
    dbmRxOtherOrders.ScrollBars := ssBoth;
  end else begin
    dbmLabNotes.ScrollBars := ssVertical;
    dbmRxOtherOrders.ScrollBars := ssVertical;
  end;
end;

procedure TfrmRxLab.ActivateTabForm;
  function convert(Source: string): string;
  var
    s: string;
    i: Integer;
    sl: TStringList;
  begin
    Result := '';
    if (Source = '') or (pos('No ', Source) = 1) then begin
      Result := Source;
      exit;
    end;
    sl := TStringList.create;
    sl.Text := Source;
    for i := 0 to sl.Count - 1 do begin
      s := sl[i];
      if pos('~', s) = 1 then begin
        Result := Result + 'Order entered on ' + FMDateTimeStr(piece(s, '^', 3)) + ' by ' + piece(s, '^', 11) + '  (' +
          piece(s, '^', 19) + ')' + #13#10 + '<' + FMDateTimeStr(piece(s, '^', 4)) + ' - ' +
          FMDateTimeStr(piece(s, '^', 5)) + '>' + #13#10;
      end else if pos('>>', s) = 2 then Result := Result + '<' + piece(s, 't>>', 2) + '>' + #13#10#13#10
      else if pos('t', s) = 1 then Result := Result + '<' + copy(s, 2, Length(s)) + '>' + #13#10#13#10
      else if pos('\', s) = 1 then Result := Result + #13#10#13#10 + copy(s, 2, Length(s)) + #13#10;
    end;
    sl.Free;
  end;

begin
  lblRxTemp.Caption := getDictionaryUnits('cdsSummary', 'Temp', 'C');
  try
    Verify;
    dbcbRxDialyser.Update;
    dbcbAC_Type.Update;
    ReportStatus;
    pnlPhysicianOrders.Visible := Preferences.bValue(onShowPhysicianOrders);
    if pnlPhysicianOrders.Visible then begin
      rePhysicianOrders.Text := convert(Engine.getPatientPhysicianOrders);
      PaintSyntax(rePhysicianOrders, False);
    end;
    tvLabs.Items.Clear;
    tvLabs.Items.Add(nil, 'Select a period to get LAB data');
    // setup;
    setReadOnly(fReadOnly);
    setActionStatus;
    FrameMDK_Comments.ActivateFrame;
    Resize;
  except
    rePhysicianOrders.Text := '';
  end;
end;

function TfrmRxLab.Verify: string;
begin
  Result := '';
  if dbmLabNotes.Text <> '' then Result := 'Old Comments field is not empty  ';
end;

procedure TfrmRxLab.setActionStatus;
begin
  FrameMDK_Comments.setActionStatus;
  Invalidate;
end;

procedure TfrmRxLab.acMoveCommentsExecute(Sender: TObject);
begin
  if dbmLabNotes.Modified then
    try
      dmData.cdsSummary.Post;
    except
    end;
  if dbmLabNotes.Text <> '' then FrameMDK_Comments.moveComment(dbmLabNotes.DataField, '')
  else MessageDLG('No comments available for update', mtInformation, [mbOK], 0);
end;

procedure TfrmRxLab.acShowOldCommentsExecute(Sender: TObject);
begin
  pnlRxNotes.Visible := not pnlRxNotes.Visible;
end;

function TfrmRxLab.getMainMenu: TMainMenu;
begin
  Result := mnMain;
end;

procedure TfrmRxLab.setMainMenuVisible(aValue: Boolean);
begin
  RxMainMenu.Visible := aValue;
end;

end.
