unit uROR_Resources;

interface

uses
  Controls, Forms, Graphics, ImgList, SysUtils;

resourcestring
  RscAddHint = 'Add|Add selected item(s) to the list';
  RscAddAllHint = 'Add All|Add all items to the list';
  RscBreakLink = 'Break the Clinical Link';
  RscRemoveHint = 'Remove|Remove selected item(s) from the list';
  RscRemoveAllHint = 'Remove All|Clear the list';
  RscUseAppData = 'Rejoin and Use Application Data';
  RscUseGlobalData = 'Rejoin and Use Global Data';
  RSC0001 = 'CCOW Contextor';
  RSC0002 = 'Update the clinical context with the application''s data?';
  RSC0003 = 'Contextor has not been run and the application has not joined a context.';
  RSC0004 = 'Contextor has been run and the application is participating in a context.';
  RSC0005 = 'Contextor has been run but the application is not participating in a context.';
  RSC0006 = 'Cannot determine the contextor state.';
  RSC0010 = 'Search pattern should contain at least %d character(s).';
  RSC0011 = 'Invalid search pattern.';
  RSC0020 = 'Field value cannot be converted to Date/Time.';

var
  BmAdd: TBitmap       = nil;
  BmAddAll: TBitmap    = nil;
  BmRemove: TBitmap    = nil;
  BmRemoveAll: TBitmap = nil;
  BmSearch: TBitmap    = nil;

procedure LoadCCREditSearchResources;
procedure LoadCCRSelectorResources;

implementation

{$R *.res}

procedure LoadCCREditSearchResources;
begin
  if Assigned(BmSearch) then Exit;
  BmSearch := TBitmap.Create;
  BmSearch.LoadFromResourceName(HInstance, 'BTN_SEARCH');
end;

procedure LoadCCRSelectorResources;
begin
  if Assigned(BmAdd) then Exit;
  BmAdd := TBitmap.Create;
  BmAddAll := TBitmap.Create;
  BmRemove := TBitmap.Create;
  BmRemoveAll := TBitmap.Create;
  BmAdd.LoadFromResourceName(HInstance, 'BTN_ADD');
  BmAddAll.LoadFromResourceName(HInstance, 'BTN_ADDALL');
  BmRemove.LoadFromResourceName(HInstance, 'BTN_REMOVE');
  BmRemoveAll.LoadFromResourceName(HInstance, 'BTN_REMOVEALL');
end;

initialization

finalization

FreeAndNil(BmAdd);
FreeAndNil(BmAddAll);
FreeAndNil(BmRemove);
FreeAndNil(BmRemoveAll);

end.
