unit uGMV_ItemList;

interface
uses
  uMDK_TreeInterfaces
  , Controls
  , Forms;

type
  TGMV_ItemList = class(TInterfacedObject, I_Viewable)
    private
      fViewForm: TForm;
      fFileName: String;
      procedure setFileName(aName:String);
    public
      property FileName: String read fFileName write setFileName;
      property ViewForm: TForm read fViewForm write fViewForm;

      function _AddRef:Integer;stdcall;
      function _Release:Integer;stdcall;

      function ShowViewForm:Integer;stdcall;
      function HideViewForm:Integer;stdcall;
      function AllowChange:Boolean;stdcall;
      function getViewForm:TForm;stdcall;
      procedure assignViewForm(aForm:TForm);stdcall;
      procedure assignParenForm(aParent:TWinControl);stdcall;
  end;

function New_TGMV_ItemList(aFileName:String): TGMV_ItemList;

implementation

uses
  SysUtils, fGMV_PictureViewer;


function New_TGMV_ItemList(aFileName:String): TGMV_ItemList;
begin
  Result := nil;
end;

////////////////////////////////////////////////////////////////////////////////

function TGMV_ItemList._AddRef:Integer;
begin
  Result := -1;
end;

function TGMV_ItemList._Release:Integer;
begin
  Result := -1;
end;

function TGMV_ItemList.HideViewForm:Integer;
begin
  if Assigned(fViewForm) then
    try
      fViewForm.Hide;
    except
    end;
  Result := 0;
end;

function TGMV_ItemList.AllowChange:Boolean;
begin
  Result := True;
end;

function TGMV_ItemList.getViewForm:TForm;
begin
  Result := fViewForm;
end;

procedure TGMV_ItemList.assignViewForm(aForm:TForm);
begin
  fViewForm := aForm;
end;

procedure TGMV_ItemList.assignParenForm(aParent:TWinControl);
begin
  fViewForm.Parent := aParent;
  fViewForm.BorderStyle := bsNone;
  fViewForm.Align := alClient;
end;

procedure TGMV_ItemList.setFileName(aName:String);
begin
  fFileName := aName;
end;

function TGMV_ItemList.ShowViewForm:Integer;
begin
  if Assigned(fViewForm) then
    begin
      fViewForm.Show;
    end;

  Result := 0;
end;

end.
