unit uMDK_GridUtils;

interface

uses
  DB, DBGrids, DBClient;

function getGridText(aGrid: TDBGrid;aDelim: String;IncludeHeader:Boolean=True): String;

implementation

function getTableHeader(aGrid: TDBGrid;aDelim: String): String;
var
 i: Integer;
  cds: TClientDataSet;
  ds: TDataSource;
  fd: TFieldDefs;
begin
  Result := '';
  ds := aGrid.DataSource;
  cds := TClientDataSet(ds.DataSet);
  fd := cds.FieldDefs;
  for i := 0 to fd.Count - 1 do
    Result := Result + fd.Items[i].DisplayName + aDelim;
end;

function getTableRecord(aGrid: TDBGrid;aDelim: String): String;
var
 i: Integer;
  cds: TClientDataSet;
  ds: TDataSource;
  fld: TFields;
begin
  Result := '';
  ds := aGrid.DataSource;
  cds := TClientDataSet(ds.DataSet);
  fld := cds.Fields;
  for i := 0 to fld.Count - 1 do
    begin
      Result := Result + fld[i].AsString + aDelim;
    end;
end;

function getGridText(aGrid: TDBGrid;aDelim: String;IncludeHeader:Boolean=True): String;
var
  cds: TClientDataSet;
  ds: TDataSource;

begin
  Result := '';
  ds := aGrid.DataSource;
  cds := TClientDataSet(ds.DataSet);
  if IncludeHeader then
    Result := Result + getTableHeader(aGrid,aDelim) + #13#10;

  cds.First;
  while not cds.Eof do
    begin
      Result := Result + getTableRecord(aGrid,aDelim) + aDelim + #13#10;
      cds.Next;
    end;
end;

end.
