unit uMDK_UU;

interface

function DecodeUUString(aSource: string): string;
function UUEncode(aSource: string): string;

const
  UUE_HEADER = '-- Begin UUEncoded Data --';
  UUE_FOOTER = '--- End UUEncoded Data ---';

implementation

uses
  Classes
  , SysUtils
  , IdCoderUUE
  ;

function DecodeUUString(aSource: string): string;
{Scan the fRPCBrokerResults for and encoded data and set it back to the way it was sent}
var
  SL: TStringList;
  i: integer;
{$IFDEF D10}
  s, ss: String;
{$ELSE}
  aStringStream: TStringStream;
{$ENDIF}
begin
  // if the data is encoded both header and footer should be present
  //                                             zzzzzzandria 060721
  if (pos(UUE_HEADER, aSource) = 0)
    or (pos(UUE_FOOTER, aSource) = 0) then
    Exit;

  SL := TStringList.Create;
  SL.Text := aSource;

  for i := SL.Count - 1 downto 0 do
    if pos(UUE_HEADER, Trim(SL[i])) = 1 then
      begin
{$IFDEF D10}
        s := '';
{$ELSE}
        aStringStream := TStringStream.Create('');
{$ENDIF}
        with TIdDecoderUUE.Create(nil) do
          try
{$IFNDEF D10}
            aStringStream.Position := 0;
{$ENDIF}
            //            while pos(UUE_FOOTER,trim(SL[i + 1])) <> 1 do
            while SL[i + 1] <> UUE_FOOTER do
              begin
{$IFDEF D10}
                ss := trim(SL[i + 1]);
                ss := DecodeString(ss);
                s := s + ss;
{$ELSE}
                DecodeToStream(trim(SL[i + 1]), aStringStream);
{$ENDIF}
                SL.Delete(i + 1);
              end;
            SL.Delete(i + 1);
{$IFDEF D10}
            SL[i] := s;
{$ELSE}
            aStringStream.Seek(0, soFromBeginning);
            SL[i] := aStringStream.DataString; {Replace header with original text}
{$ENDIF}
          finally
{$IFNDEF D10}
            FreeAndNil(aStringStream);
{$ENDIF}
            Free;
          end;
      end;
  Result := SL.Text;
  SL.Free;
end;
(*
procedure TDBConnection.DecodeResults;
{Scan the fRPCBrokerResults for and encoded data and set it back to the way it was sent}
var
  i: integer;
  aStringStream: TStringStream;
begin
  // if the data is encoded both header and footer should be present
  //                                             zzzzzzandria 060721
  if (pos(UUE_HEADER,fRPCBrokerResults.Text) = 0)
    or (pos(UUE_FOOTER,fRPCBrokerResults.Text) = 0)  then
    Exit;

  for i := fRPCBrokerResults.Count - 1 downto 0 do
    if fRPCBrokerResults[i] = UUE_HEADER then
      begin
        aStringStream := TStringStream.Create('');
        with TIdDecoderUUE.Create(nil) do
          try
            aStringStream.Position := 0;
            while fRPCBrokerResults[i + 1] <> UUE_FOOTER do
              begin
                DecodeToStream(fRPCBrokerResults[i + 1], aStringStream);
                fRPCBrokerResults.Delete(i + 1);
              end;
            fRPCBrokerResults.Delete(i + 1);
            aStringStream.Seek(0, soFromBeginning);
            fRPCBrokerResults[i] := aStringStream.DataString; {Replace header with original text}
          finally
            FreeAndNil(aStringStream);
            Free;
          end;
      end;
end;
*)

function UUEncode(aSource: string): string;
var
  aStrList: TStringList;
  aStrStream: TStringStream;
begin
  aStrStream := TStringStream.Create(aSource);
  aStrList := TStringList.Create;

  with TIdEncoderUUE.Create(nil) do
    try
      aStrList.Add(UUE_HEADER);
      aStrStream.Position := 0;
      while aStrStream.Position < aStrStream.Size do
        aStrList.Add(Encode(aStrStream, 45));
      aStrList.Add(UUE_FOOTER);
    finally
      FreeAndNil(aStrStream);
      Free;
    end;
  Result := aStrList.Text;
  aStrList.Free;
end;

end.

